/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Substitute the type names.  */
#define YYSTYPE         FRONTEND_VERILOG_YYSTYPE
#define YYLTYPE         FRONTEND_VERILOG_YYLTYPE
/* Substitute the variable and function names.  */
#define yyparse         frontend_verilog_yyparse
#define yylex           frontend_verilog_yylex
#define yyerror         frontend_verilog_yyerror
#define yydebug         frontend_verilog_yydebug
#define yynerrs         frontend_verilog_yynerrs

/* First part of user prologue.  */
#line 38 "frontends/verilog/verilog_parser.y"

#include <list>
#include <stack>
#include <string.h>
#include "frontends/verilog/verilog_frontend.h"
#include "frontends/verilog/verilog_parser.tab.hh"
#include "kernel/log.h"

#define YYLEX_PARAM &yylval, &yylloc

USING_YOSYS_NAMESPACE
using namespace AST;
using namespace VERILOG_FRONTEND;

YOSYS_NAMESPACE_BEGIN
namespace VERILOG_FRONTEND {
	int port_counter;
	dict<std::string, int> port_stubs;
	dict<IdString, AstNode*> *attr_list, default_attr_list;
	std::stack<dict<IdString, AstNode*> *> attr_list_stack;
	dict<IdString, AstNode*> *albuf;
	std::vector<UserTypeMap> user_type_stack;
	dict<std::string, AstNode*> pkg_user_types;
	std::vector<AstNode*> ast_stack;
	struct AstNode *astbuf1, *astbuf2, *astbuf3;
	struct AstNode *current_function_or_task;
	struct AstNode *current_ast, *current_ast_mod;
	int current_function_or_task_port_id;
	std::vector<char> case_type_stack;
	bool do_not_require_port_stubs;
	bool default_nettype_wire;
	bool sv_mode, formal_mode, lib_mode, specify_mode;
	bool noassert_mode, noassume_mode, norestrict_mode;
	bool assume_asserts_mode, assert_assumes_mode;
	bool current_wire_rand, current_wire_const;
	bool current_modport_input, current_modport_output;
	std::istream *lexin;
}
YOSYS_NAMESPACE_END

#define SET_AST_NODE_LOC(WHICH, BEGIN, END) \
    do { (WHICH)->location.first_line = (BEGIN).first_line; \
    (WHICH)->location.first_column = (BEGIN).first_column; \
    (WHICH)->location.last_line = (END).last_line; \
    (WHICH)->location.last_column = (END).last_column; } while(0)

#define SET_RULE_LOC(LHS, BEGIN, END) \
    do { (LHS).first_line = (BEGIN).first_line; \
    (LHS).first_column = (BEGIN).first_column; \
    (LHS).last_line = (END).last_line; \
    (LHS).last_column = (END).last_column; } while(0)

int frontend_verilog_yylex(YYSTYPE *yylval_param, YYLTYPE *yyloc_param);

static void append_attr(AstNode *ast, dict<IdString, AstNode*> *al)
{
	for (auto &it : *al) {
		if (ast->attributes.count(it.first) > 0)
			delete ast->attributes[it.first];
		ast->attributes[it.first] = it.second;
	}
	delete al;
}

static void append_attr_clone(AstNode *ast, dict<IdString, AstNode*> *al)
{
	for (auto &it : *al) {
		if (ast->attributes.count(it.first) > 0)
			delete ast->attributes[it.first];
		ast->attributes[it.first] = it.second->clone();
	}
}

static void free_attr(dict<IdString, AstNode*> *al)
{
	for (auto &it : *al)
		delete it.second;
	delete al;
}

struct specify_target {
	char polarity_op;
	AstNode *dst, *dat;
};

struct specify_triple {
	AstNode *t_min, *t_avg, *t_max;
};

struct specify_rise_fall {
	specify_triple rise;
	specify_triple fall;
};

static void addWiretypeNode(std::string *name, AstNode *node)
{
	log_assert(node);
	node->is_custom_type = true;
	node->children.push_back(new AstNode(AST_WIRETYPE));
	node->children.back()->str = *name;
	delete name;
}

static void addTypedefNode(std::string *name, AstNode *node)
{
	log_assert(node);
	auto *tnode = new AstNode(AST_TYPEDEF, node);
	tnode->str = *name;
	auto &user_types = user_type_stack.back();
	user_types[*name] = tnode;
	if (current_ast_mod && current_ast_mod->type == AST_PACKAGE) {
		// typedef inside a package so we need the qualified name
		auto qname = current_ast_mod->str + "::" + (*name).substr(1);
		pkg_user_types[qname] = tnode;
	}
	delete name;
	ast_stack.back()->children.push_back(tnode);
}

static void enterTypeScope()
{
	user_type_stack.push_back(UserTypeMap());
}

static void exitTypeScope()
{
	user_type_stack.pop_back();
}

static bool isInLocalScope(const std::string *name)
{
	// tests if a name was declared in the current block scope
	auto &user_types = user_type_stack.back();
	return (user_types.count(*name) > 0);
}

static AstNode *getTypeDefinitionNode(std::string type_name)
{
	// check current scope then outer scopes for a name
	for (auto it = user_type_stack.rbegin(); it != user_type_stack.rend(); ++it) {
		if (it->count(type_name) > 0) {
			// return the definition nodes from the typedef statement
			auto typedef_node = (*it)[type_name];
			log_assert(typedef_node->type == AST_TYPEDEF);
			return typedef_node->children[0];
		}
	}

	// The lexer recognized the name as a TOK_USER_TYPE, but now we can't find it anymore?
	log_error("typedef for user type `%s' not found", type_name.c_str());
}

static AstNode *copyTypeDefinition(std::string type_name)
{
	// return a copy of the template from a typedef definition
	auto typedef_node = getTypeDefinitionNode(type_name);
	return typedef_node->clone();
}

static AstNode *makeRange(int msb = 31, int lsb = 0, bool isSigned = true)
{
	auto range = new AstNode(AST_RANGE);
	range->children.push_back(AstNode::mkconst_int(msb, true));
	range->children.push_back(AstNode::mkconst_int(lsb, true));
	range->is_signed = isSigned;
	return range;
}

static void addRange(AstNode *parent, int msb = 31, int lsb = 0, bool isSigned = true)
{
	auto range = makeRange(msb, lsb, isSigned);
	parent->children.push_back(range);
}

static AstNode *checkRange(AstNode *type_node, AstNode *range_node)
{
	if (type_node->range_left >= 0 && type_node->range_right >= 0) {
		// type already restricts the range
		if (range_node) {
			frontend_verilog_yyerror("integer/genvar types cannot have packed dimensions.");
		}
		else {
			range_node = makeRange(type_node->range_left, type_node->range_right, false);
		}
	}
	if (range_node && range_node->children.size() != 2) {
		frontend_verilog_yyerror("wire/reg/logic packed dimension must be of the form: [<expr>:<expr>], [<expr>+:<expr>], or [<expr>-:<expr>]");
	}
	return range_node;
}

static void rewriteRange(AstNode *rangeNode)
{
	if (rangeNode->type == AST_RANGE && rangeNode->children.size() == 1) {
		// SV array size [n], rewrite as [n-1:0]
		rangeNode->children[0] = new AstNode(AST_SUB, rangeNode->children[0], AstNode::mkconst_int(1, true));
		rangeNode->children.push_back(AstNode::mkconst_int(0, false));
	}
}

static void rewriteAsMemoryNode(AstNode *node, AstNode *rangeNode)
{
	node->type = AST_MEMORY;
	if (rangeNode->type == AST_MULTIRANGE) {
		for (auto *itr : rangeNode->children)
			rewriteRange(itr);
	} else
		rewriteRange(rangeNode);
	node->children.push_back(rangeNode);
}

static void checkLabelsMatch(const char *element, const std::string *before, const std::string *after)
{
	if (!before && after)
		frontend_verilog_yyerror("%s missing where end label (%s) was given.",
			element, after->c_str() + 1);
	if (before && after && *before != *after)
		frontend_verilog_yyerror("%s (%s) and end label (%s) don't match.",
			element, before->c_str() + 1, after->c_str() + 1);
}

// This transforms a loop like
//   for (genvar i = 0; i < 10; i++) begin : blk
// to
//   genvar _i;
//   for (_i = 0; _i < 10; _i++) begin : blk
//     localparam i = _i;
// where `_i` is actually some auto-generated name.
static void rewriteGenForDeclInit(AstNode *loop)
{
	// check if this generate for loop contains an inline declaration
	log_assert(loop->type == AST_GENFOR);
	AstNode *decl = loop->children[0];
	if (decl->type == AST_ASSIGN_EQ)
		return;
	log_assert(decl->type == AST_GENVAR);
	log_assert(loop->children.size() == 5);

	// identify each component of the loop
	AstNode *init = loop->children[1];
	AstNode *cond = loop->children[2];
	AstNode *incr = loop->children[3];
	AstNode *body = loop->children[4];
	log_assert(init->type == AST_ASSIGN_EQ);
	log_assert(incr->type == AST_ASSIGN_EQ);
	log_assert(body->type == AST_GENBLOCK);

	// create a unique name for the genvar
	std::string old_str = decl->str;
	std::string new_str = stringf("$genfordecl$%d$%s", autoidx++, old_str.c_str());

	// rename and move the genvar declaration to the containing description
	decl->str = new_str;
	loop->children.erase(loop->children.begin());
	log_assert(current_ast_mod != nullptr);
	current_ast_mod->children.push_back(decl);

	// create a new localparam with old name so that the items in the loop
	// can simply use the old name and shadow it as necessary
	AstNode *indirect = new AstNode(AST_LOCALPARAM);
	indirect->str = old_str;
	AstNode *ident = new AstNode(AST_IDENTIFIER);
	ident->str = new_str;
	indirect->children.push_back(ident);

	body->children.insert(body->children.begin(), indirect);

	// only perform the renaming for the initialization, guard, and
	// incrementation to enable proper shadowing of the synthetic localparam
	std::function<void(AstNode*)> substitute = [&](AstNode *node) {
		if (node->type == AST_IDENTIFIER && node->str == old_str)
			node->str = new_str;
		for (AstNode *child : node->children)
			substitute(child);
	};
	substitute(init);
	substitute(cond);
	substitute(incr);
}


#line 360 "frontends/verilog/verilog_parser.tab.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "verilog_parser.tab.hh"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TOK_STRING = 3,                 /* TOK_STRING  */
  YYSYMBOL_TOK_ID = 4,                     /* TOK_ID  */
  YYSYMBOL_TOK_CONSTVAL = 5,               /* TOK_CONSTVAL  */
  YYSYMBOL_TOK_REALVAL = 6,                /* TOK_REALVAL  */
  YYSYMBOL_TOK_PRIMITIVE = 7,              /* TOK_PRIMITIVE  */
  YYSYMBOL_TOK_SVA_LABEL = 8,              /* TOK_SVA_LABEL  */
  YYSYMBOL_TOK_SPECIFY_OPER = 9,           /* TOK_SPECIFY_OPER  */
  YYSYMBOL_TOK_MSG_TASKS = 10,             /* TOK_MSG_TASKS  */
  YYSYMBOL_TOK_BASE = 11,                  /* TOK_BASE  */
  YYSYMBOL_TOK_BASED_CONSTVAL = 12,        /* TOK_BASED_CONSTVAL  */
  YYSYMBOL_TOK_UNBASED_UNSIZED_CONSTVAL = 13, /* TOK_UNBASED_UNSIZED_CONSTVAL  */
  YYSYMBOL_TOK_USER_TYPE = 14,             /* TOK_USER_TYPE  */
  YYSYMBOL_TOK_PKG_USER_TYPE = 15,         /* TOK_PKG_USER_TYPE  */
  YYSYMBOL_TOK_ASSERT = 16,                /* TOK_ASSERT  */
  YYSYMBOL_TOK_ASSUME = 17,                /* TOK_ASSUME  */
  YYSYMBOL_TOK_RESTRICT = 18,              /* TOK_RESTRICT  */
  YYSYMBOL_TOK_COVER = 19,                 /* TOK_COVER  */
  YYSYMBOL_TOK_FINAL = 20,                 /* TOK_FINAL  */
  YYSYMBOL_ATTR_BEGIN = 21,                /* ATTR_BEGIN  */
  YYSYMBOL_ATTR_END = 22,                  /* ATTR_END  */
  YYSYMBOL_DEFATTR_BEGIN = 23,             /* DEFATTR_BEGIN  */
  YYSYMBOL_DEFATTR_END = 24,               /* DEFATTR_END  */
  YYSYMBOL_TOK_MODULE = 25,                /* TOK_MODULE  */
  YYSYMBOL_TOK_ENDMODULE = 26,             /* TOK_ENDMODULE  */
  YYSYMBOL_TOK_PARAMETER = 27,             /* TOK_PARAMETER  */
  YYSYMBOL_TOK_LOCALPARAM = 28,            /* TOK_LOCALPARAM  */
  YYSYMBOL_TOK_DEFPARAM = 29,              /* TOK_DEFPARAM  */
  YYSYMBOL_TOK_PACKAGE = 30,               /* TOK_PACKAGE  */
  YYSYMBOL_TOK_ENDPACKAGE = 31,            /* TOK_ENDPACKAGE  */
  YYSYMBOL_TOK_PACKAGESEP = 32,            /* TOK_PACKAGESEP  */
  YYSYMBOL_TOK_INTERFACE = 33,             /* TOK_INTERFACE  */
  YYSYMBOL_TOK_ENDINTERFACE = 34,          /* TOK_ENDINTERFACE  */
  YYSYMBOL_TOK_MODPORT = 35,               /* TOK_MODPORT  */
  YYSYMBOL_TOK_VAR = 36,                   /* TOK_VAR  */
  YYSYMBOL_TOK_WILDCARD_CONNECT = 37,      /* TOK_WILDCARD_CONNECT  */
  YYSYMBOL_TOK_INPUT = 38,                 /* TOK_INPUT  */
  YYSYMBOL_TOK_OUTPUT = 39,                /* TOK_OUTPUT  */
  YYSYMBOL_TOK_INOUT = 40,                 /* TOK_INOUT  */
  YYSYMBOL_TOK_WIRE = 41,                  /* TOK_WIRE  */
  YYSYMBOL_TOK_WAND = 42,                  /* TOK_WAND  */
  YYSYMBOL_TOK_WOR = 43,                   /* TOK_WOR  */
  YYSYMBOL_TOK_REG = 44,                   /* TOK_REG  */
  YYSYMBOL_TOK_LOGIC = 45,                 /* TOK_LOGIC  */
  YYSYMBOL_TOK_INTEGER = 46,               /* TOK_INTEGER  */
  YYSYMBOL_TOK_SIGNED = 47,                /* TOK_SIGNED  */
  YYSYMBOL_TOK_ASSIGN = 48,                /* TOK_ASSIGN  */
  YYSYMBOL_TOK_ALWAYS = 49,                /* TOK_ALWAYS  */
  YYSYMBOL_TOK_INITIAL = 50,               /* TOK_INITIAL  */
  YYSYMBOL_TOK_ALWAYS_FF = 51,             /* TOK_ALWAYS_FF  */
  YYSYMBOL_TOK_ALWAYS_COMB = 52,           /* TOK_ALWAYS_COMB  */
  YYSYMBOL_TOK_ALWAYS_LATCH = 53,          /* TOK_ALWAYS_LATCH  */
  YYSYMBOL_TOK_BEGIN = 54,                 /* TOK_BEGIN  */
  YYSYMBOL_TOK_END = 55,                   /* TOK_END  */
  YYSYMBOL_TOK_IF = 56,                    /* TOK_IF  */
  YYSYMBOL_TOK_ELSE = 57,                  /* TOK_ELSE  */
  YYSYMBOL_TOK_FOR = 58,                   /* TOK_FOR  */
  YYSYMBOL_TOK_WHILE = 59,                 /* TOK_WHILE  */
  YYSYMBOL_TOK_REPEAT = 60,                /* TOK_REPEAT  */
  YYSYMBOL_TOK_DPI_FUNCTION = 61,          /* TOK_DPI_FUNCTION  */
  YYSYMBOL_TOK_POSEDGE = 62,               /* TOK_POSEDGE  */
  YYSYMBOL_TOK_NEGEDGE = 63,               /* TOK_NEGEDGE  */
  YYSYMBOL_TOK_OR = 64,                    /* TOK_OR  */
  YYSYMBOL_TOK_AUTOMATIC = 65,             /* TOK_AUTOMATIC  */
  YYSYMBOL_TOK_CASE = 66,                  /* TOK_CASE  */
  YYSYMBOL_TOK_CASEX = 67,                 /* TOK_CASEX  */
  YYSYMBOL_TOK_CASEZ = 68,                 /* TOK_CASEZ  */
  YYSYMBOL_TOK_ENDCASE = 69,               /* TOK_ENDCASE  */
  YYSYMBOL_TOK_DEFAULT = 70,               /* TOK_DEFAULT  */
  YYSYMBOL_TOK_FUNCTION = 71,              /* TOK_FUNCTION  */
  YYSYMBOL_TOK_ENDFUNCTION = 72,           /* TOK_ENDFUNCTION  */
  YYSYMBOL_TOK_TASK = 73,                  /* TOK_TASK  */
  YYSYMBOL_TOK_ENDTASK = 74,               /* TOK_ENDTASK  */
  YYSYMBOL_TOK_SPECIFY = 75,               /* TOK_SPECIFY  */
  YYSYMBOL_TOK_IGNORED_SPECIFY = 76,       /* TOK_IGNORED_SPECIFY  */
  YYSYMBOL_TOK_ENDSPECIFY = 77,            /* TOK_ENDSPECIFY  */
  YYSYMBOL_TOK_SPECPARAM = 78,             /* TOK_SPECPARAM  */
  YYSYMBOL_TOK_SPECIFY_AND = 79,           /* TOK_SPECIFY_AND  */
  YYSYMBOL_TOK_IGNORED_SPECIFY_AND = 80,   /* TOK_IGNORED_SPECIFY_AND  */
  YYSYMBOL_TOK_GENERATE = 81,              /* TOK_GENERATE  */
  YYSYMBOL_TOK_ENDGENERATE = 82,           /* TOK_ENDGENERATE  */
  YYSYMBOL_TOK_GENVAR = 83,                /* TOK_GENVAR  */
  YYSYMBOL_TOK_REAL = 84,                  /* TOK_REAL  */
  YYSYMBOL_TOK_SYNOPSYS_FULL_CASE = 85,    /* TOK_SYNOPSYS_FULL_CASE  */
  YYSYMBOL_TOK_SYNOPSYS_PARALLEL_CASE = 86, /* TOK_SYNOPSYS_PARALLEL_CASE  */
  YYSYMBOL_TOK_SUPPLY0 = 87,               /* TOK_SUPPLY0  */
  YYSYMBOL_TOK_SUPPLY1 = 88,               /* TOK_SUPPLY1  */
  YYSYMBOL_TOK_TO_SIGNED = 89,             /* TOK_TO_SIGNED  */
  YYSYMBOL_TOK_TO_UNSIGNED = 90,           /* TOK_TO_UNSIGNED  */
  YYSYMBOL_TOK_POS_INDEXED = 91,           /* TOK_POS_INDEXED  */
  YYSYMBOL_TOK_NEG_INDEXED = 92,           /* TOK_NEG_INDEXED  */
  YYSYMBOL_TOK_PROPERTY = 93,              /* TOK_PROPERTY  */
  YYSYMBOL_TOK_ENUM = 94,                  /* TOK_ENUM  */
  YYSYMBOL_TOK_TYPEDEF = 95,               /* TOK_TYPEDEF  */
  YYSYMBOL_TOK_RAND = 96,                  /* TOK_RAND  */
  YYSYMBOL_TOK_CONST = 97,                 /* TOK_CONST  */
  YYSYMBOL_TOK_CHECKER = 98,               /* TOK_CHECKER  */
  YYSYMBOL_TOK_ENDCHECKER = 99,            /* TOK_ENDCHECKER  */
  YYSYMBOL_TOK_EVENTUALLY = 100,           /* TOK_EVENTUALLY  */
  YYSYMBOL_TOK_INCREMENT = 101,            /* TOK_INCREMENT  */
  YYSYMBOL_TOK_DECREMENT = 102,            /* TOK_DECREMENT  */
  YYSYMBOL_TOK_UNIQUE = 103,               /* TOK_UNIQUE  */
  YYSYMBOL_TOK_UNIQUE0 = 104,              /* TOK_UNIQUE0  */
  YYSYMBOL_TOK_PRIORITY = 105,             /* TOK_PRIORITY  */
  YYSYMBOL_TOK_STRUCT = 106,               /* TOK_STRUCT  */
  YYSYMBOL_TOK_PACKED = 107,               /* TOK_PACKED  */
  YYSYMBOL_TOK_UNSIGNED = 108,             /* TOK_UNSIGNED  */
  YYSYMBOL_TOK_INT = 109,                  /* TOK_INT  */
  YYSYMBOL_TOK_BYTE = 110,                 /* TOK_BYTE  */
  YYSYMBOL_TOK_SHORTINT = 111,             /* TOK_SHORTINT  */
  YYSYMBOL_TOK_LONGINT = 112,              /* TOK_LONGINT  */
  YYSYMBOL_TOK_UNION = 113,                /* TOK_UNION  */
  YYSYMBOL_TOK_BIT_OR_ASSIGN = 114,        /* TOK_BIT_OR_ASSIGN  */
  YYSYMBOL_TOK_BIT_AND_ASSIGN = 115,       /* TOK_BIT_AND_ASSIGN  */
  YYSYMBOL_TOK_BIT_XOR_ASSIGN = 116,       /* TOK_BIT_XOR_ASSIGN  */
  YYSYMBOL_TOK_ADD_ASSIGN = 117,           /* TOK_ADD_ASSIGN  */
  YYSYMBOL_TOK_SUB_ASSIGN = 118,           /* TOK_SUB_ASSIGN  */
  YYSYMBOL_TOK_DIV_ASSIGN = 119,           /* TOK_DIV_ASSIGN  */
  YYSYMBOL_TOK_MOD_ASSIGN = 120,           /* TOK_MOD_ASSIGN  */
  YYSYMBOL_TOK_MUL_ASSIGN = 121,           /* TOK_MUL_ASSIGN  */
  YYSYMBOL_TOK_SHL_ASSIGN = 122,           /* TOK_SHL_ASSIGN  */
  YYSYMBOL_TOK_SHR_ASSIGN = 123,           /* TOK_SHR_ASSIGN  */
  YYSYMBOL_TOK_SSHL_ASSIGN = 124,          /* TOK_SSHL_ASSIGN  */
  YYSYMBOL_TOK_SSHR_ASSIGN = 125,          /* TOK_SSHR_ASSIGN  */
  YYSYMBOL_TOK_BIND = 126,                 /* TOK_BIND  */
  YYSYMBOL_TOK_TIME_SCALE = 127,           /* TOK_TIME_SCALE  */
  YYSYMBOL_OP_LOR = 128,                   /* OP_LOR  */
  YYSYMBOL_OP_LAND = 129,                  /* OP_LAND  */
  YYSYMBOL_130_ = 130,                     /* '|'  */
  YYSYMBOL_OP_NOR = 131,                   /* OP_NOR  */
  YYSYMBOL_132_ = 132,                     /* '^'  */
  YYSYMBOL_OP_XNOR = 133,                  /* OP_XNOR  */
  YYSYMBOL_134_ = 134,                     /* '&'  */
  YYSYMBOL_OP_NAND = 135,                  /* OP_NAND  */
  YYSYMBOL_OP_EQ = 136,                    /* OP_EQ  */
  YYSYMBOL_OP_NE = 137,                    /* OP_NE  */
  YYSYMBOL_OP_EQX = 138,                   /* OP_EQX  */
  YYSYMBOL_OP_NEX = 139,                   /* OP_NEX  */
  YYSYMBOL_140_ = 140,                     /* '<'  */
  YYSYMBOL_OP_LE = 141,                    /* OP_LE  */
  YYSYMBOL_OP_GE = 142,                    /* OP_GE  */
  YYSYMBOL_143_ = 143,                     /* '>'  */
  YYSYMBOL_OP_SHL = 144,                   /* OP_SHL  */
  YYSYMBOL_OP_SHR = 145,                   /* OP_SHR  */
  YYSYMBOL_OP_SSHL = 146,                  /* OP_SSHL  */
  YYSYMBOL_OP_SSHR = 147,                  /* OP_SSHR  */
  YYSYMBOL_148_ = 148,                     /* '+'  */
  YYSYMBOL_149_ = 149,                     /* '-'  */
  YYSYMBOL_150_ = 150,                     /* '*'  */
  YYSYMBOL_151_ = 151,                     /* '/'  */
  YYSYMBOL_152_ = 152,                     /* '%'  */
  YYSYMBOL_OP_POW = 153,                   /* OP_POW  */
  YYSYMBOL_OP_CAST = 154,                  /* OP_CAST  */
  YYSYMBOL_UNARY_OPS = 155,                /* UNARY_OPS  */
  YYSYMBOL_FAKE_THEN = 156,                /* FAKE_THEN  */
  YYSYMBOL_157_ = 157,                     /* ','  */
  YYSYMBOL_158_ = 158,                     /* '='  */
  YYSYMBOL_159_ = 159,                     /* '.'  */
  YYSYMBOL_160_ = 160,                     /* '('  */
  YYSYMBOL_161_ = 161,                     /* ')'  */
  YYSYMBOL_162_ = 162,                     /* ';'  */
  YYSYMBOL_163_ = 163,                     /* '#'  */
  YYSYMBOL_164_ = 164,                     /* ':'  */
  YYSYMBOL_165_ = 165,                     /* '['  */
  YYSYMBOL_166_ = 166,                     /* ']'  */
  YYSYMBOL_167_ = 167,                     /* '{'  */
  YYSYMBOL_168_ = 168,                     /* '}'  */
  YYSYMBOL_169_ = 169,                     /* '@'  */
  YYSYMBOL_170_ = 170,                     /* '?'  */
  YYSYMBOL_171_ = 171,                     /* '~'  */
  YYSYMBOL_172_ = 172,                     /* '!'  */
  YYSYMBOL_YYACCEPT = 173,                 /* $accept  */
  YYSYMBOL_input = 174,                    /* input  */
  YYSYMBOL_175_1 = 175,                    /* $@1  */
  YYSYMBOL_design = 176,                   /* design  */
  YYSYMBOL_attr = 177,                     /* attr  */
  YYSYMBOL_178_2 = 178,                    /* $@2  */
  YYSYMBOL_attr_opt = 179,                 /* attr_opt  */
  YYSYMBOL_defattr = 180,                  /* defattr  */
  YYSYMBOL_181_3 = 181,                    /* $@3  */
  YYSYMBOL_182_4 = 182,                    /* $@4  */
  YYSYMBOL_opt_attr_list = 183,            /* opt_attr_list  */
  YYSYMBOL_attr_list = 184,                /* attr_list  */
  YYSYMBOL_attr_assign = 185,              /* attr_assign  */
  YYSYMBOL_hierarchical_id = 186,          /* hierarchical_id  */
  YYSYMBOL_hierarchical_type_id = 187,     /* hierarchical_type_id  */
  YYSYMBOL_module = 188,                   /* module  */
  YYSYMBOL_189_5 = 189,                    /* $@5  */
  YYSYMBOL_190_6 = 190,                    /* $@6  */
  YYSYMBOL_module_para_opt = 191,          /* module_para_opt  */
  YYSYMBOL_192_7 = 192,                    /* $@7  */
  YYSYMBOL_193_8 = 193,                    /* $@8  */
  YYSYMBOL_module_para_list = 194,         /* module_para_list  */
  YYSYMBOL_single_module_para = 195,       /* single_module_para  */
  YYSYMBOL_196_9 = 196,                    /* $@9  */
  YYSYMBOL_197_10 = 197,                   /* $@10  */
  YYSYMBOL_module_args_opt = 198,          /* module_args_opt  */
  YYSYMBOL_module_args = 199,              /* module_args  */
  YYSYMBOL_optional_comma = 200,           /* optional_comma  */
  YYSYMBOL_module_arg_opt_assignment = 201, /* module_arg_opt_assignment  */
  YYSYMBOL_module_arg = 202,               /* module_arg  */
  YYSYMBOL_203_11 = 203,                   /* $@11  */
  YYSYMBOL_204_12 = 204,                   /* $@12  */
  YYSYMBOL_205_13 = 205,                   /* $@13  */
  YYSYMBOL_206_14 = 206,                   /* $@14  */
  YYSYMBOL_package = 207,                  /* package  */
  YYSYMBOL_208_15 = 208,                   /* $@15  */
  YYSYMBOL_209_16 = 209,                   /* $@16  */
  YYSYMBOL_package_body = 210,             /* package_body  */
  YYSYMBOL_package_body_stmt = 211,        /* package_body_stmt  */
  YYSYMBOL_interface = 212,                /* interface  */
  YYSYMBOL_213_17 = 213,                   /* $@17  */
  YYSYMBOL_214_18 = 214,                   /* $@18  */
  YYSYMBOL_interface_body = 215,           /* interface_body  */
  YYSYMBOL_interface_body_stmt = 216,      /* interface_body_stmt  */
  YYSYMBOL_bind_directive = 217,           /* bind_directive  */
  YYSYMBOL_218_19 = 218,                   /* $@19  */
  YYSYMBOL_219_20 = 219,                   /* $@20  */
  YYSYMBOL_220_21 = 220,                   /* $@21  */
  YYSYMBOL_bind_target = 221,              /* bind_target  */
  YYSYMBOL_opt_bind_target_instance_list = 222, /* opt_bind_target_instance_list  */
  YYSYMBOL_bind_target_instance_list = 223, /* bind_target_instance_list  */
  YYSYMBOL_bind_target_instance = 224,     /* bind_target_instance  */
  YYSYMBOL_mintypmax_expr = 225,           /* mintypmax_expr  */
  YYSYMBOL_non_opt_delay = 226,            /* non_opt_delay  */
  YYSYMBOL_delay = 227,                    /* delay  */
  YYSYMBOL_io_wire_type = 228,             /* io_wire_type  */
  YYSYMBOL_229_22 = 229,                   /* $@22  */
  YYSYMBOL_non_io_wire_type = 230,         /* non_io_wire_type  */
  YYSYMBOL_231_23 = 231,                   /* $@23  */
  YYSYMBOL_wire_type = 232,                /* wire_type  */
  YYSYMBOL_wire_type_token_io = 233,       /* wire_type_token_io  */
  YYSYMBOL_wire_type_signedness = 234,     /* wire_type_signedness  */
  YYSYMBOL_wire_type_const_rand = 235,     /* wire_type_const_rand  */
  YYSYMBOL_opt_wire_type_token = 236,      /* opt_wire_type_token  */
  YYSYMBOL_wire_type_token = 237,          /* wire_type_token  */
  YYSYMBOL_net_type = 238,                 /* net_type  */
  YYSYMBOL_logic_type = 239,               /* logic_type  */
  YYSYMBOL_integer_atom_type = 240,        /* integer_atom_type  */
  YYSYMBOL_integer_vector_type = 241,      /* integer_vector_type  */
  YYSYMBOL_non_opt_range = 242,            /* non_opt_range  */
  YYSYMBOL_non_opt_multirange = 243,       /* non_opt_multirange  */
  YYSYMBOL_range = 244,                    /* range  */
  YYSYMBOL_range_or_multirange = 245,      /* range_or_multirange  */
  YYSYMBOL_module_body = 246,              /* module_body  */
  YYSYMBOL_module_body_stmt = 247,         /* module_body_stmt  */
  YYSYMBOL_checker_decl = 248,             /* checker_decl  */
  YYSYMBOL_249_24 = 249,                   /* $@24  */
  YYSYMBOL_task_func_decl = 250,           /* task_func_decl  */
  YYSYMBOL_251_25 = 251,                   /* $@25  */
  YYSYMBOL_252_26 = 252,                   /* $@26  */
  YYSYMBOL_253_27 = 253,                   /* $@27  */
  YYSYMBOL_254_28 = 254,                   /* $@28  */
  YYSYMBOL_255_29 = 255,                   /* $@29  */
  YYSYMBOL_func_return_type = 256,         /* func_return_type  */
  YYSYMBOL_opt_type_vec = 257,             /* opt_type_vec  */
  YYSYMBOL_opt_signedness_default_signed = 258, /* opt_signedness_default_signed  */
  YYSYMBOL_opt_signedness_default_unsigned = 259, /* opt_signedness_default_unsigned  */
  YYSYMBOL_dpi_function_arg = 260,         /* dpi_function_arg  */
  YYSYMBOL_opt_dpi_function_args = 261,    /* opt_dpi_function_args  */
  YYSYMBOL_dpi_function_args = 262,        /* dpi_function_args  */
  YYSYMBOL_opt_automatic = 263,            /* opt_automatic  */
  YYSYMBOL_task_func_args_opt = 264,       /* task_func_args_opt  */
  YYSYMBOL_265_30 = 265,                   /* $@30  */
  YYSYMBOL_266_31 = 266,                   /* $@31  */
  YYSYMBOL_task_func_args = 267,           /* task_func_args  */
  YYSYMBOL_task_func_port = 268,           /* task_func_port  */
  YYSYMBOL_269_32 = 269,                   /* $@32  */
  YYSYMBOL_270_33 = 270,                   /* $@33  */
  YYSYMBOL_task_func_body = 271,           /* task_func_body  */
  YYSYMBOL_specify_block = 272,            /* specify_block  */
  YYSYMBOL_specify_item_list = 273,        /* specify_item_list  */
  YYSYMBOL_specify_item = 274,             /* specify_item  */
  YYSYMBOL_specify_opt_triple = 275,       /* specify_opt_triple  */
  YYSYMBOL_specify_if = 276,               /* specify_if  */
  YYSYMBOL_specify_condition = 277,        /* specify_condition  */
  YYSYMBOL_specify_target = 278,           /* specify_target  */
  YYSYMBOL_specify_edge = 279,             /* specify_edge  */
  YYSYMBOL_specify_rise_fall = 280,        /* specify_rise_fall  */
  YYSYMBOL_specify_triple = 281,           /* specify_triple  */
  YYSYMBOL_ignored_specify_block = 282,    /* ignored_specify_block  */
  YYSYMBOL_ignored_specify_item_opt = 283, /* ignored_specify_item_opt  */
  YYSYMBOL_ignored_specify_item = 284,     /* ignored_specify_item  */
  YYSYMBOL_specparam_declaration = 285,    /* specparam_declaration  */
  YYSYMBOL_specparam_range = 286,          /* specparam_range  */
  YYSYMBOL_list_of_specparam_assignments = 287, /* list_of_specparam_assignments  */
  YYSYMBOL_specparam_assignment = 288,     /* specparam_assignment  */
  YYSYMBOL_ignspec_opt_cond = 289,         /* ignspec_opt_cond  */
  YYSYMBOL_path_declaration = 290,         /* path_declaration  */
  YYSYMBOL_simple_path_declaration = 291,  /* simple_path_declaration  */
  YYSYMBOL_path_delay_value = 292,         /* path_delay_value  */
  YYSYMBOL_list_of_path_delay_extra_expressions = 293, /* list_of_path_delay_extra_expressions  */
  YYSYMBOL_specify_edge_identifier = 294,  /* specify_edge_identifier  */
  YYSYMBOL_parallel_path_description = 295, /* parallel_path_description  */
  YYSYMBOL_full_path_description = 296,    /* full_path_description  */
  YYSYMBOL_list_of_path_inputs = 297,      /* list_of_path_inputs  */
  YYSYMBOL_more_path_inputs = 298,         /* more_path_inputs  */
  YYSYMBOL_list_of_path_outputs = 299,     /* list_of_path_outputs  */
  YYSYMBOL_opt_polarity_operator = 300,    /* opt_polarity_operator  */
  YYSYMBOL_specify_input_terminal_descriptor = 301, /* specify_input_terminal_descriptor  */
  YYSYMBOL_specify_output_terminal_descriptor = 302, /* specify_output_terminal_descriptor  */
  YYSYMBOL_system_timing_declaration = 303, /* system_timing_declaration  */
  YYSYMBOL_system_timing_arg = 304,        /* system_timing_arg  */
  YYSYMBOL_system_timing_args = 305,       /* system_timing_args  */
  YYSYMBOL_ignspec_constant_expression = 306, /* ignspec_constant_expression  */
  YYSYMBOL_ignspec_expr = 307,             /* ignspec_expr  */
  YYSYMBOL_ignspec_id = 308,               /* ignspec_id  */
  YYSYMBOL_309_34 = 309,                   /* $@34  */
  YYSYMBOL_param_signed = 310,             /* param_signed  */
  YYSYMBOL_param_integer = 311,            /* param_integer  */
  YYSYMBOL_param_real = 312,               /* param_real  */
  YYSYMBOL_param_range = 313,              /* param_range  */
  YYSYMBOL_param_integer_type = 314,       /* param_integer_type  */
  YYSYMBOL_param_range_type = 315,         /* param_range_type  */
  YYSYMBOL_param_implicit_type = 316,      /* param_implicit_type  */
  YYSYMBOL_param_type = 317,               /* param_type  */
  YYSYMBOL_param_decl = 318,               /* param_decl  */
  YYSYMBOL_319_35 = 319,                   /* $@35  */
  YYSYMBOL_localparam_decl = 320,          /* localparam_decl  */
  YYSYMBOL_321_36 = 321,                   /* $@36  */
  YYSYMBOL_param_decl_list = 322,          /* param_decl_list  */
  YYSYMBOL_single_param_decl = 323,        /* single_param_decl  */
  YYSYMBOL_single_param_decl_ident = 324,  /* single_param_decl_ident  */
  YYSYMBOL_defparam_decl = 325,            /* defparam_decl  */
  YYSYMBOL_defparam_decl_list = 326,       /* defparam_decl_list  */
  YYSYMBOL_single_defparam_decl = 327,     /* single_defparam_decl  */
  YYSYMBOL_enum_type = 328,                /* enum_type  */
  YYSYMBOL_329_37 = 329,                   /* $@37  */
  YYSYMBOL_enum_base_type = 330,           /* enum_base_type  */
  YYSYMBOL_type_atom = 331,                /* type_atom  */
  YYSYMBOL_type_vec = 332,                 /* type_vec  */
  YYSYMBOL_type_signing = 333,             /* type_signing  */
  YYSYMBOL_enum_name_list = 334,           /* enum_name_list  */
  YYSYMBOL_enum_name_decl = 335,           /* enum_name_decl  */
  YYSYMBOL_opt_enum_init = 336,            /* opt_enum_init  */
  YYSYMBOL_enum_var_list = 337,            /* enum_var_list  */
  YYSYMBOL_enum_var = 338,                 /* enum_var  */
  YYSYMBOL_enum_decl = 339,                /* enum_decl  */
  YYSYMBOL_struct_decl = 340,              /* struct_decl  */
  YYSYMBOL_struct_type = 341,              /* struct_type  */
  YYSYMBOL_342_38 = 342,                   /* $@38  */
  YYSYMBOL_struct_union = 343,             /* struct_union  */
  YYSYMBOL_struct_body = 344,              /* struct_body  */
  YYSYMBOL_opt_packed = 345,               /* opt_packed  */
  YYSYMBOL_opt_signed_struct = 346,        /* opt_signed_struct  */
  YYSYMBOL_struct_member_list = 347,       /* struct_member_list  */
  YYSYMBOL_struct_member = 348,            /* struct_member  */
  YYSYMBOL_member_name_list = 349,         /* member_name_list  */
  YYSYMBOL_member_name = 350,              /* member_name  */
  YYSYMBOL_351_39 = 351,                   /* $@39  */
  YYSYMBOL_struct_member_type = 352,       /* struct_member_type  */
  YYSYMBOL_353_40 = 353,                   /* $@40  */
  YYSYMBOL_member_type_token = 354,        /* member_type_token  */
  YYSYMBOL_355_41 = 355,                   /* $@41  */
  YYSYMBOL_356_42 = 356,                   /* $@42  */
  YYSYMBOL_member_type = 357,              /* member_type  */
  YYSYMBOL_struct_var_list = 358,          /* struct_var_list  */
  YYSYMBOL_struct_var = 359,               /* struct_var  */
  YYSYMBOL_wire_decl = 360,                /* wire_decl  */
  YYSYMBOL_361_43 = 361,                   /* $@43  */
  YYSYMBOL_362_44 = 362,                   /* $@44  */
  YYSYMBOL_363_45 = 363,                   /* $@45  */
  YYSYMBOL_364_46 = 364,                   /* $@46  */
  YYSYMBOL_opt_supply_wires = 365,         /* opt_supply_wires  */
  YYSYMBOL_wire_name_list = 366,           /* wire_name_list  */
  YYSYMBOL_wire_name_and_opt_assign = 367, /* wire_name_and_opt_assign  */
  YYSYMBOL_wire_name = 368,                /* wire_name  */
  YYSYMBOL_assign_stmt = 369,              /* assign_stmt  */
  YYSYMBOL_assign_expr_list = 370,         /* assign_expr_list  */
  YYSYMBOL_assign_expr = 371,              /* assign_expr  */
  YYSYMBOL_type_name = 372,                /* type_name  */
  YYSYMBOL_typedef_decl = 373,             /* typedef_decl  */
  YYSYMBOL_typedef_base_type = 374,        /* typedef_base_type  */
  YYSYMBOL_enum_struct_type = 375,         /* enum_struct_type  */
  YYSYMBOL_cell_stmt = 376,                /* cell_stmt  */
  YYSYMBOL_377_47 = 377,                   /* $@47  */
  YYSYMBOL_378_48 = 378,                   /* $@48  */
  YYSYMBOL_tok_prim_wrapper = 379,         /* tok_prim_wrapper  */
  YYSYMBOL_cell_list = 380,                /* cell_list  */
  YYSYMBOL_single_cell = 381,              /* single_cell  */
  YYSYMBOL_single_cell_no_array = 382,     /* single_cell_no_array  */
  YYSYMBOL_383_49 = 383,                   /* $@49  */
  YYSYMBOL_single_cell_arraylist = 384,    /* single_cell_arraylist  */
  YYSYMBOL_385_50 = 385,                   /* $@50  */
  YYSYMBOL_cell_list_no_array = 386,       /* cell_list_no_array  */
  YYSYMBOL_prim_list = 387,                /* prim_list  */
  YYSYMBOL_single_prim = 388,              /* single_prim  */
  YYSYMBOL_389_51 = 389,                   /* $@51  */
  YYSYMBOL_cell_parameter_list_opt = 390,  /* cell_parameter_list_opt  */
  YYSYMBOL_cell_parameter_list = 391,      /* cell_parameter_list  */
  YYSYMBOL_cell_parameter = 392,           /* cell_parameter  */
  YYSYMBOL_cell_port_list = 393,           /* cell_port_list  */
  YYSYMBOL_cell_port_list_rules = 394,     /* cell_port_list_rules  */
  YYSYMBOL_cell_port = 395,                /* cell_port  */
  YYSYMBOL_always_comb_or_latch = 396,     /* always_comb_or_latch  */
  YYSYMBOL_always_or_always_ff = 397,      /* always_or_always_ff  */
  YYSYMBOL_always_stmt = 398,              /* always_stmt  */
  YYSYMBOL_399_52 = 399,                   /* $@52  */
  YYSYMBOL_400_53 = 400,                   /* $@53  */
  YYSYMBOL_401_54 = 401,                   /* $@54  */
  YYSYMBOL_402_55 = 402,                   /* $@55  */
  YYSYMBOL_always_cond = 403,              /* always_cond  */
  YYSYMBOL_always_events = 404,            /* always_events  */
  YYSYMBOL_always_event = 405,             /* always_event  */
  YYSYMBOL_opt_label = 406,                /* opt_label  */
  YYSYMBOL_opt_sva_label = 407,            /* opt_sva_label  */
  YYSYMBOL_opt_property = 408,             /* opt_property  */
  YYSYMBOL_modport_stmt = 409,             /* modport_stmt  */
  YYSYMBOL_410_56 = 410,                   /* $@56  */
  YYSYMBOL_411_57 = 411,                   /* $@57  */
  YYSYMBOL_modport_args_opt = 412,         /* modport_args_opt  */
  YYSYMBOL_modport_args = 413,             /* modport_args  */
  YYSYMBOL_modport_arg = 414,              /* modport_arg  */
  YYSYMBOL_modport_member = 415,           /* modport_member  */
  YYSYMBOL_modport_type_token = 416,       /* modport_type_token  */
  YYSYMBOL_assert = 417,                   /* assert  */
  YYSYMBOL_assert_property = 418,          /* assert_property  */
  YYSYMBOL_simple_behavioral_stmt = 419,   /* simple_behavioral_stmt  */
  YYSYMBOL_asgn_binop = 420,               /* asgn_binop  */
  YYSYMBOL_for_initialization = 421,       /* for_initialization  */
  YYSYMBOL_behavioral_stmt = 422,          /* behavioral_stmt  */
  YYSYMBOL_423_58 = 423,                   /* $@58  */
  YYSYMBOL_424_59 = 424,                   /* $@59  */
  YYSYMBOL_425_60 = 425,                   /* $@60  */
  YYSYMBOL_426_61 = 426,                   /* $@61  */
  YYSYMBOL_427_62 = 427,                   /* $@62  */
  YYSYMBOL_428_63 = 428,                   /* $@63  */
  YYSYMBOL_429_64 = 429,                   /* $@64  */
  YYSYMBOL_430_65 = 430,                   /* $@65  */
  YYSYMBOL_431_66 = 431,                   /* $@66  */
  YYSYMBOL_432_67 = 432,                   /* $@67  */
  YYSYMBOL_433_68 = 433,                   /* $@68  */
  YYSYMBOL_434_69 = 434,                   /* $@69  */
  YYSYMBOL_case_attr = 435,                /* case_attr  */
  YYSYMBOL_case_type = 436,                /* case_type  */
  YYSYMBOL_opt_synopsys_attr = 437,        /* opt_synopsys_attr  */
  YYSYMBOL_behavioral_stmt_list = 438,     /* behavioral_stmt_list  */
  YYSYMBOL_optional_else = 439,            /* optional_else  */
  YYSYMBOL_440_70 = 440,                   /* $@70  */
  YYSYMBOL_case_body = 441,                /* case_body  */
  YYSYMBOL_case_item = 442,                /* case_item  */
  YYSYMBOL_443_71 = 443,                   /* $@71  */
  YYSYMBOL_444_72 = 444,                   /* $@72  */
  YYSYMBOL_gen_case_body = 445,            /* gen_case_body  */
  YYSYMBOL_gen_case_item = 446,            /* gen_case_item  */
  YYSYMBOL_447_73 = 447,                   /* $@73  */
  YYSYMBOL_448_74 = 448,                   /* $@74  */
  YYSYMBOL_case_select = 449,              /* case_select  */
  YYSYMBOL_case_expr_list = 450,           /* case_expr_list  */
  YYSYMBOL_rvalue = 451,                   /* rvalue  */
  YYSYMBOL_lvalue = 452,                   /* lvalue  */
  YYSYMBOL_lvalue_concat_list = 453,       /* lvalue_concat_list  */
  YYSYMBOL_opt_arg_list = 454,             /* opt_arg_list  */
  YYSYMBOL_arg_list = 455,                 /* arg_list  */
  YYSYMBOL_arg_list2 = 456,                /* arg_list2  */
  YYSYMBOL_single_arg = 457,               /* single_arg  */
  YYSYMBOL_module_gen_body = 458,          /* module_gen_body  */
  YYSYMBOL_gen_stmt_or_module_body_stmt = 459, /* gen_stmt_or_module_body_stmt  */
  YYSYMBOL_genvar_identifier = 460,        /* genvar_identifier  */
  YYSYMBOL_genvar_initialization = 461,    /* genvar_initialization  */
  YYSYMBOL_gen_stmt = 462,                 /* gen_stmt  */
  YYSYMBOL_463_75 = 463,                   /* $@75  */
  YYSYMBOL_464_76 = 464,                   /* $@76  */
  YYSYMBOL_465_77 = 465,                   /* $@77  */
  YYSYMBOL_466_78 = 466,                   /* $@78  */
  YYSYMBOL_467_79 = 467,                   /* $@79  */
  YYSYMBOL_gen_block = 468,                /* gen_block  */
  YYSYMBOL_469_80 = 469,                   /* $@80  */
  YYSYMBOL_470_81 = 470,                   /* $@81  */
  YYSYMBOL_gen_stmt_block = 471,           /* gen_stmt_block  */
  YYSYMBOL_472_82 = 472,                   /* $@82  */
  YYSYMBOL_opt_gen_else = 473,             /* opt_gen_else  */
  YYSYMBOL_expr = 474,                     /* expr  */
  YYSYMBOL_basic_expr = 475,               /* basic_expr  */
  YYSYMBOL_476_83 = 476,                   /* $@83  */
  YYSYMBOL_concat_list = 477,              /* concat_list  */
  YYSYMBOL_integral_number = 478           /* integral_number  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
# define YYCOPY_NEEDED 1
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined FRONTEND_VERILOG_YYLTYPE_IS_TRIVIAL && FRONTEND_VERILOG_YYLTYPE_IS_TRIVIAL \
             && defined FRONTEND_VERILOG_YYSTYPE_IS_TRIVIAL && FRONTEND_VERILOG_YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2901

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  173
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  306
/* YYNRULES -- Number of rules.  */
#define YYNRULES  692
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1333

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   401


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   172,     2,   163,     2,   152,   134,     2,
     160,   161,   150,   148,   157,   149,   159,   151,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   164,   162,
     140,   158,   143,   170,   169,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   165,     2,   166,   132,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   167,   130,   168,   171,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   131,   133,   135,   136,   137,
     138,   139,   141,   142,   144,   145,   146,   147,   153,   154,
     155,   156
};

#if FRONTEND_VERILOG_YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   419,   419,   419,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   443,   443,   459,   462,   465,   472,
     465,   483,   483,   486,   487,   490,   496,   504,   507,   515,
     525,   526,   527,   531,   533,   531,   558,   558,   558,   558,
     561,   561,   564,   565,   565,   571,   571,   577,   580,   580,
     580,   583,   583,   586,   586,   589,   607,   610,   610,   624,
     629,   624,   639,   639,   655,   660,   662,   660,   679,   679,
     682,   682,   682,   682,   685,   687,   685,   708,   708,   711,
     711,   711,   711,   711,   711,   711,   712,   712,   715,   720,
     724,   715,   752,   757,   758,   761,   762,   767,   775,   776,
     779,   780,   781,   783,   784,   785,   786,   787,   790,   790,
     793,   793,   798,   798,   803,   804,   807,   810,   813,   819,
     820,   821,   824,   828,   831,   834,   837,   837,   841,   843,
     846,   849,   853,   856,   859,   862,   871,   874,   877,   880,
     882,   887,   892,   893,   894,   895,   896,   899,   900,   903,
     908,   914,   920,   926,   929,   935,   938,   943,   944,   947,
     949,   950,   951,   952,   955,   955,   955,   955,   955,   955,
     955,   955,   955,   955,   956,   956,   956,   957,   957,   957,
     957,   957,   957,   960,   960,   971,   971,   981,   981,   992,
     992,  1004,  1004,  1016,  1016,  1041,  1046,  1049,  1053,  1058,
    1059,  1060,  1064,  1065,  1066,  1069,  1070,  1071,  1075,  1080,
    1086,  1087,  1090,  1091,  1092,  1093,  1096,  1097,  1100,  1100,
    1100,  1104,  1100,  1112,  1112,  1115,  1115,  1136,  1136,  1150,
    1151,  1156,  1159,  1160,  1163,  1247,  1321,  1324,  1329,  1332,
    1337,  1340,  1345,  1351,  1357,  1363,  1371,  1372,  1373,  1376,
    1384,  1391,  1400,  1412,  1432,  1438,  1448,  1449,  1452,  1453,
    1456,  1459,  1460,  1464,  1465,  1471,  1474,  1474,  1477,  1480,
    1480,  1483,  1489,  1490,  1494,  1495,  1496,  1500,  1501,  1505,
    1505,  1508,  1509,  1510,  1513,  1514,  1515,  1519,  1520,  1523,
    1524,  1527,  1528,  1531,  1531,  1531,  1535,  1539,  1542,  1545,
    1546,  1547,  1550,  1551,  1552,  1559,  1562,  1563,  1570,  1570,
    1576,  1578,  1580,  1583,  1588,  1593,  1599,  1601,  1604,  1607,
    1610,  1610,  1610,  1610,  1611,  1619,  1619,  1628,  1628,  1637,
    1637,  1640,  1646,  1659,  1676,  1679,  1679,  1682,  1695,  1695,
    1718,  1719,  1720,  1724,  1730,  1731,  1735,  1736,  1737,  1740,
    1741,  1745,  1760,  1761,  1765,  1766,  1769,  1781,  1788,  1791,
    1791,  1795,  1796,  1799,  1803,  1804,  1807,  1808,  1809,  1812,
    1813,  1816,  1820,  1821,  1824,  1824,  1833,  1833,  1837,  1838,
    1855,  1857,  1855,  1869,  1870,  1873,  1874,  1877,  1890,  1894,
    1890,  1900,  1900,  1908,  1908,  1918,  1919,  1930,  1930,  1933,
    1975,  2003,  2049,  2052,  2052,  2055,  2061,  2062,  2066,  2079,
    2083,  2088,  2097,  2106,  2107,  2111,  2111,  2120,  2120,  2130,
    2133,  2138,  2139,  2142,  2142,  2145,  2145,  2156,  2156,  2167,
    2168,  2171,  2172,  2175,  2176,  2176,  2184,  2184,  2187,  2187,
    2190,  2191,  2196,  2199,  2208,  2235,  2235,  2238,  2243,  2249,
    2257,  2264,  2273,  2281,  2284,  2289,  2292,  2297,  2304,  2297,
    2317,  2317,  2333,  2333,  2347,  2348,  2349,  2350,  2351,  2352,
    2355,  2356,  2357,  2360,  2366,  2372,  2379,  2382,  2387,  2390,
    2395,  2398,  2401,  2406,  2412,  2406,  2418,  2418,  2421,  2421,
    2424,  2425,  2428,  2438,  2438,  2441,  2454,  2467,  2480,  2493,
    2502,  2511,  2520,  2535,  2552,  2561,  2570,  2579,  2588,  2597,
    2610,  2625,  2631,  2637,  2643,  2649,  2665,  2666,  2667,  2668,
    2669,  2670,  2671,  2672,  2673,  2674,  2675,  2676,  2679,  2687,
    2690,  2728,  2728,  2728,  2728,  2728,  2728,  2729,  2730,  2731,
    2734,  2734,  2744,  2744,  2754,  2756,  2754,  2781,  2786,  2788,
    2781,  2799,  2799,  2813,  2813,  2827,  2838,  2827,  2845,  2845,
    2858,  2861,  2865,  2869,  2876,  2879,  2882,  2887,  2891,  2895,
    2898,  2899,  2902,  2902,  2913,  2916,  2917,  2920,  2926,  2920,
    2939,  2940,  2943,  2949,  2943,  2958,  2959,  2962,  2967,  2974,
    2977,  2982,  2988,  2998,  3006,  3009,  3014,  3018,  3024,  3025,
    3028,  3029,  3032,  3033,  3036,  3041,  3042,  3043,  3046,  3046,
    3047,  3052,  3059,  3062,  3078,  3086,  3090,  3086,  3097,  3097,
    3106,  3106,  3115,  3115,  3127,  3129,  3127,  3145,  3145,  3152,
    3155,  3155,  3158,  3161,  3171,  3174,  3184,  3198,  3205,  3217,
    3222,  3222,  3233,  3237,  3241,  3244,  3249,  3252,  3255,  3260,
    3265,  3270,  3275,  3280,  3285,  3290,  3295,  3301,  3306,  3313,
    3318,  3323,  3328,  3333,  3338,  3343,  3348,  3353,  3358,  3363,
    3368,  3373,  3378,  3383,  3388,  3393,  3398,  3403,  3408,  3413,
    3418,  3423,  3428,  3433,  3438,  3444,  3450,  3458,  3461,  3467,
    3468,  3469,  3474
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "TOK_STRING", "TOK_ID",
  "TOK_CONSTVAL", "TOK_REALVAL", "TOK_PRIMITIVE", "TOK_SVA_LABEL",
  "TOK_SPECIFY_OPER", "TOK_MSG_TASKS", "TOK_BASE", "TOK_BASED_CONSTVAL",
  "TOK_UNBASED_UNSIZED_CONSTVAL", "TOK_USER_TYPE", "TOK_PKG_USER_TYPE",
  "TOK_ASSERT", "TOK_ASSUME", "TOK_RESTRICT", "TOK_COVER", "TOK_FINAL",
  "ATTR_BEGIN", "ATTR_END", "DEFATTR_BEGIN", "DEFATTR_END", "TOK_MODULE",
  "TOK_ENDMODULE", "TOK_PARAMETER", "TOK_LOCALPARAM", "TOK_DEFPARAM",
  "TOK_PACKAGE", "TOK_ENDPACKAGE", "TOK_PACKAGESEP", "TOK_INTERFACE",
  "TOK_ENDINTERFACE", "TOK_MODPORT", "TOK_VAR", "TOK_WILDCARD_CONNECT",
  "TOK_INPUT", "TOK_OUTPUT", "TOK_INOUT", "TOK_WIRE", "TOK_WAND",
  "TOK_WOR", "TOK_REG", "TOK_LOGIC", "TOK_INTEGER", "TOK_SIGNED",
  "TOK_ASSIGN", "TOK_ALWAYS", "TOK_INITIAL", "TOK_ALWAYS_FF",
  "TOK_ALWAYS_COMB", "TOK_ALWAYS_LATCH", "TOK_BEGIN", "TOK_END", "TOK_IF",
  "TOK_ELSE", "TOK_FOR", "TOK_WHILE", "TOK_REPEAT", "TOK_DPI_FUNCTION",
  "TOK_POSEDGE", "TOK_NEGEDGE", "TOK_OR", "TOK_AUTOMATIC", "TOK_CASE",
  "TOK_CASEX", "TOK_CASEZ", "TOK_ENDCASE", "TOK_DEFAULT", "TOK_FUNCTION",
  "TOK_ENDFUNCTION", "TOK_TASK", "TOK_ENDTASK", "TOK_SPECIFY",
  "TOK_IGNORED_SPECIFY", "TOK_ENDSPECIFY", "TOK_SPECPARAM",
  "TOK_SPECIFY_AND", "TOK_IGNORED_SPECIFY_AND", "TOK_GENERATE",
  "TOK_ENDGENERATE", "TOK_GENVAR", "TOK_REAL", "TOK_SYNOPSYS_FULL_CASE",
  "TOK_SYNOPSYS_PARALLEL_CASE", "TOK_SUPPLY0", "TOK_SUPPLY1",
  "TOK_TO_SIGNED", "TOK_TO_UNSIGNED", "TOK_POS_INDEXED", "TOK_NEG_INDEXED",
  "TOK_PROPERTY", "TOK_ENUM", "TOK_TYPEDEF", "TOK_RAND", "TOK_CONST",
  "TOK_CHECKER", "TOK_ENDCHECKER", "TOK_EVENTUALLY", "TOK_INCREMENT",
  "TOK_DECREMENT", "TOK_UNIQUE", "TOK_UNIQUE0", "TOK_PRIORITY",
  "TOK_STRUCT", "TOK_PACKED", "TOK_UNSIGNED", "TOK_INT", "TOK_BYTE",
  "TOK_SHORTINT", "TOK_LONGINT", "TOK_UNION", "TOK_BIT_OR_ASSIGN",
  "TOK_BIT_AND_ASSIGN", "TOK_BIT_XOR_ASSIGN", "TOK_ADD_ASSIGN",
  "TOK_SUB_ASSIGN", "TOK_DIV_ASSIGN", "TOK_MOD_ASSIGN", "TOK_MUL_ASSIGN",
  "TOK_SHL_ASSIGN", "TOK_SHR_ASSIGN", "TOK_SSHL_ASSIGN", "TOK_SSHR_ASSIGN",
  "TOK_BIND", "TOK_TIME_SCALE", "OP_LOR", "OP_LAND", "'|'", "OP_NOR",
  "'^'", "OP_XNOR", "'&'", "OP_NAND", "OP_EQ", "OP_NE", "OP_EQX", "OP_NEX",
  "'<'", "OP_LE", "OP_GE", "'>'", "OP_SHL", "OP_SHR", "OP_SSHL", "OP_SSHR",
  "'+'", "'-'", "'*'", "'/'", "'%'", "OP_POW", "OP_CAST", "UNARY_OPS",
  "FAKE_THEN", "','", "'='", "'.'", "'('", "')'", "';'", "'#'", "':'",
  "'['", "']'", "'{'", "'}'", "'@'", "'?'", "'~'", "'!'", "$accept",
  "input", "$@1", "design", "attr", "$@2", "attr_opt", "defattr", "$@3",
  "$@4", "opt_attr_list", "attr_list", "attr_assign", "hierarchical_id",
  "hierarchical_type_id", "module", "$@5", "$@6", "module_para_opt", "$@7",
  "$@8", "module_para_list", "single_module_para", "$@9", "$@10",
  "module_args_opt", "module_args", "optional_comma",
  "module_arg_opt_assignment", "module_arg", "$@11", "$@12", "$@13",
  "$@14", "package", "$@15", "$@16", "package_body", "package_body_stmt",
  "interface", "$@17", "$@18", "interface_body", "interface_body_stmt",
  "bind_directive", "$@19", "$@20", "$@21", "bind_target",
  "opt_bind_target_instance_list", "bind_target_instance_list",
  "bind_target_instance", "mintypmax_expr", "non_opt_delay", "delay",
  "io_wire_type", "$@22", "non_io_wire_type", "$@23", "wire_type",
  "wire_type_token_io", "wire_type_signedness", "wire_type_const_rand",
  "opt_wire_type_token", "wire_type_token", "net_type", "logic_type",
  "integer_atom_type", "integer_vector_type", "non_opt_range",
  "non_opt_multirange", "range", "range_or_multirange", "module_body",
  "module_body_stmt", "checker_decl", "$@24", "task_func_decl", "$@25",
  "$@26", "$@27", "$@28", "$@29", "func_return_type", "opt_type_vec",
  "opt_signedness_default_signed", "opt_signedness_default_unsigned",
  "dpi_function_arg", "opt_dpi_function_args", "dpi_function_args",
  "opt_automatic", "task_func_args_opt", "$@30", "$@31", "task_func_args",
  "task_func_port", "$@32", "$@33", "task_func_body", "specify_block",
  "specify_item_list", "specify_item", "specify_opt_triple", "specify_if",
  "specify_condition", "specify_target", "specify_edge",
  "specify_rise_fall", "specify_triple", "ignored_specify_block",
  "ignored_specify_item_opt", "ignored_specify_item",
  "specparam_declaration", "specparam_range",
  "list_of_specparam_assignments", "specparam_assignment",
  "ignspec_opt_cond", "path_declaration", "simple_path_declaration",
  "path_delay_value", "list_of_path_delay_extra_expressions",
  "specify_edge_identifier", "parallel_path_description",
  "full_path_description", "list_of_path_inputs", "more_path_inputs",
  "list_of_path_outputs", "opt_polarity_operator",
  "specify_input_terminal_descriptor",
  "specify_output_terminal_descriptor", "system_timing_declaration",
  "system_timing_arg", "system_timing_args", "ignspec_constant_expression",
  "ignspec_expr", "ignspec_id", "$@34", "param_signed", "param_integer",
  "param_real", "param_range", "param_integer_type", "param_range_type",
  "param_implicit_type", "param_type", "param_decl", "$@35",
  "localparam_decl", "$@36", "param_decl_list", "single_param_decl",
  "single_param_decl_ident", "defparam_decl", "defparam_decl_list",
  "single_defparam_decl", "enum_type", "$@37", "enum_base_type",
  "type_atom", "type_vec", "type_signing", "enum_name_list",
  "enum_name_decl", "opt_enum_init", "enum_var_list", "enum_var",
  "enum_decl", "struct_decl", "struct_type", "$@38", "struct_union",
  "struct_body", "opt_packed", "opt_signed_struct", "struct_member_list",
  "struct_member", "member_name_list", "member_name", "$@39",
  "struct_member_type", "$@40", "member_type_token", "$@41", "$@42",
  "member_type", "struct_var_list", "struct_var", "wire_decl", "$@43",
  "$@44", "$@45", "$@46", "opt_supply_wires", "wire_name_list",
  "wire_name_and_opt_assign", "wire_name", "assign_stmt",
  "assign_expr_list", "assign_expr", "type_name", "typedef_decl",
  "typedef_base_type", "enum_struct_type", "cell_stmt", "$@47", "$@48",
  "tok_prim_wrapper", "cell_list", "single_cell", "single_cell_no_array",
  "$@49", "single_cell_arraylist", "$@50", "cell_list_no_array",
  "prim_list", "single_prim", "$@51", "cell_parameter_list_opt",
  "cell_parameter_list", "cell_parameter", "cell_port_list",
  "cell_port_list_rules", "cell_port", "always_comb_or_latch",
  "always_or_always_ff", "always_stmt", "$@52", "$@53", "$@54", "$@55",
  "always_cond", "always_events", "always_event", "opt_label",
  "opt_sva_label", "opt_property", "modport_stmt", "$@56", "$@57",
  "modport_args_opt", "modport_args", "modport_arg", "modport_member",
  "modport_type_token", "assert", "assert_property",
  "simple_behavioral_stmt", "asgn_binop", "for_initialization",
  "behavioral_stmt", "$@58", "$@59", "$@60", "$@61", "$@62", "$@63",
  "$@64", "$@65", "$@66", "$@67", "$@68", "$@69", "case_attr", "case_type",
  "opt_synopsys_attr", "behavioral_stmt_list", "optional_else", "$@70",
  "case_body", "case_item", "$@71", "$@72", "gen_case_body",
  "gen_case_item", "$@73", "$@74", "case_select", "case_expr_list",
  "rvalue", "lvalue", "lvalue_concat_list", "opt_arg_list", "arg_list",
  "arg_list2", "single_arg", "module_gen_body",
  "gen_stmt_or_module_body_stmt", "genvar_identifier",
  "genvar_initialization", "gen_stmt", "$@75", "$@76", "$@77", "$@78",
  "$@79", "gen_block", "$@80", "$@81", "gen_stmt_block", "$@82",
  "opt_gen_else", "expr", "basic_expr", "$@83", "concat_list",
  "integral_number", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-1017)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-588)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
   -1017,   132,   323, -1017, -1017, -1017,   579, -1017, -1017,   547,
   -1017,   323,   323,   323,   323,   323,   323,   323,   323,   323,
     166,   185, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017, -1017,   186, -1017,    65,   111, -1017, -1017,
   -1017,    70,   238,   166, -1017, -1017, -1017, -1017,   262,   250,
     250,   310, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017,   176, -1017,   162, -1017,   520,   183, -1017,
   -1017, -1017, -1017, -1017, -1017,   287,  1940, -1017,   238, -1017,
   -1017,   226,    88, -1017,   275,   346,   632,   632,   452,    75,
   -1017,  1006,   499,   166,   508,   166,   535,  1940,   541,   384,
   -1017, -1017, -1017,   402,   120,   120, -1017,   136, -1017,   415,
   -1017,   578, -1017,   585, -1017,   458, -1017, -1017,   479, -1017,
   -1017, -1017, -1017, -1017, -1017, -1017, -1017,  1940,  1940, -1017,
   -1017,   177, -1017,   257,  2590, -1017,    70, -1017,   639,   166,
   -1017, -1017, -1017, -1017, -1017, -1017,    70,   251, -1017, -1017,
   -1017, -1017,   656, -1017,   251,   656, -1017, -1017,   663,   666,
   -1017, -1017, -1017,    65,   668,   111, -1017,   671, -1017, -1017,
   -1017, -1017, -1017,   534,   537,   696, -1017, -1017, -1017,    70,
   -1017, -1017, -1017, -1017,   689, -1017,   551,   553,   555,   577,
    1940,  1940,  1940,  1940,  1940,  1940,  1940,  1940,   443,   188,
     584,  1940,  1940,  1940, -1017,    70,    70, -1017, -1017,  1940,
    1940,  1940, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,   587,
   -1017,    70, -1017,   583, -1017,   600, -1017,   384, -1017, -1017,
   -1017, -1017,     4, -1017,   602,    70,   144,   596,   603,   761,
     608, -1017, -1017,    70,   609, -1017, -1017,    79,   606,   612,
     615, -1017, -1017,   605, -1017,   770,  1018, -1017,  1940,  1940,
    1940,  1940, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,
     495,  1940,  1940,  1940, -1017, -1017, -1017,   294,   616, -1017,
   -1017,   621,   625,   627,  1940,  1940,  1940,  1940,  1940,  1940,
    1940,  1940,  1940,  1940,  1940,  1940,  1940,  1940,  1940,  1940,
    1940,  1940,  1940,  1940,  1940,  1940,  1940,  1940,  1940,  1940,
    1940,  1940, -1017,   634,   166,   537,   656, -1017,  1940, -1017,
   -1017, -1017,   771,   637, -1017,   797,   609, -1017,   642,   643,
      80,   800,   647, -1017,   680,   652, -1017, -1017,  1940, -1017,
     696,   650, -1017, -1017, -1017,   204, -1017, -1017,   120,   120,
   -1017,   154, -1017,   658,   659,   667,   675, -1017,   673,   681,
   -1017,   683,   694,  1940, -1017, -1017, -1017,  2659,  2684,  2707,
    2707,  2728,  2728,  2747,  2747,  2176,  2176,  2176,  2176,   505,
     505,   505,   505,   692,   692,   692,   692,   572,   572,    -6,
      -6,    -6,   700,   695,   691,   697,   854, -1017,   698, -1017,
   -1017,   100,   861, -1017,   203, -1017,   603,   864,   710, -1017,
     869, -1017,   222,   718, -1017, -1017,   716,   872,   719, -1017,
     711, -1017,   371,    70,    97,   725,   284,  2633, -1017, -1017,
      70,   770, -1017, -1017,    70, -1017, -1017, -1017, -1017, -1017,
    1940,   709,   166,   730, -1017, -1017, -1017, -1017,  1940,  1302,
   -1017, -1017,   321, -1017,   724,   510, -1017, -1017, -1017, -1017,
   -1017, -1017,   771, -1017,   727, -1017, -1017,   680,   737, -1017,
     894,   335, -1017, -1017,    80,   739,  1940, -1017, -1017, -1017,
   -1017, -1017, -1017,   371,   805, -1017,   781,   900, -1017, -1017,
      70, -1017,   901,   743,  1488, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,   287,   746,
   -1017,   137, -1017,  1940,   747, -1017,   906,   374, -1017, -1017,
     752,   854, -1017,  2350,   910, -1017, -1017, -1017,   603,   456,
      70,    98, -1017,    70, -1017,   754, -1017,   187,   857, -1017,
     473, -1017, -1017, -1017, -1017,   690, -1017,   757, -1017,   662,
     632,   632, -1017, -1017, -1017,   716,   781, -1017,  1027, -1017,
   -1017, -1017, -1017, -1017, -1017, -1017,   281,   981, -1017, -1017,
   -1017,   166,   325, -1017, -1017, -1017,    57, -1017, -1017, -1017,
   -1017, -1017,   918,   922,    70, -1017, -1017, -1017, -1017, -1017,
   -1017,   768,  1302, -1017, -1017, -1017, -1017,   724, -1017,   769,
     774, -1017, -1017, -1017,    93,   320,    49, -1017,   926, -1017,
    2227, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017,   927, -1017, -1017,   931, -1017, -1017, -1017, -1017,
   -1017,   717, -1017,   776, -1017, -1017, -1017,   775, -1017, -1017,
   -1017,   778, -1017, -1017, -1017, -1017, -1017, -1017,  1333, -1017,
   -1017,   780,   782,   783,   786, -1017, -1017, -1017, -1017,  1940,
     278, -1017,  2013, -1017,   130,   130,   130,    58, -1017,   788,
     656,   656, -1017,   281, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017,   716,   792,    70, -1017,   791,   345, -1017,   794,   473,
   -1017, -1017, -1017,   473,   787,  1472, -1017,  1064,   796,   798,
   -1017,   799, -1017,   724,  1940, -1017,   803,   804,   881,    93,
     806, -1017,   808, -1017,   322, -1017, -1017,   810, -1017,   811,
   -1017,   812,  1940,   961,   356, -1017,   816,  2476,   814, -1017,
   -1017, -1017,   743, -1017,   367, -1017, -1017,   386, -1017,   885,
     886,   888,   890,  1940, -1017,   894, -1017,   823,   397,   821,
     799,   724,  1940, -1017,  1940,  1940,   818,   830,   799, -1017,
   -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017,   743,   743,   743, -1017, -1017,   828,   829,
     831, -1017,   832,  1940, -1017, -1017, -1017, -1017,  1940, -1017,
      60, -1017,    57, -1017,  1940, -1017, -1017, -1017,   743, -1017,
     101, -1017, -1017,   833, -1017,   986, -1017, -1017, -1017,  1940,
     835, -1017,   837,   124,   498,  1940, -1017, -1017,   498,    70,
    1940, -1017, -1017,   150,   842,   843, -1017,  1129,   838, -1017,
     405,   961, -1017,  1940, -1017,   363, -1017, -1017, -1017, -1017,
   -1017,   634, -1017,   927, -1017,   931, -1017,   845,   847,   848,
     849,   850, -1017, -1017,  1940, -1017,  1940,   852, -1017,   851,
     989,   856,   862, -1017,  1940,   853,  1940,  1940,  1940,  1519,
    1540,  1587,  1652,   867, -1017, -1017, -1017, -1017, -1017,   865,
   -1017, -1017,  1025,   873, -1017, -1017,   422,   429,   894,   870,
   -1017,   699,   473, -1017,   876, -1017,   730, -1017, -1017, -1017,
   -1017,  1033,   880,   877, -1017, -1017,  1940,   879,  1940, -1017,
     882,   846, -1017, -1017,   961,   895,   304, -1017,  2012,  2012,
     961,   961, -1017,   214, -1017,  1940, -1017, -1017, -1017, -1017,
   -1017,  1040,  1040, -1017, -1017,  1720,  1767,  1829,  1940, -1017,
     419,   883, -1017, -1017, -1017,   891,    70,   884, -1017, -1017,
   -1017, -1017, -1017, -1017, -1017,  1940,   887,  1940,   893,  1940,
     896,   897,   904, -1017,   407,   905, -1017, -1017,  1051, -1017,
   -1017,   899, -1017,   903, -1017, -1017,  1940,  1940,   913,   142,
   -1017, -1017, -1017,  1860,   915,  2567,  1004,   920,  1940,  1940,
    1001, -1017,  1072, -1017,  1940,   932,     7,   941, -1017, -1017,
     961,   393,   929,  1940, -1017,   928, -1017, -1017, -1017,  1129,
    1129,   934,   933,  2384,    70,   433, -1017, -1017, -1017, -1017,
     439, -1017,   938,  1940,   939,  1940,   942,  1940,   943,   944,
   -1017,  1940, -1017,  1940,   364,   473,  1940,  1090,  1940,   473,
     473,   945,   940,   948,   950,   952,   957, -1017,   958, -1017,
   -1017, -1017, -1017,   894,   959,  1940, -1017, -1017, -1017,  1235,
    1235, -1017, -1017,   962, -1017,   724, -1017,  1065,  2591,  1940,
   -1017, -1017,  1940,   969,  2032,   967,  1002,  1003, -1017,   961,
   -1017,   961, -1017,  1005,   928,   481,  1940, -1017, -1017, -1017,
   -1017, -1017, -1017, -1017,  1040, -1017,  1040, -1017, -1017,   983,
     985,   988,   993,   990,   997,   998,  1081,  1000, -1017,   724,
   -1017, -1017, -1017,  1007, -1017, -1017, -1017,  1008, -1017,  1009,
   -1017,  1012, -1017, -1017,   536, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017,  1004, -1017, -1017, -1017,  1013, -1017,   498,  1940,
    1021, -1017,  1940,  1019,  1024,   448, -1017, -1017, -1017,   961,
    1028,  1940,   928,  1026, -1017, -1017,  1029,  1023, -1017,  1031,
   -1017,  1039, -1017, -1017, -1017, -1017,  1282, -1017, -1017,  1106,
    1940,  1041, -1017, -1017, -1017, -1017, -1017,  1099, -1017, -1017,
    1940,   243,  1011, -1017,   961,   961,   961, -1017,  1044, -1017,
    1042, -1017, -1017, -1017, -1017, -1017, -1017, -1017,   313, -1017,
     362, -1017, -1017, -1017, -1017, -1017, -1017, -1017,  1282,    57,
    1046,  1001,  1940,  1940,  1940,  2079,   220,   283, -1017, -1017,
    1940,  1047,  1004,  1940, -1017,   473,  1049, -1017,  1004,  1057,
    1054,  1055,   500,  1940,  1059, -1017,  1053,  1940,  1058,  1940,
    1061,   746, -1017, -1017, -1017, -1017, -1017,   473, -1017,  1940,
   -1017, -1017, -1017,  1069,   501, -1017,  1940,  1066,  1940,  1067,
    1940,   473, -1017,  1073,  1940,  1940,  1068,  1082,  1083,  1084,
    1086, -1017,  1940,  1088,   453,  1070,  1940, -1017,  1089, -1017,
    1091, -1017,  1071,  1940, -1017,  1940, -1017, -1017, -1017, -1017,
     477,   746,  1940, -1017,  1085,  1940,  1094,  1940,   483,  1940,
   -1017,  1096,  1940,  1098,  1940,  1100,  1940,  1101,  1940,  1108,
    1940,  1095, -1017
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,    14,     1,    18,    74,     0,    88,     3,     0,
      17,    14,    14,    14,    14,    14,    14,    14,    14,    14,
      22,     0,    30,    31,   148,   147,   142,   338,   361,   143,
     146,   144,   145,   362,     0,   410,   202,   205,   413,   414,
     359,   156,     0,     0,    33,   325,   327,    65,     0,   217,
     217,    15,     5,     4,    10,    11,    12,     6,     7,     8,
       9,    27,    19,    21,    23,    25,    75,   342,     0,   203,
     204,   412,   206,   207,   411,   365,     0,   155,     0,   406,
     407,     0,    97,    89,    94,     0,   312,   312,     0,     0,
     216,   199,     0,    22,     0,     0,     0,     0,     0,    39,
     344,   345,   343,     0,   348,   348,    32,   368,   360,     0,
     639,   689,   638,     0,   690,     0,    14,    14,     0,    14,
      14,    14,    14,    14,    14,    14,    14,     0,     0,    14,
      14,   156,   634,     0,   632,   637,   156,   409,     0,     0,
      92,    34,   310,   314,   311,   324,   156,   312,   321,   320,
     322,   323,     0,   313,   312,     0,    66,   185,     0,     0,
     200,   201,   195,   202,     0,   205,   191,     0,    20,    24,
      28,    26,    29,     0,    49,     0,   346,   347,   340,   156,
     366,   367,   364,   376,     0,   691,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   687,
       0,     0,     0,     0,   640,   155,   593,   592,   636,     0,
       0,     0,   152,    14,    14,    14,    14,    14,    14,    14,
      14,    14,    14,    14,    14,    14,    14,    14,    14,    14,
      14,    14,    14,    14,    14,    14,    14,    14,    14,     0,
      14,   158,   157,     0,    90,    93,    95,    39,   315,   319,
     316,   333,     0,   329,   332,   317,     0,     0,   211,     0,
       0,   198,   193,   196,   219,    16,    36,    14,     0,   353,
      54,   349,   341,   376,   369,     0,   380,   692,     0,     0,
       0,     0,   657,   658,   659,   660,   655,   656,   679,   680,
     644,     0,     0,     0,   646,   648,   683,     0,     0,   153,
     154,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   408,   437,     0,    49,     0,   326,     0,   318,
     328,    69,   215,     0,   187,     0,   219,   197,   220,     0,
      14,    57,     0,    48,   112,    54,    51,    78,     0,   351,
      53,     0,   363,   370,   374,     0,   372,   379,   348,   348,
     377,     0,   378,     0,     0,     0,     0,   635,     0,   687,
     688,     0,   152,   601,   150,   151,   149,   682,   681,   651,
     652,   653,   654,   649,   650,   667,   668,   669,   670,   665,
     666,   671,   672,   661,   662,   663,   664,   673,   674,   675,
     676,   677,   678,     0,     0,     0,     0,    96,     0,   330,
     331,    14,   209,   214,     0,   186,   211,     0,     0,   218,
      14,   230,     0,    37,    40,    47,    56,     0,     0,   114,
       0,   115,   125,   156,    14,     0,    14,   352,   350,   339,
     156,     0,   371,   383,   156,   381,   684,   642,   643,   685,
       0,     0,     0,    54,   600,   602,   604,   686,     0,   440,
     425,   429,     0,   163,   477,     0,    68,    73,    72,    71,
      70,   208,   213,   210,     0,   189,   230,   112,    54,   223,
       0,    14,    43,    45,    14,     0,     0,    58,    60,    64,
     116,   117,   118,   125,   124,   123,     0,     0,    52,    50,
     156,    76,     0,   109,   112,    77,    87,    79,    80,    82,
      83,    85,    81,    84,    86,   375,   373,   384,   365,     0,
     647,   156,   591,    53,     0,   633,     0,     0,   438,   441,
       0,     0,    91,    14,     0,    67,   212,   188,   211,    14,
     156,    14,   221,   156,   228,     0,   192,     0,   112,   531,
      14,   534,   535,   533,   536,     0,   532,     0,   229,     0,
     312,   312,    41,    38,    55,    56,   127,   122,   132,   138,
     137,   136,   130,   139,   135,   141,   121,   128,   134,   140,
      62,     0,     0,   335,   483,   108,     0,   455,   462,   456,
     453,   454,     0,     0,   156,   460,   457,   382,   645,   603,
     641,     0,   440,   436,    14,   430,   622,   477,   624,     0,
       0,   564,   565,   566,   233,   270,     0,   607,     0,   162,
     112,   179,   176,   159,   181,   164,   165,   182,   170,   166,
     167,   169,     0,   174,   175,     0,   171,   172,   168,   173,
     177,     0,   180,     0,   160,   161,   476,     0,   194,   225,
     224,     0,   401,   478,   100,   101,   102,   103,     0,   542,
     544,     0,     0,     0,     0,   563,   561,   562,   539,     0,
     156,   594,     0,   537,   482,   482,   482,   482,   538,     0,
       0,     0,    61,   121,   126,   131,   133,   119,   120,   113,
     129,    56,     0,   156,   334,     0,     0,   403,     0,    14,
     391,   393,   388,    14,   469,     0,   439,   447,     0,   444,
     445,   599,    35,   477,     0,   615,     0,     0,     0,   233,
       0,   308,     0,   257,   270,   259,   260,     0,   261,     0,
     262,     0,     0,     0,     0,   266,     0,    14,     0,   415,
     419,   420,   109,   356,     0,   354,   387,     0,   385,     0,
       0,     0,     0,     0,   190,     0,   222,     0,     0,    98,
     599,   477,     0,   547,     0,     0,     0,   596,   599,   512,
     513,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   109,   109,   109,   481,   480,     0,     0,
       0,   501,     0,     0,    44,    46,   111,    63,     0,   336,
       0,   484,     0,   402,     0,   463,   395,   395,   109,   461,
       0,   458,   442,     0,   452,     0,   448,   426,    14,   601,
       0,   625,     0,     0,   248,     0,   231,   232,   248,   156,
       0,   256,   258,     0,     0,     0,   271,     0,     0,   305,
       0,     0,   263,     0,   178,   112,   609,   605,   608,   606,
     183,   437,   417,     0,   357,     0,   358,     0,     0,     0,
       0,     0,   226,   104,     0,   105,     0,     0,   545,     0,
     112,     0,     0,   595,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   337,   492,   493,   494,   486,    54,
     488,   491,     0,     0,   404,   405,     0,     0,     0,     0,
     468,     0,    14,   443,   451,   446,    54,   623,   607,   618,
     611,     0,     0,     0,   246,   247,     0,     0,     0,   309,
       0,   306,   279,   280,     0,     0,   295,   296,     0,     0,
       0,     0,   302,     0,   301,     0,   264,   267,   268,   610,
     163,     0,   434,   355,   386,     0,     0,     0,     0,   620,
       0,     0,   543,   571,   555,     0,   156,     0,   551,   553,
     597,   541,   514,   511,   515,     0,     0,     0,     0,     0,
       0,     0,     0,   558,    53,     0,   490,   485,     0,   392,
     394,   389,   397,   399,   466,   467,     0,     0,     0,     0,
     470,   475,   459,     0,     0,    14,   627,   612,     0,     0,
     241,   238,     0,   269,     0,     0,   295,     0,   293,   294,
       0,   295,   287,     0,   272,   275,   273,   299,   300,     0,
       0,     0,     0,    14,   425,     0,   421,   423,   424,   433,
       0,   431,     0,     0,     0,     0,     0,     0,     0,     0,
     581,     0,   106,     0,    14,    14,     0,     0,     0,    14,
      14,     0,     0,     0,     0,     0,     0,   500,     0,   569,
     489,   487,   396,     0,     0,     0,   473,   474,   465,     0,
       0,   464,   450,     0,   598,   477,   629,   631,    14,     0,
     614,   616,     0,     0,     0,     0,     0,     0,   287,     0,
     289,     0,   288,     0,     0,   306,     0,   276,   303,   304,
     298,   265,   184,   427,     0,   416,   434,   418,    14,     0,
       0,     0,     0,     0,     0,     0,   582,     0,    99,   477,
     570,   556,   528,   529,   548,   552,   554,     0,   495,     0,
     496,     0,   502,   499,   576,   398,   390,   400,   471,   472,
     449,   626,   627,   619,   628,   613,     0,   240,   248,     0,
       0,   242,     0,     0,     0,     0,   291,   297,   290,     0,
       0,     0,   277,     0,   422,   432,     0,     0,   504,     0,
     505,     0,   509,   508,   621,   580,     0,   107,   546,   574,
       0,     0,   497,   498,   503,   567,   568,   577,   630,    14,
       0,     0,     0,   307,     0,     0,     0,   284,     0,   274,
       0,   278,    14,   435,   506,   507,   510,   588,   586,   583,
       0,   589,   572,   557,   530,    14,   559,   575,     0,     0,
       0,   241,     0,     0,     0,     0,   295,   295,   292,   281,
       0,     0,   627,     0,   585,    14,     0,   578,   627,     0,
       0,     0,     0,     0,     0,   249,   254,     0,     0,     0,
       0,   307,   428,   584,   590,   573,   549,    14,   617,     0,
     245,   244,   243,     0,   254,   234,     0,     0,     0,     0,
       0,    14,   579,   237,     0,     0,     0,     0,     0,     0,
       0,   550,     0,     0,     0,     0,     0,   286,     0,   283,
       0,   236,     0,     0,   250,     0,   255,   285,   282,   235,
       0,   255,     0,   251,     0,     0,     0,     0,     0,     0,
     252,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   253
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1017, -1017, -1017,   767,    55, -1017, -1017,    92, -1017, -1017,
    1173, -1017,  1093,   -18,    24, -1017, -1017, -1017,  1022, -1017,
   -1017, -1017,   777, -1017, -1017,   935, -1017,  -346,  -493,   824,
   -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017, -1017,  -417, -1017, -1017, -1017, -1017, -1017,
   -1017,   -89,  -820,  -455,  -272, -1017, -1017,   392, -1017,  -241,
   -1017,   580,   772, -1017,   703, -1017,  -116,    50, -1017,  -125,
    -123,   -17,  -410,   324,  -539, -1017, -1017,  -420, -1017, -1017,
   -1017, -1017, -1017, -1017, -1017,  1113,  1116,   801,  -361, -1017,
    1234,   946, -1017, -1017, -1017,   740, -1017, -1017,   813, -1017,
     565, -1017, -1017, -1017,    71, -1017,  -833, -1017,   980, -1017,
   -1017,   569,  -500, -1017,   561,   459, -1017, -1017, -1017,   370,
   -1004, -1017, -1017, -1017,   377, -1017,   108,  -973,  -874, -1009,
   -1017,  -355, -1017,   369,  -794,  -486, -1017,   288, -1017, -1017,
   -1017, -1017, -1017, -1017,   -59,     1, -1017,    20, -1017,  1161,
    -295, -1017,   871, -1017,   617,  1312, -1017, -1017,    28,    29,
     -60, -1017,   963, -1017, -1017,   463, -1017, -1017,  1313, -1017,
     951,   793, -1017, -1017, -1017,  1060, -1017,   889, -1017, -1017,
   -1017, -1017, -1017, -1017, -1017, -1017,   462,  -406, -1017, -1017,
   -1017, -1017,   511, -1017,   258,  -448,   902, -1017,   518,  1254,
      74, -1017, -1017, -1017, -1017, -1017, -1017, -1017,  -889,  -298,
   -1017, -1017, -1017, -1017, -1017,   218, -1017,   474, -1017,   729,
    -994, -1017,   514, -1017, -1017,   907, -1017, -1017, -1017, -1017,
   -1017, -1017,  -399,  -570,  -536,    69, -1017, -1017, -1017, -1017,
   -1017,   361,   445, -1017, -1017, -1017,  -989, -1017, -1017,  -550,
   -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017,   785, -1017, -1017, -1017, -1017, -1017, -1017,
   -1017, -1017, -1017, -1017, -1017, -1017,   122, -1017,  -439,  -547,
     467,  -353,   526, -1017,   825,   438,   269,   440, -1017,  -516,
   -1017, -1017, -1017, -1017, -1017,  -517, -1017, -1017, -1016, -1017,
   -1017,   -76,  2028, -1017,   391,   -68
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,     2,     8,   558,    10,    51,   559,    20,    94,
      62,    63,    64,   131,   145,    12,    85,   247,   174,   350,
     495,   433,   434,   570,   571,   268,   355,   361,   497,   356,
     436,   437,   575,   701,    13,    88,   257,   421,   476,    14,
      21,    99,   446,   515,    15,    43,   138,   333,    83,   140,
     245,    84,   768,   560,   596,   439,   440,   441,   442,   604,
     503,   699,   506,   693,   586,   587,   588,   102,    37,    77,
     241,   242,   243,   543,   856,   634,   950,    16,   258,   426,
     548,   264,   346,   164,   165,    71,    74,   423,   343,   424,
      91,   349,   430,   661,   488,   489,   765,   490,   491,   636,
     728,   729,  1293,   730,  1093,  1160,   926,  1254,  1255,   637,
     734,   735,   638,   743,   744,   745,   737,   738,   739,  1024,
    1107,   934,   844,   845,   935,  1021,  1165,  1022,   936,  1166,
     740,   942,   943,   848,   944,  1167,   839,   146,   147,   148,
     249,   149,   150,   151,   152,   561,    86,   562,    87,   252,
     253,   254,   641,   592,   593,   642,    67,   103,   153,   154,
     178,   270,   271,   359,   754,   755,   643,   644,   645,    75,
      40,   108,   109,   182,   273,   274,   365,   366,   450,   275,
     276,   370,   371,   528,   372,   757,   758,   563,   818,  1074,
     816,   817,   906,   991,   992,   993,   647,   706,   707,    81,
     564,    41,    42,   649,   861,   952,   752,  1035,  1039,  1037,
     540,  1038,  1173,   472,  1040,  1041,  1042,   416,   537,   538,
     718,   719,   720,   605,   606,   650,   714,   912,   713,   709,
     821,   999,  1000,   545,   565,   798,   524,   705,   903,   811,
     899,   900,   901,   902,   566,   652,   567,   795,   967,   568,
     778,   770,   771,   963,   880,  1191,  1281,  1059,  1060,  1055,
    1189,  1069,   569,   653,  1144,  1054,  1223,  1245,  1197,  1227,
    1228,  1267,  1126,  1185,  1186,  1242,  1219,  1220,   132,   682,
     776,   830,   463,   464,   465,   747,   857,   922,   923,   858,
     833,  1156,  1006,  1050,   721,  1086,   723,   918,  1087,  1088,
    1153,  1256,   134,   298,   200,   135
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     133,   477,    65,    17,   633,   928,   205,   651,   206,   445,
     683,   205,    17,    17,    17,    17,    17,    17,    17,    17,
      17,   171,    18,   532,    78,    82,   655,   654,   155,   516,
      35,    18,    18,    18,    18,    18,    18,    18,    18,    18,
     520,   419,   554,  1098,   527,   179,   930,   722,  1102,   708,
     246,   198,   199,   731,   960,   435,    36,     9,   595,   948,
    1016,    61,  1036,   208,   895,   484,     9,     9,     9,     9,
       9,     9,     9,     9,     9,    65,    19,    65,   796,   157,
     299,   300,   692,   351,   251,    19,    19,    19,    19,    19,
      19,    19,    19,    19,    11,   104,   105,   726,   896,   897,
    1170,   351,  -227,    11,    11,    11,    11,    11,    11,    11,
      11,    11,    69,   443,   207,   162,   300,   534,   471,   681,
      96,    82,   909,   635,  1176,   736,   632,   297,   920,   248,
     339,   474,     3,   301,   302,   303,  1198,   646,   347,   741,
     746,   163,   552,   662,  1025,  1025,  1100,   238,   239,   727,
     796,   797,   702,   831,   731,  1018,  1019,   681,    72,   815,
    1208,   336,   272,   819,  1020,  1097,   337,   176,  1211,    96,
      61,   187,   188,    70,   190,   191,   192,   193,   194,   195,
     196,   197,   111,   180,   201,   202,   204,   657,   113,    66,
     114,   664,   665,   666,    96,     6,  1237,  1238,   -14,   435,
      68,   878,   373,   374,   375,   376,  1079,   921,   807,    96,
    1230,   651,   932,   933,   742,   378,   379,   379,  1241,    73,
     801,   898,   377,   797,   679,  1174,  1263,  1168,   177,  1104,
     859,  1127,  1268,   158,   736,    76,  1246,   -42,   352,   159,
     353,   -42,    79,   615,   181,   417,   550,    98,   741,   492,
     493,   910,    80,  -239,   413,   414,   352,   746,   -53,   -53,
      28,   911,   420,  1258,  1260,   708,    89,    33,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,  1029,   331,    98,   595,   142,  1080,
     367,   336,   203,  1081,   368,   369,   340,   466,   453,   454,
      96,  1257,  1172,   510,   667,    90,    82,   872,   511,   512,
      97,    98,   354,   -13,   731,  1200,   731,   635,   697,   205,
     632,    93,   513,    95,  1232,  1233,    98,   -14,   595,   595,
     595,   646,   203,   555,   106,   292,     4,   668,   209,   210,
     141,  -479,  -479,  -479,  -479,   293,     5,   937,     4,   144,
     482,   451,  1002,   595,   483,   746,   452,   749,  1018,  1019,
     750,  1030,   555,   681,  1259,  1031,   732,  1206,   732,     6,
    -479,  -479,  -479,  -479,   529,   209,   210,     4,   137,   698,
      45,    46,   535,   539,   107,   804,   805,   733,   626,   841,
     626,  -110,  -110,  -110,   290,   432,   205,  1234,   206,   556,
       7,   895,   597,   598,   599,   600,   601,   877,     6,  1129,
     574,   211,   478,   212,    48,   885,   507,   751,   205,   929,
       6,  1018,  1019,   525,    49,   250,    50,    98,  -540,   139,
    -540,   479,   255,   203,   531,   896,   897,   517,   937,     7,
     602,   603,  1018,  1019,  1027,  1028,   156,   466,   211,     6,
     382,  1020,   696,  1277,   555,  1279,   518,   504,   505,   651,
    -587,   700,  -479,  -479,  -479,  -479,   475,  -587,   541,     4,
     862,   555,   703,   542,  1288,   487,  1290,   704,   859,  -479,
    -479,  -479,  -479,   591,   633,   480,     4,   651,   557,   354,
     111,   514,   812,   166,  1130,  1131,   113,   813,   114,  1135,
    1136,   690,   691,   851,   207,  1151,   655,   654,   852,  1243,
     522,   886,   887,   888,   863,   949,  1244,   557,   658,   864,
     585,   612,   168,   659,   937,   613,   539,    45,    46,   170,
     680,  1018,  1019,   865,   639,   172,   908,   173,   866,   432,
    1101,     6,   651,   985,   874,   205,   589,   206,   875,  1188,
     924,   925,   851,   640,   100,   101,    26,   946,     6,   175,
    1004,    48,    44,   531,    45,    46,  1051,    47,   531,   988,
    1052,    49,   183,    50,   989,   635,   988,   712,   632,   184,
    1114,   990,   769,    22,    23,  1115,  1116,   185,   630,   646,
     585,  1117,   585,   777,   290,  1206,   487,   291,    48,  1207,
    1303,   585,   186,   635,  1304,   937,   632,   648,    49,   557,
      50,  1195,  1196,    24,    25,    26,   589,   646,   589,    29,
      30,    31,    32,   189,  1312,   631,   557,   589,  1313,   823,
    1319,   826,   290,   244,  1320,  1171,    22,    23,   832,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     251,  1272,   290,   207,   460,  1285,   849,   259,   635,   717,
     260,   632,   262,    27,  1108,  1109,   100,   101,    26,   142,
    1148,  1149,   646,   380,   381,    28,   591,   871,    29,    30,
      31,    32,    33,   265,   266,  1265,   879,   267,   881,   882,
     269,   277,   110,    61,   111,   112,   684,   685,   686,   687,
     113,   278,   114,   279,   205,   280,   143,  1282,  -110,  -110,
    -110,   995,   235,   236,   237,   238,   239,   893,   621,   622,
     623,  1291,   894,   759,   760,   761,   762,   281,   905,    34,
     144,    29,    30,    31,    32,   332,   115,   330,   639,   500,
     501,   502,   294,   466,   799,   800,   802,   334,   341,   927,
     338,   996,   997,   342,   931,   344,   345,   640,   357,   348,
     358,   931,   360,   362,   364,   422,   383,   931,    52,    53,
      54,    55,    56,    57,    58,    59,    60,   384,   116,   117,
     681,   385,    34,   386,   531,    22,    23,   415,   769,   425,
     961,   427,   855,   429,   -59,   431,   438,   118,   777,   444,
     972,   973,   974,   976,   978,   980,   982,   578,   449,   456,
     457,   648,   579,   580,   581,   582,   583,    26,   458,   119,
     120,   121,   122,   123,   124,  1001,   459,   460,   292,   631,
     233,   234,   235,   236,   237,   238,   239,   125,   126,   998,
    1010,   461,  1012,   462,   239,   468,   467,   469,   470,   127,
     473,    61,   931,   931,   584,   481,   128,   669,   485,   849,
     129,   130,   486,  -227,   496,   494,   498,   530,   499,  1044,
    1046,  1048,  1049,   717,    45,    46,   509,   533,   544,   547,
      29,    30,    31,    32,   551,  -110,  -110,  -110,   553,  1061,
     573,  1063,   577,  1065,   590,   594,   557,   608,   610,  1113,
     611,   670,   614,   671,   656,   672,   673,   674,   663,   688,
    1076,  1077,   710,  -560,  -560,  -560,   711,  1083,   715,   724,
     748,   753,  1090,  1091,   725,   756,   763,   764,  1095,   766,
     772,    34,   773,   774,   602,   603,   775,  1105,   803,  1057,
     808,   810,   814,   931,   931,   828,   820,   827,   836,   829,
     675,   676,   677,   834,   835,   731,   838,  1119,   840,  1121,
     843,  1123,   847,   846,   853,   769,   860,  1128,   867,   868,
    1132,   869,  1134,   870,   873,   876,   883,   884,   889,   890,
     914,   891,   892,   965,   913,    22,    23,   917,   919,  1147,
     938,   939,   945,  1001,  1001,   955,   639,   956,   957,   958,
    1014,   959,   964,  1155,   962,   971,  1157,   968,  1161,   678,
      22,    23,   984,   969,   679,   640,   583,    26,   983,   895,
     931,   994,    22,    23,   639,   987,  1003,   920,  1008,  1009,
    1011,    22,    23,  1013,  1034,  1017,  1058,  1053,  1062,  1056,
     160,   161,    26,   640,  1064,  1072,  1073,  1066,   618,  1067,
     855,  1075,   100,   101,    26,  1068,  1071,   110,    61,   111,
     112,   695,   583,    26,  1078,   113,  1084,   114,  1089,   648,
    1092,  1094,  1096,  1201,  1099,  1106,  1203,  1103,   630,   639,
      29,    30,    31,    32,  1133,  1210,  1110,   631,  1118,  1111,
    1120,   824,  1138,  1122,  1124,  1125,  1137,   648,   640,  1139,
    1221,   115,  1140,  1141,  1224,    29,    30,    31,    32,  1142,
    1143,  1146,  1152,  1150,  1231,   631,  1158,    29,    30,    31,
      32,  1162,   110,    61,   111,   112,    29,    30,    31,    32,
     113,    34,   114,   855,  1177,  1163,  1164,  1178,  1169,  1179,
    1184,  1181,  1221,   116,   117,  1180,  1250,  1251,  1252,  1182,
    1183,  1187,   648,  1222,  1261,  1190,    34,  1264,  1226,  1235,
    1192,  1193,   118,   717,  1194,  1199,   115,  1274,    34,  1204,
     631,   931,  1202,   931,  1205,  1214,  1212,    34,   169,  1209,
    1213,   940,   941,  1215,   119,   120,   121,   122,   123,   124,
    1286,  1216,   931,  1225,   931,  1239,  1240,  1248,  1262,  1295,
    1266,   531,   125,   126,  1269,  1270,  1271,  1276,   116,   117,
    1306,  1275,  1278,   825,   127,  1280,  1284,  1287,  1289,  1311,
    1292,   128,  1296,  1309,  1305,   129,   130,   118,   110,    61,
     111,   112,  1315,  1297,  1298,  1299,   113,  1300,   114,  1302,
    1307,  1317,  1308,  1322,  1229,  1324,  1332,  1326,  1328,   119,
     120,   121,   122,   123,   124,  1330,   167,   717,   508,   335,
     418,   572,   966,   806,  1033,   576,   261,   125,   126,   694,
    1229,   263,   115,   546,    92,   110,    61,   111,   112,   127,
    1217,   660,   428,   113,   837,   114,   128,   996,   997,   549,
     129,   130,  1249,   842,   850,   110,    61,   111,   112,  1026,
     947,  1015,  1236,   113,  1032,   114,   256,   519,    38,    39,
     809,   607,   455,   448,   116,   117,   953,   954,   907,   115,
     904,  1145,   136,   363,  1175,   951,   110,    61,   111,   112,
     526,   716,   915,   118,   113,  1070,   114,   986,   521,   115,
    1247,   970,  1218,   523,   689,   916,  1005,  1154,   609,     0,
       0,  1007,     0,     0,     0,   119,   120,   121,   122,   123,
     124,   116,   117,     0,     0,     0,     0,     0,     0,     0,
     115,     0,     0,   125,   126,     0,     0,     0,     0,     0,
     118,   116,   117,     0,     0,   127,     0,     0,     0,     0,
       0,     0,   128,     0,     0,     0,   129,   130,     0,     0,
     118,     0,   119,   120,   121,   122,   123,   124,     0,     0,
       0,     0,   116,   117,     0,     0,     0,     0,     0,     0,
     125,   126,   119,   120,   121,   122,   123,   124,     0,     0,
       0,   118,   127,     0,     0,     0,     0,     0,     0,   128,
     125,   126,     0,   129,   130,     0,     0,     0,     0,     0,
     767,   536,   127,   119,   120,   121,   122,   123,   124,   128,
       0,     0,     0,   129,   130,   110,    61,   111,   112,     0,
       0,   125,   126,   113,     0,   114,     0,     0,     0,     0,
       0,     0,     0,   127,     0,     0,     0,     0,     0,     0,
     128,     0,     0,     0,   129,   130,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,    46,     0,     0,   115,
       0,     0,   110,    61,   111,   112,  -110,  -110,  -110,     0,
     113,     0,   114,     0,     0,     0,     0,   597,   598,   599,
     600,   601,     0,   110,    61,   111,   112,     0,     0,     0,
       0,   113,     0,   114,     0,     0,     0,     0,     0,     0,
       0,   116,   117,     0,     0,     0,   115,     0,     0,     0,
       0,     0,     0,     0,     0,   602,   603,     0,     0,     0,
     118,     0,     0,     0,     0,     0,     0,   115,     0,     0,
     110,    61,   111,   112,     0,     0,     0,     0,   113,     0,
     114,     0,   119,   120,   121,   122,   123,   124,   116,   117,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   975,
     125,   126,     0,     0,     0,     0,     0,   118,     0,   116,
     117,     0,   127,   822,   115,     0,     0,     0,     0,   128,
     977,     0,     0,   129,   130,     0,     0,     0,   118,   119,
     120,   121,   122,   123,   124,   110,    61,   111,   112,     0,
       0,     0,     0,   113,     0,   114,     0,   125,   126,     0,
     119,   120,   121,   122,   123,   124,   116,   117,     0,   127,
       0,     0,     0,     0,     0,     0,   128,   979,   125,   126,
     129,   130,     0,     0,     0,   118,     0,     0,     0,   115,
     127,     0,     0,     0,     0,     0,     0,   128,     0,     0,
       0,   129,   130,     0,     0,     0,     0,   119,   120,   121,
     122,   123,   124,   110,    61,   111,   112,     0,     0,     0,
       0,   113,     0,   114,     0,   125,   126,     0,     0,     0,
       0,   116,   117,     0,     0,     0,     0,   127,     0,     0,
       0,     0,     0,     0,   128,     0,     0,     0,   129,   130,
     118,     0,     0,     0,     0,     0,     0,   115,     0,     0,
     110,    61,   111,   112,     0,     0,     0,     0,   113,     0,
     114,     0,   119,   120,   121,   122,   123,   124,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     125,   126,     0,     0,     0,     0,     0,     0,     0,   116,
     117,     0,   127,   981,   115,     0,     0,     0,     0,   128,
    1043,     0,     0,   129,   130,     0,     0,     0,   118,     0,
       0,     0,   110,    61,   111,   112,     0,     0,     0,     0,
     113,     0,   114,     0,     0,     0,     0,     0,     0,     0,
     119,   120,   121,   122,   123,   124,   116,   117,     0,     0,
       0,     0,     0,   110,    61,   111,   112,  1045,   125,   126,
       0,   113,     0,   114,     0,   118,   115,     0,     0,     0,
     127,     0,     0,     0,     0,     0,     0,   128,     0,     0,
       0,   129,   130,     0,     0,     0,     0,   119,   120,   121,
     122,   123,   124,     0,     0,     0,     0,   115,     0,     0,
       0,     0,     0,     0,     0,   125,   126,     0,   116,   117,
       0,     0,     0,     0,     0,     0,     0,   127,     0,  1047,
       0,     0,     0,     0,   128,     0,     0,   118,   129,   130,
       0,     0,     0,   110,    61,   111,   112,     0,     0,   116,
     117,   113,     0,   114,     0,     0,     0,     0,     0,   119,
     120,   121,   122,   123,   124,     0,     0,     0,   118,     0,
       0,     0,     0,     0,     0,     0,     0,   125,   126,     0,
       0,     0,     0,     0,     0,     0,     0,   115,     0,   127,
     119,   120,   121,   122,   123,   124,   128,     0,     0,     0,
     129,   130,     0,     0,     0,     0,     0,     0,   125,   126,
       0,     0,     0,     0,     0,   110,    61,   111,   112,     0,
     127,  1082,     0,   113,     0,   114,     0,   128,     0,   116,
     117,   129,   130,     0,     0,   110,    61,   111,   112,     0,
       0,     0,     0,   113,     0,   114,     0,     0,   118,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   115,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     119,   120,   121,   122,   123,   124,     0,     0,     0,   115,
       0,     0,   110,    61,   111,   112,     0,     0,   125,   126,
     113,     0,   114,     0,     0,     0,     0,     0,     0,     0,
     127,   116,   117,     0,     0,     0,     0,   128,     0,     0,
       0,   129,   130,     0,   779,   780,     0,     0,     0,     0,
     118,   116,   117,     0,     0,     0,   115,   781,   782,   783,
     784,   785,   786,   787,   788,   789,   790,   791,   792,     0,
     118,     0,   119,   120,   121,   122,   123,   124,     0,     0,
       0,     0,     0,     0,   793,     0,     0,     0,     0,     0,
     125,   126,   119,   120,   121,   122,   123,   124,   116,   117,
       0,   794,  1023,     0,     0,     0,     0,     0,     0,   128,
     125,   126,     0,   129,   130,     0,     0,   118,     0,     0,
       0,     0,  1159,     0,     0,     0,     0,     0,     0,   128,
       0,     0,     0,   129,   130,     0,     0,     0,     0,   119,
     120,   121,   122,   123,   124,     0,     0,     0,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   125,   126,   295,
     296,   749,     0,  1273,   750,     0,     0,     0,     0,  1253,
       0,     0,     0,     0,     0,     0,   128,     0,     0,  1283,
     129,   130,     0,     0,    45,    46,     0,     0,     0,     0,
       0,     0,     0,     0,  1294,  -110,  -110,  -110,     0,     0,
       0,     0,  1301,     0,     0,     0,   597,   598,   599,   600,
     601,     0,     0,  1310,     0,     0,     0,     0,    48,     0,
       0,   751,  1314,     0,     0,  1316,     0,  1318,    49,  1321,
      50,     0,  1323,     0,  1325,     0,  1327,     0,  1329,     0,
    1331,     0,     0,     0,   602,   603,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,     0,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   555,     0,
     616,     0,     0,     0,     0,     0,  -479,  -479,  -479,  -479,
       0,     0,     0,     4,     0,     0,   617,     0,     0,   510,
       0,     0,     0,     0,     0,     0,   447,     0,     0,     0,
       0,     0,   555,     0,   616,     0,     0,     0,   513,     0,
    -479,  -479,  -479,  -479,   618,     0,   619,     4,   620,     0,
       0,     0,     0,   510,     0,     0,   621,   622,   623,     0,
       0,     0,     0,     0,     0,   624,   625,     0,   626,     0,
       0,   627,   513,     0,     0,     0,     0,     0,   618,     0,
     619,     0,   620,     0,    27,     6,     0,     0,   628,     0,
     621,   622,   623,     0,     0,     0,    28,     0,     0,   624,
     625,     0,   626,    33,     0,   627,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     7,     0,    27,     6,
       0,     0,   628,  1112,   555,     0,   616,     0,     0,     0,
      28,     0,  -479,  -479,  -479,  -479,     0,    33,     0,     4,
       0,     0,     0,     0,     0,   510,     0,     0,     0,     0,
       7,     0,   629,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   513,     0,     0,     0,     0,     0,
     618,     0,   619,     0,   620,     0,     0,     0,     0,     0,
       0,     0,   621,   622,   623,     0,   629,     0,     0,     0,
       0,   624,   625,     0,   626,     0,     0,   627,   854,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      27,     6,     0,     0,   628,   555,     0,   616,     0,     0,
       0,     0,    28,  -479,  -479,  -479,  -479,     0,     0,    33,
       4,     0,     0,     0,     0,     0,   510,     0,     0,   555,
       0,   616,     7,     0,     0,     0,     0,  -479,  -479,  -479,
    -479,     0,     0,     0,     4,   513,     0,     0,     0,     0,
     510,   618,  1085,   619,     0,   620,     0,     0,     0,     0,
       0,     0,     0,   621,   622,   623,     0,     0,     0,   513,
       0,     0,   624,   625,     0,   626,     0,   619,   627,   620,
       0,     0,     0,     0,     0,     0,     0,   621,   622,   623,
       0,    27,     6,     0,     0,   628,   624,   625,     0,   626,
       0,     0,   627,    28,     0,     0,     0,     0,     0,     0,
      33,     0,     0,     0,     0,    27,     6,     0,     0,   628,
       0,     0,     0,     7,     0,     0,     0,    28,     0,     0,
       0,     0,     0,     0,    33,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     7,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     240,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239
};

static const yytype_int16 yycheck[] =
{
      76,   421,    20,     2,   543,   838,   131,   543,   131,   355,
     560,   136,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    97,     2,   462,    41,    43,   543,   543,    87,   446,
       6,    11,    12,    13,    14,    15,    16,    17,    18,    19,
     446,   336,   490,  1016,   454,   105,   840,   617,  1021,   596,
     139,   127,   128,     4,   874,   350,     6,     2,   513,   853,
     934,     4,   951,   131,     4,   426,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    93,     2,    95,    20,     4,
     205,   206,   575,     4,     4,    11,    12,    13,    14,    15,
      16,    17,    18,    19,     2,    67,    67,     4,    38,    39,
    1104,     4,     4,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    47,   354,   131,    91,   241,   463,   416,   558,
      32,   139,    21,   543,  1118,   625,   543,   203,     4,   146,
     255,    31,     0,   209,   210,   211,  1152,   543,   263,   625,
     626,    91,   488,   553,   938,   939,  1020,   153,   154,    56,
      20,    93,   591,   723,     4,   148,   149,   596,    47,   709,
    1169,   157,   179,   713,   157,   158,   162,    47,  1172,    32,
       4,   116,   117,   108,   119,   120,   121,   122,   123,   124,
     125,   126,     5,    47,   129,   130,   131,   548,    11,     4,
      13,     4,     5,     6,    32,    95,  1205,  1206,    21,   494,
      14,   771,   278,   279,   280,   281,    64,    83,   701,    32,
    1199,   747,    62,    63,   165,   291,   292,   293,  1212,   108,
     162,   161,   290,    93,   167,  1114,  1242,  1101,   108,  1023,
     747,  1051,  1248,   158,   734,   165,  1225,   157,   159,   164,
     161,   161,     4,   541,   108,   334,   487,   159,   734,    27,
      28,   150,    14,   160,   330,   331,   159,   743,   161,   161,
     106,   160,   338,  1236,  1237,   812,     4,   113,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,    80,   240,   159,   752,    47,   157,
     276,   157,   165,   161,   276,   276,   162,   383,   368,   369,
      32,    91,  1106,    29,   127,    65,   334,   765,    34,    35,
     158,   159,   267,     0,     4,  1158,     4,   747,    47,   454,
     747,    21,    48,   157,    91,    92,   159,   160,   793,   794,
     795,   747,   165,     8,   161,   157,    23,   160,    91,    92,
       4,    16,    17,    18,    19,   167,    33,   843,    23,   108,
     157,   157,   912,   818,   161,   851,   162,     4,   148,   149,
       7,   157,     8,   812,    91,   161,    56,   157,    56,    95,
      16,    17,    18,    19,   460,    91,    92,    23,   162,   108,
      27,    28,   468,   469,   107,   690,   691,    77,    78,    77,
      78,    38,    39,    40,   161,   350,   531,   164,   531,    74,
     126,     4,    49,    50,    51,    52,    53,   770,    95,    55,
     496,   164,   421,   166,    61,   778,   443,    64,   553,   839,
      95,   148,   149,   450,    71,   147,    73,   159,   160,   164,
     162,   421,   154,   165,   462,    38,    39,   446,   934,   126,
      87,    88,   148,   149,   940,   941,     4,   533,   164,    95,
     166,   157,   578,  1257,     8,  1259,   446,    96,    97,  1005,
     157,   587,    16,    17,    18,    19,   421,   164,   157,    23,
     752,     8,   157,   162,  1278,   430,  1280,   162,  1005,    16,
      17,    18,    19,   510,  1033,   421,    23,  1033,   163,   444,
       5,   446,   157,     4,  1054,  1055,    11,   162,    13,  1059,
    1060,   570,   571,   157,   531,  1085,  1033,  1033,   162,   157,
     446,   793,   794,   795,   157,   162,   164,   163,    72,   162,
     506,   157,    24,   550,  1020,   161,   612,    27,    28,     4,
     558,   148,   149,   157,   543,     4,   818,   163,   162,   494,
     157,    95,  1088,   899,   157,   680,   506,   680,   161,  1129,
      62,    63,   157,   543,    44,    45,    46,   162,    95,   167,
     916,    61,    25,   591,    27,    28,   157,    30,   596,   157,
     161,    71,   167,    73,   162,  1005,   157,   604,  1005,    11,
     157,   162,   668,    14,    15,   162,   157,    12,   543,  1005,
     576,   162,   578,   679,   161,   157,   551,   164,    61,   161,
     157,   587,   154,  1033,   161,  1101,  1033,   543,    71,   163,
      73,    85,    86,    44,    45,    46,   576,  1033,   578,   109,
     110,   111,   112,   154,   157,   543,   163,   587,   161,   715,
     157,   717,   161,     4,   161,   164,    14,    15,   724,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
       4,   161,   161,   680,   164,   164,   742,     4,  1088,   614,
       4,  1088,     4,    94,  1029,  1030,    44,    45,    46,    47,
    1079,  1080,  1088,   292,   293,   106,   703,   763,   109,   110,
     111,   112,   113,    22,   160,  1245,   772,   160,   774,   775,
       4,    12,     3,     4,     5,     6,    16,    17,    18,    19,
      11,   160,    13,   160,   839,   160,    84,  1267,    38,    39,
      40,    22,   150,   151,   152,   153,   154,   803,    66,    67,
      68,  1281,   808,    16,    17,    18,    19,   160,   814,   160,
     108,   109,   110,   111,   112,   162,    47,   160,   747,    38,
      39,    40,   168,   829,   685,   686,   687,   157,   162,   835,
     158,    62,    63,   160,   840,     4,   158,   747,   162,   160,
     158,   847,   157,   168,     4,     4,   160,   853,    11,    12,
      13,    14,    15,    16,    17,    18,    19,   166,    89,    90,
    1229,   166,   160,   166,   812,    14,    15,   163,   874,   162,
     876,     4,   747,   161,     4,   162,   159,   108,   884,   157,
     886,   887,   888,   889,   890,   891,   892,    36,   168,   161,
     161,   747,    41,    42,    43,    44,    45,    46,   161,   130,
     131,   132,   133,   134,   135,   911,   161,   164,   157,   747,
     148,   149,   150,   151,   152,   153,   154,   148,   149,   150,
     926,   168,   928,   159,   154,   164,   161,   160,     4,   160,
     162,     4,   938,   939,    83,     4,   167,    10,     4,   945,
     171,   172,   162,     4,   158,   157,     4,   168,   159,   955,
     956,   957,   958,   828,    27,    28,   161,   157,   164,   162,
     109,   110,   111,   112,   157,    38,    39,    40,     4,   975,
     161,   977,    97,   979,     4,     4,   163,   161,   161,  1034,
       4,    54,   160,    56,     4,    58,    59,    60,   164,   162,
     996,   997,     4,    66,    67,    68,     4,  1003,   160,   160,
       4,     4,  1008,  1009,   160,     4,   160,   162,  1014,   161,
     160,   160,   160,   160,    87,    88,   160,  1023,   160,   966,
     158,   160,   158,  1029,  1030,   157,   169,   161,    77,   160,
     103,   104,   105,   160,   160,     4,   160,  1043,   160,  1045,
     160,  1047,   160,   162,   158,  1051,   162,  1053,    93,    93,
    1056,    93,  1058,    93,   161,   164,   168,   157,   160,   160,
       4,   160,   160,     4,   161,    14,    15,   162,   161,  1075,
     158,   158,   164,  1079,  1080,   160,  1005,   160,   160,   160,
     164,   161,   161,  1089,   162,   162,  1092,   161,  1094,   162,
      14,    15,   157,   161,   167,  1005,    45,    46,   161,     4,
    1106,   161,    14,    15,  1033,   162,   160,     4,   158,   162,
     161,    14,    15,   161,     4,   150,   162,   164,   161,   158,
      44,    45,    46,  1033,   161,     4,   157,   161,    54,   162,
    1005,   158,    44,    45,    46,   161,   161,     3,     4,     5,
       6,    44,    45,    46,   161,    11,   161,    13,   158,  1005,
      79,     9,   150,  1159,   143,   157,  1162,   158,  1033,  1088,
     109,   110,   111,   112,     4,  1171,   162,  1005,   160,   166,
     161,    37,   162,   161,   161,   161,   161,  1033,  1088,   161,
    1186,    47,   162,   161,  1190,   109,   110,   111,   112,   162,
     162,   162,    57,   161,  1200,  1033,   157,   109,   110,   111,
     112,   164,     3,     4,     5,     6,   109,   110,   111,   112,
      11,   160,    13,  1088,   161,   143,   143,   162,   143,   161,
      69,   161,  1228,    89,    90,   162,  1232,  1233,  1234,   162,
     162,   161,  1088,    57,  1240,   158,   160,  1243,    69,   158,
     162,   162,   108,  1118,   162,   162,    47,  1253,   160,   160,
    1088,  1257,   161,  1259,   160,   162,   160,   160,    95,   161,
     161,    62,    63,   162,   130,   131,   132,   133,   134,   135,
    1276,   162,  1278,   162,  1280,   161,   164,   161,   161,  1285,
     161,  1229,   148,   149,   157,   161,   161,   164,    89,    90,
    1296,   162,   164,   159,   160,   164,   157,   161,   161,  1305,
     157,   167,   164,   162,   164,   171,   172,   108,     3,     4,
       5,     6,   157,   161,   161,   161,    11,   161,    13,   161,
     161,   157,   161,   157,  1199,   157,   161,   157,   157,   130,
     131,   132,   133,   134,   135,   157,    93,  1212,   444,   247,
     335,   494,   880,   693,   950,   503,   163,   148,   149,   576,
    1225,   165,    47,   482,    50,     3,     4,     5,     6,   160,
       8,   551,   346,    11,   729,    13,   167,    62,    63,   486,
     171,   172,  1231,   734,   743,     3,     4,     5,     6,   939,
     851,   934,  1204,    11,   945,    13,   155,   446,     6,     6,
     703,   528,   371,   360,    89,    90,   863,   865,   817,    47,
     812,  1073,    78,   273,  1116,   861,     3,     4,     5,     6,
     451,   612,   828,   108,    11,   984,    13,   902,   446,    47,
    1228,   884,    70,   446,   569,   829,   918,  1088,   533,    -1,
      -1,   921,    -1,    -1,    -1,   130,   131,   132,   133,   134,
     135,    89,    90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      47,    -1,    -1,   148,   149,    -1,    -1,    -1,    -1,    -1,
     108,    89,    90,    -1,    -1,   160,    -1,    -1,    -1,    -1,
      -1,    -1,   167,    -1,    -1,    -1,   171,   172,    -1,    -1,
     108,    -1,   130,   131,   132,   133,   134,   135,    -1,    -1,
      -1,    -1,    89,    90,    -1,    -1,    -1,    -1,    -1,    -1,
     148,   149,   130,   131,   132,   133,   134,   135,    -1,    -1,
      -1,   108,   160,    -1,    -1,    -1,    -1,    -1,    -1,   167,
     148,   149,    -1,   171,   172,    -1,    -1,    -1,    -1,    -1,
     127,   159,   160,   130,   131,   132,   133,   134,   135,   167,
      -1,    -1,    -1,   171,   172,     3,     4,     5,     6,    -1,
      -1,   148,   149,    11,    -1,    13,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   160,    -1,    -1,    -1,    -1,    -1,    -1,
     167,    -1,    -1,    -1,   171,   172,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    27,    28,    -1,    -1,    47,
      -1,    -1,     3,     4,     5,     6,    38,    39,    40,    -1,
      11,    -1,    13,    -1,    -1,    -1,    -1,    49,    50,    51,
      52,    53,    -1,     3,     4,     5,     6,    -1,    -1,    -1,
      -1,    11,    -1,    13,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    89,    90,    -1,    -1,    -1,    47,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    88,    -1,    -1,    -1,
     108,    -1,    -1,    -1,    -1,    -1,    -1,    47,    -1,    -1,
       3,     4,     5,     6,    -1,    -1,    -1,    -1,    11,    -1,
      13,    -1,   130,   131,   132,   133,   134,   135,    89,    90,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,
     148,   149,    -1,    -1,    -1,    -1,    -1,   108,    -1,    89,
      90,    -1,   160,   161,    47,    -1,    -1,    -1,    -1,   167,
     100,    -1,    -1,   171,   172,    -1,    -1,    -1,   108,   130,
     131,   132,   133,   134,   135,     3,     4,     5,     6,    -1,
      -1,    -1,    -1,    11,    -1,    13,    -1,   148,   149,    -1,
     130,   131,   132,   133,   134,   135,    89,    90,    -1,   160,
      -1,    -1,    -1,    -1,    -1,    -1,   167,   100,   148,   149,
     171,   172,    -1,    -1,    -1,   108,    -1,    -1,    -1,    47,
     160,    -1,    -1,    -1,    -1,    -1,    -1,   167,    -1,    -1,
      -1,   171,   172,    -1,    -1,    -1,    -1,   130,   131,   132,
     133,   134,   135,     3,     4,     5,     6,    -1,    -1,    -1,
      -1,    11,    -1,    13,    -1,   148,   149,    -1,    -1,    -1,
      -1,    89,    90,    -1,    -1,    -1,    -1,   160,    -1,    -1,
      -1,    -1,    -1,    -1,   167,    -1,    -1,    -1,   171,   172,
     108,    -1,    -1,    -1,    -1,    -1,    -1,    47,    -1,    -1,
       3,     4,     5,     6,    -1,    -1,    -1,    -1,    11,    -1,
      13,    -1,   130,   131,   132,   133,   134,   135,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     148,   149,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,
      90,    -1,   160,   161,    47,    -1,    -1,    -1,    -1,   167,
     100,    -1,    -1,   171,   172,    -1,    -1,    -1,   108,    -1,
      -1,    -1,     3,     4,     5,     6,    -1,    -1,    -1,    -1,
      11,    -1,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     130,   131,   132,   133,   134,   135,    89,    90,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,     6,   100,   148,   149,
      -1,    11,    -1,    13,    -1,   108,    47,    -1,    -1,    -1,
     160,    -1,    -1,    -1,    -1,    -1,    -1,   167,    -1,    -1,
      -1,   171,   172,    -1,    -1,    -1,    -1,   130,   131,   132,
     133,   134,   135,    -1,    -1,    -1,    -1,    47,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   148,   149,    -1,    89,    90,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   160,    -1,   100,
      -1,    -1,    -1,    -1,   167,    -1,    -1,   108,   171,   172,
      -1,    -1,    -1,     3,     4,     5,     6,    -1,    -1,    89,
      90,    11,    -1,    13,    -1,    -1,    -1,    -1,    -1,   130,
     131,   132,   133,   134,   135,    -1,    -1,    -1,   108,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,   149,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    47,    -1,   160,
     130,   131,   132,   133,   134,   135,   167,    -1,    -1,    -1,
     171,   172,    -1,    -1,    -1,    -1,    -1,    -1,   148,   149,
      -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,    -1,
     160,   161,    -1,    11,    -1,    13,    -1,   167,    -1,    89,
      90,   171,   172,    -1,    -1,     3,     4,     5,     6,    -1,
      -1,    -1,    -1,    11,    -1,    13,    -1,    -1,   108,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    47,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     130,   131,   132,   133,   134,   135,    -1,    -1,    -1,    47,
      -1,    -1,     3,     4,     5,     6,    -1,    -1,   148,   149,
      11,    -1,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     160,    89,    90,    -1,    -1,    -1,    -1,   167,    -1,    -1,
      -1,   171,   172,    -1,   101,   102,    -1,    -1,    -1,    -1,
     108,    89,    90,    -1,    -1,    -1,    47,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,    -1,
     108,    -1,   130,   131,   132,   133,   134,   135,    -1,    -1,
      -1,    -1,    -1,    -1,   141,    -1,    -1,    -1,    -1,    -1,
     148,   149,   130,   131,   132,   133,   134,   135,    89,    90,
      -1,   158,   160,    -1,    -1,    -1,    -1,    -1,    -1,   167,
     148,   149,    -1,   171,   172,    -1,    -1,   108,    -1,    -1,
      -1,    -1,   160,    -1,    -1,    -1,    -1,    -1,    -1,   167,
      -1,    -1,    -1,   171,   172,    -1,    -1,    -1,    -1,   130,
     131,   132,   133,   134,   135,    -1,    -1,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,    -1,   148,   149,   201,
     202,     4,    -1,  1253,     7,    -1,    -1,    -1,    -1,   160,
      -1,    -1,    -1,    -1,    -1,    -1,   167,    -1,    -1,  1269,
     171,   172,    -1,    -1,    27,    28,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1284,    38,    39,    40,    -1,    -1,
      -1,    -1,  1292,    -1,    -1,    -1,    49,    50,    51,    52,
      53,    -1,    -1,  1303,    -1,    -1,    -1,    -1,    61,    -1,
      -1,    64,  1312,    -1,    -1,  1315,    -1,  1317,    71,  1319,
      73,    -1,  1322,    -1,  1324,    -1,  1326,    -1,  1328,    -1,
    1330,    -1,    -1,    -1,    87,    88,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,     8,    -1,
      10,    -1,    -1,    -1,    -1,    -1,    16,    17,    18,    19,
      -1,    -1,    -1,    23,    -1,    -1,    26,    -1,    -1,    29,
      -1,    -1,    -1,    -1,    -1,    -1,   358,    -1,    -1,    -1,
      -1,    -1,     8,    -1,    10,    -1,    -1,    -1,    48,    -1,
      16,    17,    18,    19,    54,    -1,    56,    23,    58,    -1,
      -1,    -1,    -1,    29,    -1,    -1,    66,    67,    68,    -1,
      -1,    -1,    -1,    -1,    -1,    75,    76,    -1,    78,    -1,
      -1,    81,    48,    -1,    -1,    -1,    -1,    -1,    54,    -1,
      56,    -1,    58,    -1,    94,    95,    -1,    -1,    98,    -1,
      66,    67,    68,    -1,    -1,    -1,   106,    -1,    -1,    75,
      76,    -1,    78,   113,    -1,    81,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   126,    -1,    94,    95,
      -1,    -1,    98,    99,     8,    -1,    10,    -1,    -1,    -1,
     106,    -1,    16,    17,    18,    19,    -1,   113,    -1,    23,
      -1,    -1,    -1,    -1,    -1,    29,    -1,    -1,    -1,    -1,
     126,    -1,   162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    48,    -1,    -1,    -1,    -1,    -1,
      54,    -1,    56,    -1,    58,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    66,    67,    68,    -1,   162,    -1,    -1,    -1,
      -1,    75,    76,    -1,    78,    -1,    -1,    81,    82,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    95,    -1,    -1,    98,     8,    -1,    10,    -1,    -1,
      -1,    -1,   106,    16,    17,    18,    19,    -1,    -1,   113,
      23,    -1,    -1,    -1,    -1,    -1,    29,    -1,    -1,     8,
      -1,    10,   126,    -1,    -1,    -1,    -1,    16,    17,    18,
      19,    -1,    -1,    -1,    23,    48,    -1,    -1,    -1,    -1,
      29,    54,    55,    56,    -1,    58,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    66,    67,    68,    -1,    -1,    -1,    48,
      -1,    -1,    75,    76,    -1,    78,    -1,    56,    81,    58,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,    67,    68,
      -1,    94,    95,    -1,    -1,    98,    75,    76,    -1,    78,
      -1,    -1,    81,   106,    -1,    -1,    -1,    -1,    -1,    -1,
     113,    -1,    -1,    -1,    -1,    94,    95,    -1,    -1,    98,
      -1,    -1,    -1,   126,    -1,    -1,    -1,   106,    -1,    -1,
      -1,    -1,    -1,    -1,   113,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   126,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     170,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   174,   175,     0,    23,    33,    95,   126,   176,   177,
     178,   180,   188,   207,   212,   217,   250,   318,   320,   373,
     181,   213,    14,    15,    44,    45,    46,    94,   106,   109,
     110,   111,   112,   113,   160,   187,   240,   241,   328,   341,
     343,   374,   375,   218,    25,    27,    28,    30,    61,    71,
      73,   179,   176,   176,   176,   176,   176,   176,   176,   176,
     176,     4,   183,   184,   185,   186,     4,   329,    14,    47,
     108,   258,    47,   108,   259,   342,   165,   242,   244,     4,
      14,   372,   186,   221,   224,   189,   319,   321,   208,     4,
      65,   263,   263,    21,   182,   157,    32,   158,   159,   214,
      44,    45,   240,   330,   331,   332,   161,   107,   344,   345,
       3,     5,     6,    11,    13,    47,    89,    90,   108,   130,
     131,   132,   133,   134,   135,   148,   149,   160,   167,   171,
     172,   186,   451,   474,   475,   478,   372,   162,   219,   164,
     222,     4,    47,    84,   108,   187,   310,   311,   312,   314,
     315,   316,   317,   331,   332,   317,     4,     4,   158,   164,
      44,    45,   187,   240,   256,   257,     4,   183,    24,   185,
       4,   474,     4,   163,   191,   167,    47,   108,   333,   333,
      47,   108,   346,   167,    11,    12,   154,   177,   177,   154,
     177,   177,   177,   177,   177,   177,   177,   177,   474,   474,
     477,   177,   177,   165,   177,   242,   243,   244,   478,    91,
      92,   164,   166,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     170,   243,   244,   245,     4,   223,   224,   190,   244,   313,
     310,     4,   322,   323,   324,   310,   322,   209,   251,     4,
       4,   258,     4,   259,   254,    22,   160,   160,   198,     4,
     334,   335,   244,   347,   348,   352,   353,    12,   160,   160,
     160,   160,   475,   475,   475,   475,   475,   475,   475,   475,
     161,   164,   157,   167,   168,   475,   475,   474,   476,   242,
     242,   474,   474,   474,   177,   177,   177,   177,   177,   177,
     177,   177,   177,   177,   177,   177,   177,   177,   177,   177,
     177,   177,   177,   177,   177,   177,   177,   177,   177,   177,
     160,   177,   162,   220,   157,   191,   157,   162,   158,   242,
     162,   162,   160,   261,     4,   158,   255,   242,   160,   264,
     192,     4,   159,   161,   177,   199,   202,   162,   158,   336,
     157,   200,   168,   348,     4,   349,   350,   187,   331,   332,
     354,   355,   357,   474,   474,   474,   474,   478,   474,   474,
     477,   477,   166,   160,   166,   166,   166,   475,   475,   475,
     475,   475,   475,   475,   475,   475,   475,   475,   475,   475,
     475,   475,   475,   475,   475,   475,   475,   475,   475,   475,
     475,   475,   475,   474,   474,   163,   390,   224,   198,   323,
     474,   210,     4,   260,   262,   162,   252,     4,   264,   161,
     265,   162,   177,   194,   195,   323,   203,   204,   159,   228,
     229,   230,   231,   232,   157,   200,   215,   475,   335,   168,
     351,   157,   162,   333,   333,   343,   161,   161,   161,   161,
     164,   168,   159,   455,   456,   457,   474,   161,   164,   160,
       4,   382,   386,   162,    31,   177,   211,   250,   318,   320,
     373,     4,   157,   161,   261,     4,   162,   177,   267,   268,
     270,   271,    27,    28,   157,   193,   158,   201,     4,   159,
      38,    39,    40,   233,    96,    97,   235,   244,   202,   161,
      29,    34,    35,    48,   177,   216,   217,   318,   320,   325,
     360,   369,   373,   398,   409,   244,   350,   245,   356,   474,
     168,   186,   451,   157,   200,   474,   159,   391,   392,   474,
     383,   157,   162,   246,   164,   406,   260,   162,   253,   271,
     232,   157,   200,     4,   368,     8,    74,   163,   177,   180,
     226,   318,   320,   360,   373,   407,   417,   419,   422,   435,
     196,   197,   195,   161,   474,   205,   235,    97,    36,    41,
      42,    43,    44,    45,    83,   187,   237,   238,   239,   240,
       4,   244,   326,   327,     4,   226,   227,    49,    50,    51,
      52,    53,    87,    88,   232,   396,   397,   344,   161,   457,
     161,     4,   157,   161,   160,   382,    10,    26,    54,    56,
      58,    66,    67,    68,    75,    76,    78,    81,    98,   162,
     177,   180,   217,   247,   248,   250,   272,   282,   285,   318,
     320,   325,   328,   339,   340,   341,   360,   369,   373,   376,
     398,   407,   418,   436,   462,   468,     4,   261,    72,   244,
     268,   266,   245,   164,     4,     5,     6,   127,   160,    10,
      54,    56,    58,    59,    60,   103,   104,   105,   162,   167,
     186,   451,   452,   422,    16,    17,    18,    19,   162,   436,
     317,   317,   201,   236,   237,    44,   239,    47,   108,   234,
     239,   206,   451,   157,   162,   410,   370,   371,   452,   402,
       4,     4,   244,   401,   399,   160,   392,   177,   393,   394,
     395,   467,   406,   469,   160,   160,     4,    56,   273,   274,
     276,     4,    56,    77,   283,   284,   285,   289,   290,   291,
     303,   308,   165,   286,   287,   288,   308,   458,     4,     4,
       7,    64,   379,     4,   337,   338,     4,   358,   359,    16,
      17,    18,    19,   160,   162,   269,   161,   127,   225,   474,
     424,   425,   160,   160,   160,   160,   453,   474,   423,   101,
     102,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   141,   158,   420,    20,    93,   408,   408,
     408,   162,   408,   160,   323,   323,   234,   201,   158,   327,
     160,   412,   157,   162,   158,   422,   363,   364,   361,   422,
     169,   403,   161,   474,    37,   159,   474,   161,   157,   160,
     454,   406,   474,   463,   160,   160,    77,   273,   160,   309,
     160,    77,   284,   160,   295,   296,   162,   160,   306,   474,
     287,   157,   162,   158,    82,   177,   247,   459,   462,   468,
     162,   377,   227,   157,   162,   157,   162,    93,    93,    93,
      93,   474,   368,   161,   157,   161,   164,   454,   406,   474,
     427,   474,   474,   168,   157,   454,   227,   227,   227,   160,
     160,   160,   160,   474,   474,     4,    38,    39,   161,   413,
     414,   415,   416,   411,   371,   474,   365,   365,   227,    21,
     150,   160,   400,   161,     4,   395,   455,   162,   470,   161,
       4,    83,   460,   461,    62,    63,   279,   474,   279,   245,
     307,   474,    62,    63,   294,   297,   301,   308,   158,   158,
      62,    63,   304,   305,   307,   164,   162,   288,   307,   162,
     249,   390,   378,   338,   359,   160,   160,   160,   160,   161,
     225,   474,   162,   426,   161,     4,   230,   421,   161,   161,
     453,   162,   474,   474,   474,   100,   474,   100,   474,   100,
     474,   161,   474,   161,   157,   200,   415,   162,   157,   162,
     162,   366,   367,   368,   161,    22,    62,    63,   150,   404,
     405,   474,   422,   160,   200,   458,   465,   460,   158,   162,
     474,   161,   474,   161,   164,   297,   301,   150,   148,   149,
     157,   298,   300,   160,   292,   307,   292,   308,   308,    80,
     157,   161,   306,   246,     4,   380,   381,   382,   384,   381,
     387,   388,   389,   100,   474,   100,   474,   100,   474,   474,
     466,   157,   161,   164,   438,   432,   158,   244,   162,   430,
     431,   474,   161,   474,   161,   474,   161,   162,   161,   434,
     414,   161,     4,   157,   362,   158,   474,   474,   161,    64,
     157,   161,   161,   474,   161,    55,   468,   471,   472,   158,
     474,   474,    79,   277,     9,   474,   150,   158,   300,   143,
     301,   157,   300,   158,   307,   474,   157,   293,   304,   304,
     162,   166,    99,   242,   157,   162,   157,   162,   160,   474,
     161,   474,   161,   474,   161,   161,   445,   225,   474,    55,
     422,   422,   474,     4,   474,   422,   422,   161,   162,   161,
     162,   161,   162,   162,   437,   367,   162,   474,   405,   405,
     161,   406,    57,   473,   459,   474,   464,   474,   157,   160,
     278,   474,   164,   143,   143,   299,   302,   308,   301,   143,
     293,   164,   307,   385,   381,   388,   393,   161,   162,   161,
     162,   161,   162,   162,    69,   446,   447,   161,   406,   433,
     158,   428,   162,   162,   162,    85,    86,   441,   471,   162,
     279,   474,   161,   474,   160,   160,   157,   161,   302,   161,
     474,   293,   160,   161,   162,   162,   162,     8,    70,   449,
     450,   474,    57,   439,   474,   162,    69,   442,   443,   177,
     419,   474,    91,    92,   164,   158,   299,   302,   302,   161,
     164,   393,   448,   157,   164,   440,   419,   449,   161,   277,
     474,   474,   474,   160,   280,   281,   474,    91,   300,    91,
     300,   474,   161,   471,   474,   422,   161,   444,   471,   157,
     161,   161,   161,   281,   474,   162,   164,   307,   164,   307,
     164,   429,   422,   281,   157,   164,   474,   161,   307,   161,
     307,   422,   157,   275,   281,   474,   164,   161,   161,   161,
     161,   281,   161,   157,   161,   164,   474,   161,   161,   162,
     281,   474,   157,   161,   281,   157,   281,   157,   281,   157,
     161,   281,   157,   281,   157,   281,   157,   281,   157,   281,
     157,   281,   161
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   173,   175,   174,   176,   176,   176,   176,   176,   176,
     176,   176,   176,   176,   178,   177,   179,   179,   181,   182,
     180,   183,   183,   184,   184,   185,   185,   186,   186,   186,
     187,   187,   187,   189,   190,   188,   192,   193,   191,   191,
     194,   194,   195,   196,   195,   197,   195,   195,   198,   198,
     198,   199,   199,   200,   200,   201,   201,   203,   202,   204,
     205,   202,   206,   202,   202,   208,   209,   207,   210,   210,
     211,   211,   211,   211,   213,   214,   212,   215,   215,   216,
     216,   216,   216,   216,   216,   216,   216,   216,   218,   219,
     220,   217,   221,   222,   222,   223,   223,   224,   225,   225,
     226,   226,   226,   226,   226,   226,   226,   226,   227,   227,
     229,   228,   231,   230,   232,   232,   233,   233,   233,   234,
     234,   234,   235,   235,   235,   235,   236,   236,   237,   237,
     237,   237,   237,   237,   237,   237,   238,   238,   238,   239,
     239,   239,   240,   240,   240,   240,   240,   241,   241,   242,
     242,   242,   242,   243,   243,   244,   244,   245,   245,   246,
     246,   246,   246,   246,   247,   247,   247,   247,   247,   247,
     247,   247,   247,   247,   247,   247,   247,   247,   247,   247,
     247,   247,   247,   249,   248,   251,   250,   252,   250,   253,
     250,   254,   250,   255,   250,   256,   256,   256,   256,   257,
     257,   257,   258,   258,   258,   259,   259,   259,   260,   260,
     261,   261,   262,   262,   262,   262,   263,   263,   264,   264,
     265,   266,   264,   267,   267,   269,   268,   270,   268,   271,
     271,   272,   273,   273,   274,   274,   275,   275,   276,   276,
     277,   277,   278,   278,   278,   278,   279,   279,   279,   280,
     280,   280,   280,   280,   281,   281,   282,   282,   283,   283,
     284,   284,   284,   285,   285,   286,   287,   287,   288,   289,
     289,   290,   291,   291,   292,   292,   292,   293,   293,   294,
     294,   295,   295,   295,   296,   296,   296,   297,   297,   298,
     298,   299,   299,   300,   300,   300,   301,   302,   303,   304,
     304,   304,   305,   305,   305,   306,   307,   307,   309,   308,
     310,   310,   310,   311,   312,   313,   314,   315,   315,   316,
     317,   317,   317,   317,   317,   319,   318,   321,   320,   322,
     322,   323,   323,   324,   325,   326,   326,   327,   329,   328,
     330,   330,   330,   331,   332,   332,   333,   333,   333,   334,
     334,   335,   336,   336,   337,   337,   338,   339,   340,   342,
     341,   343,   343,   344,   345,   345,   346,   346,   346,   347,
     347,   348,   349,   349,   351,   350,   353,   352,   354,   354,
     355,   356,   354,   357,   357,   358,   358,   359,   361,   362,
     360,   363,   360,   364,   360,   365,   365,   366,   366,   367,
     367,   368,   369,   370,   370,   371,   372,   372,   373,   373,
     374,   374,   374,   375,   375,   377,   376,   378,   376,   379,
     379,   380,   380,   381,   381,   383,   382,   385,   384,   386,
     386,   387,   387,   388,   389,   388,   390,   390,   391,   391,
     392,   392,   392,   392,   393,   394,   394,   395,   395,   395,
     395,   395,   395,   396,   396,   397,   397,   399,   400,   398,
     401,   398,   402,   398,   403,   403,   403,   403,   403,   403,
     404,   404,   404,   405,   405,   405,   406,   406,   407,   407,
     408,   408,   408,   410,   411,   409,   412,   412,   413,   413,
     414,   414,   415,   416,   416,   417,   417,   417,   417,   417,
     417,   417,   417,   417,   418,   418,   418,   418,   418,   418,
     418,   419,   419,   419,   419,   419,   420,   420,   420,   420,
     420,   420,   420,   420,   420,   420,   420,   420,   421,   421,
     421,   422,   422,   422,   422,   422,   422,   422,   422,   422,
     423,   422,   424,   422,   425,   426,   422,   427,   428,   429,
     422,   430,   422,   431,   422,   432,   433,   422,   434,   422,
     435,   435,   435,   435,   436,   436,   436,   437,   437,   437,
     438,   438,   440,   439,   439,   441,   441,   443,   444,   442,
     445,   445,   447,   448,   446,   449,   449,   450,   450,   450,
     450,   451,   451,   451,   452,   452,   453,   453,   454,   454,
     455,   455,   456,   456,   457,   458,   458,   458,   459,   459,
     459,   460,   461,   461,   461,   463,   464,   462,   465,   462,
     466,   462,   467,   462,   469,   470,   468,   472,   471,   471,
     473,   473,   474,   474,   475,   475,   475,   475,   475,   475,
     476,   475,   475,   475,   475,   475,   475,   475,   475,   475,
     475,   475,   475,   475,   475,   475,   475,   475,   475,   475,
     475,   475,   475,   475,   475,   475,   475,   475,   475,   475,
     475,   475,   475,   475,   475,   475,   475,   475,   475,   475,
     475,   475,   475,   475,   475,   475,   475,   477,   477,   478,
     478,   478,   478
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     0,     0,     2,     4,     0,     0,     0,
       5,     1,     0,     1,     3,     1,     3,     1,     3,     3,
       1,     1,     3,     0,     0,    11,     0,     0,     6,     0,
       1,     3,     0,     0,     5,     0,     5,     1,     2,     0,
       4,     1,     3,     1,     0,     2,     0,     0,     3,     0,
       0,     5,     0,     6,     3,     0,     0,     9,     2,     0,
       1,     1,     1,     1,     0,     0,     9,     2,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     0,
       0,     9,     2,     2,     0,     1,     3,     1,     1,     5,
       2,     2,     2,     2,     4,     4,     6,     8,     1,     0,
       0,     5,     0,     4,     1,     1,     1,     1,     1,     1,
       1,     0,     2,     1,     1,     0,     1,     0,     1,     2,
       1,     2,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     5,
       5,     5,     3,     2,     2,     1,     0,     1,     1,     2,
       2,     2,     2,     0,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       1,     1,     1,     0,     6,     0,     7,     0,     9,     0,
      11,     0,     9,     0,    10,     1,     2,     3,     2,     0,
       1,     1,     0,     1,     1,     0,     1,     1,     2,     1,
       3,     0,     3,     2,     1,     0,     1,     0,     2,     0,
       0,     0,     6,     1,     3,     0,     5,     0,     2,     2,
       0,     3,     2,     0,    10,    14,     2,     0,     4,     0,
       2,     0,     1,     5,     5,     5,     1,     1,     0,     1,
       5,     7,    13,    25,     1,     5,     3,     2,     2,     1,
       1,     1,     1,     3,     4,     5,     1,     3,     3,     4,
       0,     2,     4,     4,     4,     1,     2,     2,     3,     1,
       1,     7,    12,    11,     6,    12,    11,     2,     3,     2,
       3,     1,     3,     1,     1,     0,     1,     1,     5,     2,
       2,     1,     1,     3,     3,     1,     1,     5,     0,     3,
       1,     1,     0,     1,     1,     1,     2,     2,     3,     2,
       1,     1,     1,     1,     1,     0,     6,     0,     6,     1,
       3,     3,     1,     1,     3,     1,     3,     4,     0,     7,
       2,     3,     0,     1,     1,     1,     1,     1,     0,     1,
       3,     2,     2,     0,     1,     3,     1,     3,     3,     0,
       3,     1,     1,     4,     2,     0,     1,     1,     0,     1,
       2,     3,     1,     3,     0,     3,     0,     2,     1,     1,
       0,     0,     4,     2,     3,     1,     3,     1,     0,     0,
       8,     0,     6,     0,     6,     0,     3,     1,     3,     1,
       3,     2,     4,     1,     3,     3,     1,     1,     6,     4,
       1,     2,     2,     1,     1,     0,     6,     0,     6,     1,
       1,     1,     3,     1,     1,     0,     5,     0,     6,     1,
       3,     1,     3,     1,     0,     4,     4,     0,     1,     3,
       0,     1,     4,     5,     1,     1,     3,     1,     2,     6,
       5,     3,     2,     1,     1,     1,     1,     0,     0,     6,
       0,     4,     0,     4,     4,     4,     3,     3,     2,     0,
       1,     3,     3,     2,     2,     1,     2,     0,     2,     0,
       1,     1,     0,     0,     0,     6,     2,     4,     1,     3,
       2,     1,     1,     1,     1,     7,     7,     8,     8,     7,
       6,     3,     7,     8,     7,     7,     8,     8,     7,     7,
       8,     5,     3,     3,     5,     5,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       5,     1,     1,     1,     1,     1,     1,     2,     2,     2,
       0,     5,     0,     5,     0,     0,     8,     0,     0,     0,
      13,     0,     7,     0,     7,     0,     0,     9,     0,     9,
       1,     2,     2,     2,     1,     1,     1,     2,     2,     0,
       2,     0,     0,     3,     0,     2,     0,     0,     0,     4,
       2,     0,     0,     0,     4,     2,     1,     1,     1,     1,
       3,     6,     2,     2,     1,     3,     1,     3,     4,     0,
       1,     0,     1,     3,     1,     2,     2,     0,     1,     1,
       2,     1,     2,     4,     3,     0,     0,    11,     0,     7,
       0,     7,     0,     4,     0,     0,     7,     0,     2,     1,
       2,     0,     1,     6,     1,     4,     2,     1,     1,     1,
       0,     7,     5,     5,     3,     7,     3,     6,     3,     4,
       4,     4,     4,     4,     4,     3,     3,     3,     3,     3,
       3,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     3,
       3,     4,     4,     3,     5,     5,     5,     1,     3,     1,
       1,     2,     3
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = FRONTEND_VERILOG_YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == FRONTEND_VERILOG_YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        YY_LAC_DISCARD ("YYBACKUP");                              \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use FRONTEND_VERILOG_YYerror or FRONTEND_VERILOG_YYUNDEF. */
#define YYERRCODE FRONTEND_VERILOG_YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if FRONTEND_VERILOG_YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined FRONTEND_VERILOG_YYLTYPE_IS_TRIVIAL && FRONTEND_VERILOG_YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !FRONTEND_VERILOG_YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !FRONTEND_VERILOG_YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Given a state stack such that *YYBOTTOM is its bottom, such that
   *YYTOP is either its top or is YYTOP_EMPTY to indicate an empty
   stack, and such that *YYCAPACITY is the maximum number of elements it
   can hold without a reallocation, make sure there is enough room to
   store YYADD more elements.  If not, allocate a new stack using
   YYSTACK_ALLOC, copy the existing elements, and adjust *YYBOTTOM,
   *YYTOP, and *YYCAPACITY to reflect the new capacity and memory
   location.  If *YYBOTTOM != YYBOTTOM_NO_FREE, then free the old stack
   using YYSTACK_FREE.  Return 0 if successful or if no reallocation is
   required.  Return YYENOMEM if memory is exhausted.  */
static int
yy_lac_stack_realloc (YYPTRDIFF_T *yycapacity, YYPTRDIFF_T yyadd,
#if FRONTEND_VERILOG_YYDEBUG
                      char const *yydebug_prefix,
                      char const *yydebug_suffix,
#endif
                      yy_state_t **yybottom,
                      yy_state_t *yybottom_no_free,
                      yy_state_t **yytop, yy_state_t *yytop_empty)
{
  YYPTRDIFF_T yysize_old =
    *yytop == yytop_empty ? 0 : *yytop - *yybottom + 1;
  YYPTRDIFF_T yysize_new = yysize_old + yyadd;
  if (*yycapacity < yysize_new)
    {
      YYPTRDIFF_T yyalloc = 2 * yysize_new;
      yy_state_t *yybottom_new;
      /* Use YYMAXDEPTH for maximum stack size given that the stack
         should never need to grow larger than the main state stack
         needs to grow without LAC.  */
      if (YYMAXDEPTH < yysize_new)
        {
          YYDPRINTF ((stderr, "%smax size exceeded%s", yydebug_prefix,
                      yydebug_suffix));
          return YYENOMEM;
        }
      if (YYMAXDEPTH < yyalloc)
        yyalloc = YYMAXDEPTH;
      yybottom_new =
        YY_CAST (yy_state_t *,
                 YYSTACK_ALLOC (YY_CAST (YYSIZE_T,
                                         yyalloc * YYSIZEOF (*yybottom_new))));
      if (!yybottom_new)
        {
          YYDPRINTF ((stderr, "%srealloc failed%s", yydebug_prefix,
                      yydebug_suffix));
          return YYENOMEM;
        }
      if (*yytop != yytop_empty)
        {
          YYCOPY (yybottom_new, *yybottom, yysize_old);
          *yytop = yybottom_new + (yysize_old - 1);
        }
      if (*yybottom != yybottom_no_free)
        YYSTACK_FREE (*yybottom);
      *yybottom = yybottom_new;
      *yycapacity = yyalloc;
    }
  return 0;
}

/* Establish the initial context for the current lookahead if no initial
   context is currently established.

   We define a context as a snapshot of the parser stacks.  We define
   the initial context for a lookahead as the context in which the
   parser initially examines that lookahead in order to select a
   syntactic action.  Thus, if the lookahead eventually proves
   syntactically unacceptable (possibly in a later context reached via a
   series of reductions), the initial context can be used to determine
   the exact set of tokens that would be syntactically acceptable in the
   lookahead's place.  Moreover, it is the context after which any
   further semantic actions would be erroneous because they would be
   determined by a syntactically unacceptable token.

   YY_LAC_ESTABLISH should be invoked when a reduction is about to be
   performed in an inconsistent state (which, for the purposes of LAC,
   includes consistent states that don't know they're consistent because
   their default reductions have been disabled).  Iff there is a
   lookahead token, it should also be invoked before reporting a syntax
   error.  This latter case is for the sake of the debugging output.

   For parse.lac=full, the implementation of YY_LAC_ESTABLISH is as
   follows.  If no initial context is currently established for the
   current lookahead, then check if that lookahead can eventually be
   shifted if syntactic actions continue from the current context.
   Report a syntax error if it cannot.  */
#define YY_LAC_ESTABLISH                                                \
do {                                                                    \
  if (!yy_lac_established)                                              \
    {                                                                   \
      YYDPRINTF ((stderr,                                               \
                  "LAC: initial context established for %s\n",          \
                  yysymbol_name (yytoken)));                            \
      yy_lac_established = 1;                                           \
      switch (yy_lac (yyesa, &yyes, &yyes_capacity, yyssp, yytoken))    \
        {                                                               \
        case YYENOMEM:                                                  \
          YYNOMEM;                                                      \
        case 1:                                                         \
          goto yyerrlab;                                                \
        }                                                               \
    }                                                                   \
} while (0)

/* Discard any previous initial lookahead context because of Event,
   which may be a lookahead change or an invalidation of the currently
   established initial context for the current lookahead.

   The most common example of a lookahead change is a shift.  An example
   of both cases is syntax error recovery.  That is, a syntax error
   occurs when the lookahead is syntactically erroneous for the
   currently established initial context, so error recovery manipulates
   the parser stacks to try to find a new initial context in which the
   current lookahead is syntactically acceptable.  If it fails to find
   such a context, it discards the lookahead.  */
#if FRONTEND_VERILOG_YYDEBUG
# define YY_LAC_DISCARD(Event)                                           \
do {                                                                     \
  if (yy_lac_established)                                                \
    {                                                                    \
      YYDPRINTF ((stderr, "LAC: initial context discarded due to "       \
                  Event "\n"));                                          \
      yy_lac_established = 0;                                            \
    }                                                                    \
} while (0)
#else
# define YY_LAC_DISCARD(Event) yy_lac_established = 0
#endif

/* Given the stack whose top is *YYSSP, return 0 iff YYTOKEN can
   eventually (after perhaps some reductions) be shifted, return 1 if
   not, or return YYENOMEM if memory is exhausted.  As preconditions and
   postconditions: *YYES_CAPACITY is the allocated size of the array to
   which *YYES points, and either *YYES = YYESA or *YYES points to an
   array allocated with YYSTACK_ALLOC.  yy_lac may overwrite the
   contents of either array, alter *YYES and *YYES_CAPACITY, and free
   any old *YYES other than YYESA.  */
static int
yy_lac (yy_state_t *yyesa, yy_state_t **yyes,
        YYPTRDIFF_T *yyes_capacity, yy_state_t *yyssp, yysymbol_kind_t yytoken)
{
  yy_state_t *yyes_prev = yyssp;
  yy_state_t *yyesp = yyes_prev;
  /* Reduce until we encounter a shift and thereby accept the token.  */
  YYDPRINTF ((stderr, "LAC: checking lookahead %s:", yysymbol_name (yytoken)));
  if (yytoken == YYSYMBOL_YYUNDEF)
    {
      YYDPRINTF ((stderr, " Always Err\n"));
      return 1;
    }
  while (1)
    {
      int yyrule = yypact[+*yyesp];
      if (yypact_value_is_default (yyrule)
          || (yyrule += yytoken) < 0 || YYLAST < yyrule
          || yycheck[yyrule] != yytoken)
        {
          /* Use the default action.  */
          yyrule = yydefact[+*yyesp];
          if (yyrule == 0)
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
        }
      else
        {
          /* Use the action from yytable.  */
          yyrule = yytable[yyrule];
          if (yytable_value_is_error (yyrule))
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
          if (0 < yyrule)
            {
              YYDPRINTF ((stderr, " S%d\n", yyrule));
              return 0;
            }
          yyrule = -yyrule;
        }
      /* By now we know we have to simulate a reduce.  */
      YYDPRINTF ((stderr, " R%d", yyrule - 1));
      {
        /* Pop the corresponding number of values from the stack.  */
        YYPTRDIFF_T yylen = yyr2[yyrule];
        /* First pop from the LAC stack as many tokens as possible.  */
        if (yyesp != yyes_prev)
          {
            YYPTRDIFF_T yysize = yyesp - *yyes + 1;
            if (yylen < yysize)
              {
                yyesp -= yylen;
                yylen = 0;
              }
            else
              {
                yyesp = yyes_prev;
                yylen -= yysize;
              }
          }
        /* Only afterwards look at the main stack.  */
        if (yylen)
          yyesp = yyes_prev -= yylen;
      }
      /* Push the resulting state of the reduction.  */
      {
        yy_state_fast_t yystate;
        {
          const int yylhs = yyr1[yyrule] - YYNTOKENS;
          const int yyi = yypgoto[yylhs] + *yyesp;
          yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyesp
                     ? yytable[yyi]
                     : yydefgoto[yylhs]);
        }
        if (yyesp == yyes_prev)
          {
            yyesp = *yyes;
            YY_IGNORE_USELESS_CAST_BEGIN
            *yyesp = YY_CAST (yy_state_t, yystate);
            YY_IGNORE_USELESS_CAST_END
          }
        else
          {
            if (yy_lac_stack_realloc (yyes_capacity, 1,
#if FRONTEND_VERILOG_YYDEBUG
                                      " (", ")",
#endif
                                      yyes, yyesa, &yyesp, yyes_prev))
              {
                YYDPRINTF ((stderr, "\n"));
                return YYENOMEM;
              }
            YY_IGNORE_USELESS_CAST_BEGIN
            *++yyesp = YY_CAST (yy_state_t, yystate);
            YY_IGNORE_USELESS_CAST_END
          }
        YYDPRINTF ((stderr, " G%d", yystate));
      }
    }
}

/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yy_state_t *yyesa;
  yy_state_t **yyes;
  YYPTRDIFF_T *yyes_capacity;
  yysymbol_kind_t yytoken;
  YYLTYPE *yylloc;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;

  int yyx;
  for (yyx = 0; yyx < YYNTOKENS; ++yyx)
    {
      yysymbol_kind_t yysym = YY_CAST (yysymbol_kind_t, yyx);
      if (yysym != YYSYMBOL_YYerror && yysym != YYSYMBOL_YYUNDEF)
        switch (yy_lac (yyctx->yyesa, yyctx->yyes, yyctx->yyes_capacity, yyctx->yyssp, yysym))
          {
          case YYENOMEM:
            return YYENOMEM;
          case 1:
            continue;
          default:
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = yysym;
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
       In the first two cases, it might appear that the current syntax
       error should have been detected in the previous state when yy_lac
       was invoked.  However, at that time, there might have been a
       different syntax error that discarded a different initial context
       during error recovery, leaving behind the current lookahead.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      YYDPRINTF ((stderr, "Constructing syntax error message\n"));
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else if (yyn == 0)
        YYDPRINTF ((stderr, "No expected tokens.\n"));
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.  In order to see if a particular token T is a
   valid looakhead, invoke yy_lac (YYESA, YYES, YYES_CAPACITY, YYSSP, T).

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store or if
   yy_lac returned YYENOMEM.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined FRONTEND_VERILOG_YYLTYPE_IS_TRIVIAL && FRONTEND_VERILOG_YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

    yy_state_t yyesa[20];
    yy_state_t *yyes = yyesa;
    YYPTRDIFF_T yyes_capacity = 20 < YYMAXDEPTH ? 20 : YYMAXDEPTH;

  /* Whether LAC context is established.  A Boolean.  */
  int yy_lac_established = 0;
  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = FRONTEND_VERILOG_YYEMPTY; /* Cause a token to be read.  */

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == FRONTEND_VERILOG_YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, &yylloc);
    }

  if (yychar <= FRONTEND_VERILOG_YYEOF)
    {
      yychar = FRONTEND_VERILOG_YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == FRONTEND_VERILOG_YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = FRONTEND_VERILOG_YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    {
      YY_LAC_ESTABLISH;
      goto yydefault;
    }
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      YY_LAC_ESTABLISH;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = FRONTEND_VERILOG_YYEMPTY;
  YY_LAC_DISCARD ("shift");
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  {
    int yychar_backup = yychar;
    switch (yyn)
      {
  case 2: /* $@1: %empty  */
#line 419 "frontends/verilog/verilog_parser.y"
       {
	ast_stack.clear();
	ast_stack.push_back(current_ast);
}
#line 3817 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 3: /* input: $@1 design  */
#line 422 "frontends/verilog/verilog_parser.y"
         {
	ast_stack.pop_back();
	log_assert(GetSize(ast_stack) == 0);
	for (auto &it : default_attr_list)
		delete it.second;
	default_attr_list.clear();
}
#line 3829 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 14: /* $@2: %empty  */
#line 443 "frontends/verilog/verilog_parser.y"
        {
		if (attr_list != nullptr)
			attr_list_stack.push(attr_list);
		attr_list = new dict<IdString, AstNode*>;
		for (auto &it : default_attr_list)
			(*attr_list)[it.first] = it.second->clone();
	}
#line 3841 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 15: /* attr: $@2 attr_opt  */
#line 449 "frontends/verilog/verilog_parser.y"
                   {
		(yyval.al) = attr_list;
		if (!attr_list_stack.empty()) {
			attr_list = attr_list_stack.top();
			attr_list_stack.pop();
		} else
			attr_list = nullptr;
	}
#line 3854 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 16: /* attr_opt: attr_opt ATTR_BEGIN opt_attr_list ATTR_END  */
#line 459 "frontends/verilog/verilog_parser.y"
                                                   {
		SET_RULE_LOC((yyloc), (yylsp[-2]), (yyloc));
	}
#line 3862 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 18: /* $@3: %empty  */
#line 465 "frontends/verilog/verilog_parser.y"
                      {
		if (attr_list != nullptr)
			attr_list_stack.push(attr_list);
		attr_list = new dict<IdString, AstNode*>;
		for (auto &it : default_attr_list)
			delete it.second;
		default_attr_list.clear();
	}
#line 3875 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 19: /* $@4: %empty  */
#line 472 "frontends/verilog/verilog_parser.y"
                        {
		attr_list->swap(default_attr_list);
		delete attr_list;
		if (!attr_list_stack.empty()) {
			attr_list = attr_list_stack.top();
			attr_list_stack.pop();
		} else
			attr_list = nullptr;
	}
#line 3889 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 25: /* attr_assign: hierarchical_id  */
#line 490 "frontends/verilog/verilog_parser.y"
                        {
		if (attr_list->count(*(yyvsp[0].string)) != 0)
			delete (*attr_list)[*(yyvsp[0].string)];
		(*attr_list)[*(yyvsp[0].string)] = AstNode::mkconst_int(1, false);
		delete (yyvsp[0].string);
	}
#line 3900 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 26: /* attr_assign: hierarchical_id '=' expr  */
#line 496 "frontends/verilog/verilog_parser.y"
                                 {
		if (attr_list->count(*(yyvsp[-2].string)) != 0)
			delete (*attr_list)[*(yyvsp[-2].string)];
		(*attr_list)[*(yyvsp[-2].string)] = (yyvsp[0].ast);
		delete (yyvsp[-2].string);
	}
#line 3911 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 27: /* hierarchical_id: TOK_ID  */
#line 504 "frontends/verilog/verilog_parser.y"
               {
		(yyval.string) = (yyvsp[0].string);
	}
#line 3919 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 28: /* hierarchical_id: hierarchical_id TOK_PACKAGESEP TOK_ID  */
#line 507 "frontends/verilog/verilog_parser.y"
                                              {
		if ((yyvsp[0].string)->compare(0, 1, "\\") == 0)
			*(yyvsp[-2].string) += "::" + (yyvsp[0].string)->substr(1);
		else
			*(yyvsp[-2].string) += "::" + *(yyvsp[0].string);
		delete (yyvsp[0].string);
		(yyval.string) = (yyvsp[-2].string);
	}
#line 3932 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 29: /* hierarchical_id: hierarchical_id '.' TOK_ID  */
#line 515 "frontends/verilog/verilog_parser.y"
                                   {
		if ((yyvsp[0].string)->compare(0, 1, "\\") == 0)
			*(yyvsp[-2].string) += "." + (yyvsp[0].string)->substr(1);
		else
			*(yyvsp[-2].string) += "." + *(yyvsp[0].string);
		delete (yyvsp[0].string);
		(yyval.string) = (yyvsp[-2].string);
	}
#line 3945 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 32: /* hierarchical_type_id: '(' TOK_USER_TYPE ')'  */
#line 527 "frontends/verilog/verilog_parser.y"
                                { (yyval.string) = (yyvsp[-1].string); }
#line 3951 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 33: /* $@5: %empty  */
#line 531 "frontends/verilog/verilog_parser.y"
                        {
		enterTypeScope();
	}
#line 3959 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 34: /* $@6: %empty  */
#line 533 "frontends/verilog/verilog_parser.y"
                 {
		do_not_require_port_stubs = false;
		AstNode *mod = new AstNode(AST_MODULE);
		ast_stack.back()->children.push_back(mod);
		ast_stack.push_back(mod);
		current_ast_mod = mod;
		port_stubs.clear();
		port_counter = 0;
		mod->str = *(yyvsp[0].string);
		append_attr(mod, (yyvsp[-3].al));
	}
#line 3975 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 35: /* module: attr TOK_MODULE $@5 TOK_ID $@6 module_para_opt module_args_opt ';' module_body TOK_ENDMODULE opt_label  */
#line 543 "frontends/verilog/verilog_parser.y"
                                                                                  {
		if (port_stubs.size() != 0)
			frontend_verilog_yyerror("Missing details for module port `%s'.",
					port_stubs.begin()->first.c_str());
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-9]), (yyloc));
		ast_stack.pop_back();
		log_assert(ast_stack.size() == 1);
		checkLabelsMatch("Module name", (yyvsp[-7].string), (yyvsp[0].string));
		current_ast_mod = NULL;
		delete (yyvsp[-7].string);
		delete (yyvsp[0].string);
		exitTypeScope();
	}
#line 3993 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 36: /* $@7: %empty  */
#line 558 "frontends/verilog/verilog_parser.y"
                { astbuf1 = nullptr; }
#line 3999 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 37: /* $@8: %empty  */
#line 558 "frontends/verilog/verilog_parser.y"
                                                        { if (astbuf1) delete astbuf1; }
#line 4005 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 43: /* $@9: %empty  */
#line 565 "frontends/verilog/verilog_parser.y"
                           {
		if (astbuf1) delete astbuf1;
		astbuf1 = new AstNode(AST_PARAMETER);
		astbuf1->children.push_back(AstNode::mkconst_int(0, true));
		append_attr(astbuf1, (yyvsp[-1].al));
	}
#line 4016 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 45: /* $@10: %empty  */
#line 571 "frontends/verilog/verilog_parser.y"
                            {
		if (astbuf1) delete astbuf1;
		astbuf1 = new AstNode(AST_LOCALPARAM);
		astbuf1->children.push_back(AstNode::mkconst_int(0, true));
		append_attr(astbuf1, (yyvsp[-1].al));
	}
#line 4027 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 55: /* module_arg_opt_assignment: '=' expr  */
#line 589 "frontends/verilog/verilog_parser.y"
                 {
		if (ast_stack.back()->children.size() > 0 && ast_stack.back()->children.back()->type == AST_WIRE) {
			if (ast_stack.back()->children.back()->is_input) {
				AstNode *n = ast_stack.back()->children.back();
				if (n->attributes.count(ID::defaultvalue))
					delete n->attributes.at(ID::defaultvalue);
				n->attributes[ID::defaultvalue] = (yyvsp[0].ast);
			} else {
				AstNode *wire = new AstNode(AST_IDENTIFIER);
				wire->str = ast_stack.back()->children.back()->str;
				if (ast_stack.back()->children.back()->is_reg || ast_stack.back()->children.back()->is_logic)
					ast_stack.back()->children.push_back(new AstNode(AST_INITIAL, new AstNode(AST_BLOCK, new AstNode(AST_ASSIGN_LE, wire, (yyvsp[0].ast)))));
				else
					ast_stack.back()->children.push_back(new AstNode(AST_ASSIGN, wire, (yyvsp[0].ast)));
			}
		} else
			frontend_verilog_yyerror("SystemVerilog interface in module port list cannot have a default value.");
	}
#line 4050 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 57: /* $@11: %empty  */
#line 610 "frontends/verilog/verilog_parser.y"
               {
		if (ast_stack.back()->children.size() > 0 && ast_stack.back()->children.back()->type == AST_WIRE) {
			AstNode *node = ast_stack.back()->children.back()->clone();
			node->str = *(yyvsp[0].string);
			node->port_id = ++port_counter;
			ast_stack.back()->children.push_back(node);
			SET_AST_NODE_LOC(node, (yylsp[0]), (yylsp[0]));
		} else {
			if (port_stubs.count(*(yyvsp[0].string)) != 0)
				frontend_verilog_yyerror("Duplicate module port `%s'.", (yyvsp[0].string)->c_str());
			port_stubs[*(yyvsp[0].string)] = ++port_counter;
		}
		delete (yyvsp[0].string);
	}
#line 4069 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 59: /* $@12: %empty  */
#line 624 "frontends/verilog/verilog_parser.y"
               {
		astbuf1 = new AstNode(AST_INTERFACEPORT);
		astbuf1->children.push_back(new AstNode(AST_INTERFACEPORTTYPE));
		astbuf1->children[0]->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 4080 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 60: /* $@13: %empty  */
#line 629 "frontends/verilog/verilog_parser.y"
                 {  /* SV interfaces */
		if (!sv_mode)
			frontend_verilog_yyerror("Interface found in port list (%s). This is not supported unless read_verilog is called with -sv!", (yyvsp[0].string)->c_str());
		astbuf2 = astbuf1->clone(); // really only needed if multiple instances of same type.
		astbuf2->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		astbuf2->port_id = ++port_counter;
		ast_stack.back()->children.push_back(astbuf2);
		delete astbuf1; // really only needed if multiple instances of same type.
	}
#line 4095 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 62: /* $@14: %empty  */
#line 639 "frontends/verilog/verilog_parser.y"
                                    {
		AstNode *node = (yyvsp[-2].ast);
		node->str = *(yyvsp[0].string);
		SET_AST_NODE_LOC(node, (yylsp[0]), (yylsp[0]));
		node->port_id = ++port_counter;
		AstNode *range = checkRange(node, (yyvsp[-1].ast));
		if (range != NULL)
			node->children.push_back(range);
		if (!node->is_input && !node->is_output)
			frontend_verilog_yyerror("Module port `%s' is neither input nor output.", (yyvsp[0].string)->c_str());
		if (node->is_reg && node->is_input && !node->is_output && !sv_mode)
			frontend_verilog_yyerror("Input port `%s' is declared as register.", (yyvsp[0].string)->c_str());
		ast_stack.back()->children.push_back(node);
		append_attr(node, (yyvsp[-3].al));
		delete (yyvsp[0].string);
	}
#line 4116 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 64: /* module_arg: '.' '.' '.'  */
#line 655 "frontends/verilog/verilog_parser.y"
                    {
		do_not_require_port_stubs = true;
	}
#line 4124 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 65: /* $@15: %empty  */
#line 660 "frontends/verilog/verilog_parser.y"
                         {
		enterTypeScope();
	}
#line 4132 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 66: /* $@16: %empty  */
#line 662 "frontends/verilog/verilog_parser.y"
                 {
		AstNode *mod = new AstNode(AST_PACKAGE);
		ast_stack.back()->children.push_back(mod);
		ast_stack.push_back(mod);
		current_ast_mod = mod;
		mod->str = *(yyvsp[0].string);
		append_attr(mod, (yyvsp[-3].al));
	}
#line 4145 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 67: /* package: attr TOK_PACKAGE $@15 TOK_ID $@16 ';' package_body TOK_ENDPACKAGE opt_label  */
#line 669 "frontends/verilog/verilog_parser.y"
                                                    {
		ast_stack.pop_back();
		checkLabelsMatch("Package name", (yyvsp[-5].string), (yyvsp[0].string));
		current_ast_mod = NULL;
		delete (yyvsp[-5].string);
		delete (yyvsp[0].string);
		exitTypeScope();
	}
#line 4158 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 74: /* $@17: %empty  */
#line 685 "frontends/verilog/verilog_parser.y"
                      {
		enterTypeScope();
	}
#line 4166 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 75: /* $@18: %empty  */
#line 687 "frontends/verilog/verilog_parser.y"
                 {
		do_not_require_port_stubs = false;
		AstNode *intf = new AstNode(AST_INTERFACE);
		ast_stack.back()->children.push_back(intf);
		ast_stack.push_back(intf);
		current_ast_mod = intf;
		port_stubs.clear();
		port_counter = 0;
		intf->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 4182 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 76: /* interface: TOK_INTERFACE $@17 TOK_ID $@18 module_para_opt module_args_opt ';' interface_body TOK_ENDINTERFACE  */
#line 697 "frontends/verilog/verilog_parser.y"
                                                                              {
		if (port_stubs.size() != 0)
			frontend_verilog_yyerror("Missing details for module port `%s'.",
				port_stubs.begin()->first.c_str());
		ast_stack.pop_back();
		log_assert(ast_stack.size() == 1);
		current_ast_mod = NULL;
		exitTypeScope();
	}
#line 4196 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 88: /* $@19: %empty  */
#line 715 "frontends/verilog/verilog_parser.y"
                 {
		AstNode *bnode = new AstNode(AST_BIND);
		ast_stack.back()->children.push_back(bnode);
		ast_stack.push_back(bnode);
	}
#line 4206 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 89: /* $@20: %empty  */
#line 720 "frontends/verilog/verilog_parser.y"
                    {
		// bind_target should have added at least one child
		log_assert(ast_stack.back()->children.size() >= 1);
	}
#line 4215 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 90: /* $@21: %empty  */
#line 724 "frontends/verilog/verilog_parser.y"
               {
		// The single_cell parser in cell_list_no_array uses astbuf1 as
		// a sort of template for constructing cells.
		astbuf1 = new AstNode(AST_CELL);
		astbuf1->children.push_back(new AstNode(AST_CELLTYPE));
		astbuf1->children[0]->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 4228 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 91: /* bind_directive: TOK_BIND $@19 bind_target $@20 TOK_ID $@21 cell_parameter_list_opt cell_list_no_array ';'  */
#line 732 "frontends/verilog/verilog_parser.y"
                                                       {
		// cell_list should have added at least one more child
		log_assert(ast_stack.back()->children.size() >= 2);
		delete astbuf1;
		ast_stack.pop_back();
	}
#line 4239 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 97: /* bind_target_instance: hierarchical_id  */
#line 767 "frontends/verilog/verilog_parser.y"
                        {
		auto *node = new AstNode(AST_IDENTIFIER);
		node->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		ast_stack.back()->children.push_back(node);
	}
#line 4250 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 98: /* mintypmax_expr: expr  */
#line 775 "frontends/verilog/verilog_parser.y"
             { delete (yyvsp[0].ast); }
#line 4256 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 99: /* mintypmax_expr: expr ':' expr ':' expr  */
#line 776 "frontends/verilog/verilog_parser.y"
                               { delete (yyvsp[-4].ast); delete (yyvsp[-2].ast); delete (yyvsp[0].ast); }
#line 4262 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 100: /* non_opt_delay: '#' TOK_ID  */
#line 779 "frontends/verilog/verilog_parser.y"
                   { delete (yyvsp[0].string); }
#line 4268 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 101: /* non_opt_delay: '#' TOK_CONSTVAL  */
#line 780 "frontends/verilog/verilog_parser.y"
                         { delete (yyvsp[0].string); }
#line 4274 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 102: /* non_opt_delay: '#' TOK_REALVAL  */
#line 781 "frontends/verilog/verilog_parser.y"
                        { delete (yyvsp[0].string); }
#line 4280 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 110: /* $@22: %empty  */
#line 793 "frontends/verilog/verilog_parser.y"
        { astbuf3 = new AstNode(AST_WIRE); current_wire_rand = false; current_wire_const = false; }
#line 4286 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 111: /* io_wire_type: $@22 wire_type_token_io wire_type_const_rand opt_wire_type_token wire_type_signedness  */
#line 795 "frontends/verilog/verilog_parser.y"
        { (yyval.ast) = astbuf3; SET_RULE_LOC((yyloc), (yylsp[-3]), (yyloc)); }
#line 4292 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 112: /* $@23: %empty  */
#line 798 "frontends/verilog/verilog_parser.y"
        { astbuf3 = new AstNode(AST_WIRE); current_wire_rand = false; current_wire_const = false; }
#line 4298 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 113: /* non_io_wire_type: $@23 wire_type_const_rand wire_type_token wire_type_signedness  */
#line 800 "frontends/verilog/verilog_parser.y"
        { (yyval.ast) = astbuf3; SET_RULE_LOC((yyloc), (yylsp[-2]), (yyloc)); }
#line 4304 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 116: /* wire_type_token_io: TOK_INPUT  */
#line 807 "frontends/verilog/verilog_parser.y"
                  {
		astbuf3->is_input = true;
	}
#line 4312 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 117: /* wire_type_token_io: TOK_OUTPUT  */
#line 810 "frontends/verilog/verilog_parser.y"
                   {
		astbuf3->is_output = true;
	}
#line 4320 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 118: /* wire_type_token_io: TOK_INOUT  */
#line 813 "frontends/verilog/verilog_parser.y"
                  {
		astbuf3->is_input = true;
		astbuf3->is_output = true;
	}
#line 4329 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 119: /* wire_type_signedness: TOK_SIGNED  */
#line 819 "frontends/verilog/verilog_parser.y"
                     { astbuf3->is_signed = true;  }
#line 4335 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 120: /* wire_type_signedness: TOK_UNSIGNED  */
#line 820 "frontends/verilog/verilog_parser.y"
                     { astbuf3->is_signed = false; }
#line 4341 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 122: /* wire_type_const_rand: TOK_RAND TOK_CONST  */
#line 824 "frontends/verilog/verilog_parser.y"
                           {
	    current_wire_rand = true;
	    current_wire_const = true;
	}
#line 4350 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 123: /* wire_type_const_rand: TOK_CONST  */
#line 828 "frontends/verilog/verilog_parser.y"
                  {
	    current_wire_const = true;
	}
#line 4358 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 124: /* wire_type_const_rand: TOK_RAND  */
#line 831 "frontends/verilog/verilog_parser.y"
                 {
	    current_wire_rand = true;
	}
#line 4366 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 128: /* wire_type_token: net_type  */
#line 841 "frontends/verilog/verilog_parser.y"
                 {
	}
#line 4373 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 129: /* wire_type_token: net_type logic_type  */
#line 843 "frontends/verilog/verilog_parser.y"
                            {
	}
#line 4380 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 130: /* wire_type_token: TOK_REG  */
#line 846 "frontends/verilog/verilog_parser.y"
                {
		astbuf3->is_reg = true;
	}
#line 4388 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 131: /* wire_type_token: TOK_VAR TOK_REG  */
#line 849 "frontends/verilog/verilog_parser.y"
                        {
		astbuf3->is_reg = true;
	}
#line 4396 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 132: /* wire_type_token: TOK_VAR  */
#line 853 "frontends/verilog/verilog_parser.y"
                {
		astbuf3->is_logic = true;
	}
#line 4404 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 133: /* wire_type_token: TOK_VAR logic_type  */
#line 856 "frontends/verilog/verilog_parser.y"
                           {
		astbuf3->is_logic = true;
	}
#line 4412 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 134: /* wire_type_token: logic_type  */
#line 859 "frontends/verilog/verilog_parser.y"
                   {
		astbuf3->is_logic = true;
	}
#line 4420 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 135: /* wire_type_token: TOK_GENVAR  */
#line 862 "frontends/verilog/verilog_parser.y"
                   {
		astbuf3->type = AST_GENVAR;
		astbuf3->is_reg = true;
		astbuf3->is_signed = true;
		astbuf3->range_left = 31;
		astbuf3->range_right = 0;
	}
#line 4432 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 136: /* net_type: TOK_WOR  */
#line 871 "frontends/verilog/verilog_parser.y"
                {
		astbuf3->is_wor = true;
	}
#line 4440 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 137: /* net_type: TOK_WAND  */
#line 874 "frontends/verilog/verilog_parser.y"
                 {
		astbuf3->is_wand = true;
	}
#line 4448 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 139: /* logic_type: TOK_LOGIC  */
#line 880 "frontends/verilog/verilog_parser.y"
                  {
	}
#line 4455 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 140: /* logic_type: integer_atom_type  */
#line 882 "frontends/verilog/verilog_parser.y"
                          {
		astbuf3->range_left = (yyvsp[0].integer) - 1;
		astbuf3->range_right = 0;
		astbuf3->is_signed = true;
	}
#line 4465 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 141: /* logic_type: hierarchical_type_id  */
#line 887 "frontends/verilog/verilog_parser.y"
                             {
		addWiretypeNode((yyvsp[0].string), astbuf3);
	}
#line 4473 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 142: /* integer_atom_type: TOK_INTEGER  */
#line 892 "frontends/verilog/verilog_parser.y"
                        { (yyval.integer) = 32; }
#line 4479 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 143: /* integer_atom_type: TOK_INT  */
#line 893 "frontends/verilog/verilog_parser.y"
                        { (yyval.integer) = 32; }
#line 4485 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 144: /* integer_atom_type: TOK_SHORTINT  */
#line 894 "frontends/verilog/verilog_parser.y"
                        { (yyval.integer) = 16; }
#line 4491 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 145: /* integer_atom_type: TOK_LONGINT  */
#line 895 "frontends/verilog/verilog_parser.y"
                        { (yyval.integer) = 64; }
#line 4497 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 146: /* integer_atom_type: TOK_BYTE  */
#line 896 "frontends/verilog/verilog_parser.y"
                        { (yyval.integer) =  8; }
#line 4503 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 147: /* integer_vector_type: TOK_LOGIC  */
#line 899 "frontends/verilog/verilog_parser.y"
                  { (yyval.integer) = TOK_LOGIC; }
#line 4509 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 148: /* integer_vector_type: TOK_REG  */
#line 900 "frontends/verilog/verilog_parser.y"
                  { (yyval.integer) = TOK_REG; }
#line 4515 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 149: /* non_opt_range: '[' expr ':' expr ']'  */
#line 903 "frontends/verilog/verilog_parser.y"
                              {
		(yyval.ast) = new AstNode(AST_RANGE);
		(yyval.ast)->children.push_back((yyvsp[-3].ast));
		(yyval.ast)->children.push_back((yyvsp[-1].ast));
	}
#line 4525 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 150: /* non_opt_range: '[' expr TOK_POS_INDEXED expr ']'  */
#line 908 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_RANGE);
		AstNode *expr = new AstNode(AST_SELFSZ, (yyvsp[-3].ast));
		(yyval.ast)->children.push_back(new AstNode(AST_SUB, new AstNode(AST_ADD, expr->clone(), (yyvsp[-1].ast)), AstNode::mkconst_int(1, true)));
		(yyval.ast)->children.push_back(new AstNode(AST_ADD, expr, AstNode::mkconst_int(0, true)));
	}
#line 4536 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 151: /* non_opt_range: '[' expr TOK_NEG_INDEXED expr ']'  */
#line 914 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_RANGE);
		AstNode *expr = new AstNode(AST_SELFSZ, (yyvsp[-3].ast));
		(yyval.ast)->children.push_back(new AstNode(AST_ADD, expr, AstNode::mkconst_int(0, true)));
		(yyval.ast)->children.push_back(new AstNode(AST_SUB, new AstNode(AST_ADD, expr->clone(), AstNode::mkconst_int(1, true)), (yyvsp[-1].ast)));
	}
#line 4547 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 152: /* non_opt_range: '[' expr ']'  */
#line 920 "frontends/verilog/verilog_parser.y"
                     {
		(yyval.ast) = new AstNode(AST_RANGE);
		(yyval.ast)->children.push_back((yyvsp[-1].ast));
	}
#line 4556 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 153: /* non_opt_multirange: non_opt_range non_opt_range  */
#line 926 "frontends/verilog/verilog_parser.y"
                                    {
		(yyval.ast) = new AstNode(AST_MULTIRANGE, (yyvsp[-1].ast), (yyvsp[0].ast));
	}
#line 4564 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 154: /* non_opt_multirange: non_opt_multirange non_opt_range  */
#line 929 "frontends/verilog/verilog_parser.y"
                                         {
		(yyval.ast) = (yyvsp[-1].ast);
		(yyval.ast)->children.push_back((yyvsp[0].ast));
	}
#line 4573 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 155: /* range: non_opt_range  */
#line 935 "frontends/verilog/verilog_parser.y"
                      {
		(yyval.ast) = (yyvsp[0].ast);
	}
#line 4581 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 156: /* range: %empty  */
#line 938 "frontends/verilog/verilog_parser.y"
               {
		(yyval.ast) = NULL;
	}
#line 4589 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 157: /* range_or_multirange: range  */
#line 943 "frontends/verilog/verilog_parser.y"
              { (yyval.ast) = (yyvsp[0].ast); }
#line 4595 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 158: /* range_or_multirange: non_opt_multirange  */
#line 944 "frontends/verilog/verilog_parser.y"
                           { (yyval.ast) = (yyvsp[0].ast); }
#line 4601 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 183: /* $@24: %empty  */
#line 960 "frontends/verilog/verilog_parser.y"
                               {
		AstNode *node = new AstNode(AST_GENBLOCK);
		node->str = *(yyvsp[-1].string);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 4612 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 184: /* checker_decl: TOK_CHECKER TOK_ID ';' $@24 module_body TOK_ENDCHECKER  */
#line 965 "frontends/verilog/verilog_parser.y"
                                     {
		delete (yyvsp[-4].string);
		ast_stack.pop_back();
	}
#line 4621 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 185: /* $@25: %empty  */
#line 971 "frontends/verilog/verilog_parser.y"
                                            {
		current_function_or_task = new AstNode(AST_DPI_FUNCTION, AstNode::mkconst_str(*(yyvsp[-1].string)), AstNode::mkconst_str(*(yyvsp[0].string)));
		current_function_or_task->str = *(yyvsp[0].string);
		append_attr(current_function_or_task, (yyvsp[-3].al));
		ast_stack.back()->children.push_back(current_function_or_task);
		delete (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 4634 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 186: /* task_func_decl: attr TOK_DPI_FUNCTION TOK_ID TOK_ID $@25 opt_dpi_function_args ';'  */
#line 978 "frontends/verilog/verilog_parser.y"
                                    {
		current_function_or_task = NULL;
	}
#line 4642 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 187: /* $@26: %empty  */
#line 981 "frontends/verilog/verilog_parser.y"
                                                       {
		current_function_or_task = new AstNode(AST_DPI_FUNCTION, AstNode::mkconst_str(*(yyvsp[-1].string)), AstNode::mkconst_str(*(yyvsp[-3].string)));
		current_function_or_task->str = *(yyvsp[0].string);
		append_attr(current_function_or_task, (yyvsp[-5].al));
		ast_stack.back()->children.push_back(current_function_or_task);
		delete (yyvsp[-3].string);
		delete (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 4656 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 188: /* task_func_decl: attr TOK_DPI_FUNCTION TOK_ID '=' TOK_ID TOK_ID $@26 opt_dpi_function_args ';'  */
#line 989 "frontends/verilog/verilog_parser.y"
                                    {
		current_function_or_task = NULL;
	}
#line 4664 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 189: /* $@27: %empty  */
#line 992 "frontends/verilog/verilog_parser.y"
                                                                  {
		current_function_or_task = new AstNode(AST_DPI_FUNCTION, AstNode::mkconst_str(*(yyvsp[-1].string)), AstNode::mkconst_str(*(yyvsp[-5].string) + ":" + RTLIL::unescape_id(*(yyvsp[-3].string))));
		current_function_or_task->str = *(yyvsp[0].string);
		append_attr(current_function_or_task, (yyvsp[-7].al));
		ast_stack.back()->children.push_back(current_function_or_task);
		delete (yyvsp[-5].string);
		delete (yyvsp[-3].string);
		delete (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 4679 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 190: /* task_func_decl: attr TOK_DPI_FUNCTION TOK_ID ':' TOK_ID '=' TOK_ID TOK_ID $@27 opt_dpi_function_args ';'  */
#line 1001 "frontends/verilog/verilog_parser.y"
                                    {
		current_function_or_task = NULL;
	}
#line 4687 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 191: /* $@28: %empty  */
#line 1004 "frontends/verilog/verilog_parser.y"
                                           {
		current_function_or_task = new AstNode(AST_TASK);
		current_function_or_task->str = *(yyvsp[0].string);
		append_attr(current_function_or_task, (yyvsp[-3].al));
		ast_stack.back()->children.push_back(current_function_or_task);
		ast_stack.push_back(current_function_or_task);
		current_function_or_task_port_id = 1;
		delete (yyvsp[0].string);
	}
#line 4701 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 192: /* task_func_decl: attr TOK_TASK opt_automatic TOK_ID $@28 task_func_args_opt ';' task_func_body TOK_ENDTASK  */
#line 1012 "frontends/verilog/verilog_parser.y"
                                                            {
		current_function_or_task = NULL;
		ast_stack.pop_back();
	}
#line 4710 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 193: /* $@29: %empty  */
#line 1016 "frontends/verilog/verilog_parser.y"
                                                                {
		current_function_or_task = new AstNode(AST_FUNCTION);
		current_function_or_task->str = *(yyvsp[0].string);
		append_attr(current_function_or_task, (yyvsp[-4].al));
		ast_stack.back()->children.push_back(current_function_or_task);
		ast_stack.push_back(current_function_or_task);
		AstNode *outreg = new AstNode(AST_WIRE);
		outreg->str = *(yyvsp[0].string);
		outreg->is_signed = false;
		outreg->is_reg = true;
		if ((yyvsp[-1].ast) != NULL) {
			outreg->children.push_back((yyvsp[-1].ast));
			outreg->is_signed = (yyvsp[-1].ast)->is_signed;
			(yyvsp[-1].ast)->is_signed = false;
			outreg->is_custom_type = (yyvsp[-1].ast)->type == AST_WIRETYPE;
		}
		current_function_or_task->children.push_back(outreg);
		current_function_or_task_port_id = 1;
		delete (yyvsp[0].string);
	}
#line 4735 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 194: /* task_func_decl: attr TOK_FUNCTION opt_automatic func_return_type TOK_ID $@29 task_func_args_opt ';' task_func_body TOK_ENDFUNCTION  */
#line 1035 "frontends/verilog/verilog_parser.y"
                                                                {
		current_function_or_task = NULL;
		ast_stack.pop_back();
	}
#line 4744 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 195: /* func_return_type: hierarchical_type_id  */
#line 1041 "frontends/verilog/verilog_parser.y"
                             {
		(yyval.ast) = new AstNode(AST_WIRETYPE);
		(yyval.ast)->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 4754 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 196: /* func_return_type: opt_type_vec opt_signedness_default_unsigned  */
#line 1046 "frontends/verilog/verilog_parser.y"
                                                     {
		(yyval.ast) = makeRange(0, 0, (yyvsp[0].boolean));
	}
#line 4762 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 197: /* func_return_type: opt_type_vec opt_signedness_default_unsigned non_opt_range  */
#line 1049 "frontends/verilog/verilog_parser.y"
                                                                   {
		(yyval.ast) = (yyvsp[0].ast);
		(yyval.ast)->is_signed = (yyvsp[-1].boolean);
	}
#line 4771 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 198: /* func_return_type: integer_atom_type opt_signedness_default_signed  */
#line 1053 "frontends/verilog/verilog_parser.y"
                                                        {
		(yyval.ast) = makeRange((yyvsp[-1].integer) - 1, 0, (yyvsp[0].boolean));
	}
#line 4779 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 202: /* opt_signedness_default_signed: %empty  */
#line 1064 "frontends/verilog/verilog_parser.y"
                        { (yyval.boolean) = true; }
#line 4785 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 203: /* opt_signedness_default_signed: TOK_SIGNED  */
#line 1065 "frontends/verilog/verilog_parser.y"
                        { (yyval.boolean) = true; }
#line 4791 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 204: /* opt_signedness_default_signed: TOK_UNSIGNED  */
#line 1066 "frontends/verilog/verilog_parser.y"
                        { (yyval.boolean) = false; }
#line 4797 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 205: /* opt_signedness_default_unsigned: %empty  */
#line 1069 "frontends/verilog/verilog_parser.y"
                        { (yyval.boolean) = false; }
#line 4803 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 206: /* opt_signedness_default_unsigned: TOK_SIGNED  */
#line 1070 "frontends/verilog/verilog_parser.y"
                        { (yyval.boolean) = true; }
#line 4809 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 207: /* opt_signedness_default_unsigned: TOK_UNSIGNED  */
#line 1071 "frontends/verilog/verilog_parser.y"
                        { (yyval.boolean) = false; }
#line 4815 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 208: /* dpi_function_arg: TOK_ID TOK_ID  */
#line 1075 "frontends/verilog/verilog_parser.y"
                      {
		current_function_or_task->children.push_back(AstNode::mkconst_str(*(yyvsp[-1].string)));
		delete (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 4825 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 209: /* dpi_function_arg: TOK_ID  */
#line 1080 "frontends/verilog/verilog_parser.y"
               {
		current_function_or_task->children.push_back(AstNode::mkconst_str(*(yyvsp[0].string)));
		delete (yyvsp[0].string);
	}
#line 4834 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 220: /* $@30: %empty  */
#line 1100 "frontends/verilog/verilog_parser.y"
                               {
		albuf = nullptr;
		astbuf1 = nullptr;
		astbuf2 = nullptr;
	}
#line 4844 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 221: /* $@31: %empty  */
#line 1104 "frontends/verilog/verilog_parser.y"
                                        {
		delete astbuf1;
		if (astbuf2 != NULL)
			delete astbuf2;
		free_attr(albuf);
	}
#line 4855 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 225: /* $@32: %empty  */
#line 1115 "frontends/verilog/verilog_parser.y"
                             {
		bool prev_was_input = true;
		bool prev_was_output = false;
		if (albuf) {
			prev_was_input = astbuf1->is_input;
			prev_was_output = astbuf1->is_output;
			delete astbuf1;
			if (astbuf2 != NULL)
				delete astbuf2;
			free_attr(albuf);
		}
		albuf = (yyvsp[-2].al);
		astbuf1 = (yyvsp[-1].ast);
		astbuf2 = checkRange(astbuf1, (yyvsp[0].ast));
		if (!astbuf1->is_input && !astbuf1->is_output) {
			if (!sv_mode)
				frontend_verilog_yyerror("task/function argument direction missing");
			astbuf1->is_input = prev_was_input;
			astbuf1->is_output = prev_was_output;
		}
	}
#line 4881 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 227: /* $@33: %empty  */
#line 1136 "frontends/verilog/verilog_parser.y"
        {
		if (!astbuf1) {
			if (!sv_mode)
				frontend_verilog_yyerror("task/function argument direction missing");
			albuf = new dict<IdString, AstNode*>;
			astbuf1 = new AstNode(AST_WIRE);
			current_wire_rand = false;
			current_wire_const = false;
			astbuf1->is_input = true;
			astbuf2 = NULL;
		}
	}
#line 4898 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 234: /* specify_item: specify_if '(' specify_edge expr TOK_SPECIFY_OPER specify_target ')' '=' specify_rise_fall ';'  */
#line 1163 "frontends/verilog/verilog_parser.y"
                                                                                                       {
		AstNode *en_expr = (yyvsp[-9].ast);
		char specify_edge = (yyvsp[-7].ch);
		AstNode *src_expr = (yyvsp[-6].ast);
		string *oper = (yyvsp[-5].string);
		specify_target *target = (yyvsp[-4].specify_target_ptr);
		specify_rise_fall *timing = (yyvsp[-1].specify_rise_fall_ptr);

		if (specify_edge != 0 && target->dat == nullptr)
			frontend_verilog_yyerror("Found specify edge but no data spec.\n");

		AstNode *cell = new AstNode(AST_CELL);
		ast_stack.back()->children.push_back(cell);
		cell->str = stringf("$specify$%d", autoidx++);
		cell->children.push_back(new AstNode(AST_CELLTYPE));
		cell->children.back()->str = target->dat ? "$specify3" : "$specify2";
		SET_AST_NODE_LOC(cell, en_expr ? (yylsp[-9]) : (yylsp[-8]), (yylsp[0]));

		char oper_polarity = 0;
		char oper_type = oper->at(0);

		if (oper->size() == 3) {
			oper_polarity = oper->at(0);
			oper_type = oper->at(1);
		}

		cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(oper_type == '*', false, 1)));
		cell->children.back()->str = "\\FULL";

		cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(oper_polarity != 0, false, 1)));
		cell->children.back()->str = "\\SRC_DST_PEN";

		cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(oper_polarity == '+', false, 1)));
		cell->children.back()->str = "\\SRC_DST_POL";

		cell->children.push_back(new AstNode(AST_PARASET, timing->rise.t_min));
		cell->children.back()->str = "\\T_RISE_MIN";

		cell->children.push_back(new AstNode(AST_PARASET, timing->rise.t_avg));
		cell->children.back()->str = "\\T_RISE_TYP";

		cell->children.push_back(new AstNode(AST_PARASET, timing->rise.t_max));
		cell->children.back()->str = "\\T_RISE_MAX";

		cell->children.push_back(new AstNode(AST_PARASET, timing->fall.t_min));
		cell->children.back()->str = "\\T_FALL_MIN";

		cell->children.push_back(new AstNode(AST_PARASET, timing->fall.t_avg));
		cell->children.back()->str = "\\T_FALL_TYP";

		cell->children.push_back(new AstNode(AST_PARASET, timing->fall.t_max));
		cell->children.back()->str = "\\T_FALL_MAX";

		cell->children.push_back(new AstNode(AST_ARGUMENT, en_expr ? en_expr : AstNode::mkconst_int(1, false, 1)));
		cell->children.back()->str = "\\EN";

		cell->children.push_back(new AstNode(AST_ARGUMENT, src_expr));
		cell->children.back()->str = "\\SRC";

		cell->children.push_back(new AstNode(AST_ARGUMENT, target->dst));
		cell->children.back()->str = "\\DST";

		if (target->dat)
		{
			cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(specify_edge != 0, false, 1)));
			cell->children.back()->str = "\\EDGE_EN";

			cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(specify_edge == 'p', false, 1)));
			cell->children.back()->str = "\\EDGE_POL";

			cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(target->polarity_op != 0, false, 1)));
			cell->children.back()->str = "\\DAT_DST_PEN";

			cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_int(target->polarity_op == '+', false, 1)));
			cell->children.back()->str = "\\DAT_DST_POL";

			cell->children.push_back(new AstNode(AST_ARGUMENT, target->dat));
			cell->children.back()->str = "\\DAT";
		}

		delete oper;
		delete target;
		delete timing;
	}
#line 4987 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 235: /* specify_item: TOK_ID '(' specify_edge expr specify_condition ',' specify_edge expr specify_condition ',' specify_triple specify_opt_triple ')' ';'  */
#line 1247 "frontends/verilog/verilog_parser.y"
                                                                                                                                             {
		if (*(yyvsp[-13].string) != "$setup" && *(yyvsp[-13].string) != "$hold" && *(yyvsp[-13].string) != "$setuphold" && *(yyvsp[-13].string) != "$removal" && *(yyvsp[-13].string) != "$recovery" &&
				*(yyvsp[-13].string) != "$recrem" && *(yyvsp[-13].string) != "$skew" && *(yyvsp[-13].string) != "$timeskew" && *(yyvsp[-13].string) != "$fullskew" && *(yyvsp[-13].string) != "$nochange")
			frontend_verilog_yyerror("Unsupported specify rule type: %s\n", (yyvsp[-13].string)->c_str());

		AstNode *src_pen = AstNode::mkconst_int((yyvsp[-11].ch) != 0, false, 1);
		AstNode *src_pol = AstNode::mkconst_int((yyvsp[-11].ch) == 'p', false, 1);
		AstNode *src_expr = (yyvsp[-10].ast), *src_en = (yyvsp[-9].ast) ? (yyvsp[-9].ast) : AstNode::mkconst_int(1, false, 1);

		AstNode *dst_pen = AstNode::mkconst_int((yyvsp[-7].ch) != 0, false, 1);
		AstNode *dst_pol = AstNode::mkconst_int((yyvsp[-7].ch) == 'p', false, 1);
		AstNode *dst_expr = (yyvsp[-6].ast), *dst_en = (yyvsp[-5].ast) ? (yyvsp[-5].ast) : AstNode::mkconst_int(1, false, 1);

		specify_triple *limit = (yyvsp[-3].specify_triple_ptr);
		specify_triple *limit2 = (yyvsp[-2].specify_triple_ptr);

		AstNode *cell = new AstNode(AST_CELL);
		ast_stack.back()->children.push_back(cell);
		cell->str = stringf("$specify$%d", autoidx++);
		cell->children.push_back(new AstNode(AST_CELLTYPE));
		cell->children.back()->str = "$specrule";
		SET_AST_NODE_LOC(cell, (yylsp[-13]), (yylsp[0]));

		cell->children.push_back(new AstNode(AST_PARASET, AstNode::mkconst_str(*(yyvsp[-13].string))));
		cell->children.back()->str = "\\TYPE";

		cell->children.push_back(new AstNode(AST_PARASET, limit->t_min));
		cell->children.back()->str = "\\T_LIMIT_MIN";

		cell->children.push_back(new AstNode(AST_PARASET, limit->t_avg));
		cell->children.back()->str = "\\T_LIMIT_TYP";

		cell->children.push_back(new AstNode(AST_PARASET, limit->t_max));
		cell->children.back()->str = "\\T_LIMIT_MAX";

		cell->children.push_back(new AstNode(AST_PARASET, limit2 ? limit2->t_min : AstNode::mkconst_int(0, true)));
		cell->children.back()->str = "\\T_LIMIT2_MIN";

		cell->children.push_back(new AstNode(AST_PARASET, limit2 ? limit2->t_avg : AstNode::mkconst_int(0, true)));
		cell->children.back()->str = "\\T_LIMIT2_TYP";

		cell->children.push_back(new AstNode(AST_PARASET, limit2 ? limit2->t_max : AstNode::mkconst_int(0, true)));
		cell->children.back()->str = "\\T_LIMIT2_MAX";

		cell->children.push_back(new AstNode(AST_PARASET, src_pen));
		cell->children.back()->str = "\\SRC_PEN";

		cell->children.push_back(new AstNode(AST_PARASET, src_pol));
		cell->children.back()->str = "\\SRC_POL";

		cell->children.push_back(new AstNode(AST_PARASET, dst_pen));
		cell->children.back()->str = "\\DST_PEN";

		cell->children.push_back(new AstNode(AST_PARASET, dst_pol));
		cell->children.back()->str = "\\DST_POL";

		cell->children.push_back(new AstNode(AST_ARGUMENT, src_en));
		cell->children.back()->str = "\\SRC_EN";

		cell->children.push_back(new AstNode(AST_ARGUMENT, src_expr));
		cell->children.back()->str = "\\SRC";

		cell->children.push_back(new AstNode(AST_ARGUMENT, dst_en));
		cell->children.back()->str = "\\DST_EN";

		cell->children.push_back(new AstNode(AST_ARGUMENT, dst_expr));
		cell->children.back()->str = "\\DST";

		delete (yyvsp[-13].string);
		delete limit;
		delete limit2;
	}
#line 5064 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 236: /* specify_opt_triple: ',' specify_triple  */
#line 1321 "frontends/verilog/verilog_parser.y"
                           {
		(yyval.specify_triple_ptr) = (yyvsp[0].specify_triple_ptr);
	}
#line 5072 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 237: /* specify_opt_triple: %empty  */
#line 1324 "frontends/verilog/verilog_parser.y"
               {
		(yyval.specify_triple_ptr) = nullptr;
	}
#line 5080 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 238: /* specify_if: TOK_IF '(' expr ')'  */
#line 1329 "frontends/verilog/verilog_parser.y"
                            {
		(yyval.ast) = (yyvsp[-1].ast);
	}
#line 5088 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 239: /* specify_if: %empty  */
#line 1332 "frontends/verilog/verilog_parser.y"
               {
		(yyval.ast) = nullptr;
	}
#line 5096 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 240: /* specify_condition: TOK_SPECIFY_AND expr  */
#line 1337 "frontends/verilog/verilog_parser.y"
                             {
		(yyval.ast) = (yyvsp[0].ast);
	}
#line 5104 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 241: /* specify_condition: %empty  */
#line 1340 "frontends/verilog/verilog_parser.y"
               {
		(yyval.ast) = nullptr;
	}
#line 5112 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 242: /* specify_target: expr  */
#line 1345 "frontends/verilog/verilog_parser.y"
             {
		(yyval.specify_target_ptr) = new specify_target;
		(yyval.specify_target_ptr)->polarity_op = 0;
		(yyval.specify_target_ptr)->dst = (yyvsp[0].ast);
		(yyval.specify_target_ptr)->dat = nullptr;
	}
#line 5123 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 243: /* specify_target: '(' expr ':' expr ')'  */
#line 1351 "frontends/verilog/verilog_parser.y"
                             {
		(yyval.specify_target_ptr) = new specify_target;
		(yyval.specify_target_ptr)->polarity_op = 0;
		(yyval.specify_target_ptr)->dst = (yyvsp[-3].ast);
		(yyval.specify_target_ptr)->dat = (yyvsp[-1].ast);
	}
#line 5134 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 244: /* specify_target: '(' expr TOK_NEG_INDEXED expr ')'  */
#line 1357 "frontends/verilog/verilog_parser.y"
                                         {
		(yyval.specify_target_ptr) = new specify_target;
		(yyval.specify_target_ptr)->polarity_op = '-';
		(yyval.specify_target_ptr)->dst = (yyvsp[-3].ast);
		(yyval.specify_target_ptr)->dat = (yyvsp[-1].ast);
	}
#line 5145 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 245: /* specify_target: '(' expr TOK_POS_INDEXED expr ')'  */
#line 1363 "frontends/verilog/verilog_parser.y"
                                         {
		(yyval.specify_target_ptr) = new specify_target;
		(yyval.specify_target_ptr)->polarity_op = '+';
		(yyval.specify_target_ptr)->dst = (yyvsp[-3].ast);
		(yyval.specify_target_ptr)->dat = (yyvsp[-1].ast);
	}
#line 5156 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 246: /* specify_edge: TOK_POSEDGE  */
#line 1371 "frontends/verilog/verilog_parser.y"
                    { (yyval.ch) = 'p'; }
#line 5162 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 247: /* specify_edge: TOK_NEGEDGE  */
#line 1372 "frontends/verilog/verilog_parser.y"
                    { (yyval.ch) = 'n'; }
#line 5168 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 248: /* specify_edge: %empty  */
#line 1373 "frontends/verilog/verilog_parser.y"
               { (yyval.ch) = 0; }
#line 5174 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 249: /* specify_rise_fall: specify_triple  */
#line 1376 "frontends/verilog/verilog_parser.y"
                       {
		(yyval.specify_rise_fall_ptr) = new specify_rise_fall;
		(yyval.specify_rise_fall_ptr)->rise = *(yyvsp[0].specify_triple_ptr);
		(yyval.specify_rise_fall_ptr)->fall.t_min = (yyvsp[0].specify_triple_ptr)->t_min->clone();
		(yyval.specify_rise_fall_ptr)->fall.t_avg = (yyvsp[0].specify_triple_ptr)->t_avg->clone();
		(yyval.specify_rise_fall_ptr)->fall.t_max = (yyvsp[0].specify_triple_ptr)->t_max->clone();
		delete (yyvsp[0].specify_triple_ptr);
	}
#line 5187 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 250: /* specify_rise_fall: '(' specify_triple ',' specify_triple ')'  */
#line 1384 "frontends/verilog/verilog_parser.y"
                                                  {
		(yyval.specify_rise_fall_ptr) = new specify_rise_fall;
		(yyval.specify_rise_fall_ptr)->rise = *(yyvsp[-3].specify_triple_ptr);
		(yyval.specify_rise_fall_ptr)->fall = *(yyvsp[-1].specify_triple_ptr);
		delete (yyvsp[-3].specify_triple_ptr);
		delete (yyvsp[-1].specify_triple_ptr);
	}
#line 5199 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 251: /* specify_rise_fall: '(' specify_triple ',' specify_triple ',' specify_triple ')'  */
#line 1391 "frontends/verilog/verilog_parser.y"
                                                                     {
		(yyval.specify_rise_fall_ptr) = new specify_rise_fall;
		(yyval.specify_rise_fall_ptr)->rise = *(yyvsp[-5].specify_triple_ptr);
		(yyval.specify_rise_fall_ptr)->fall = *(yyvsp[-3].specify_triple_ptr);
		delete (yyvsp[-5].specify_triple_ptr);
		delete (yyvsp[-3].specify_triple_ptr);
		delete (yyvsp[-1].specify_triple_ptr);
		log_file_warning(current_filename, get_line_num(), "Path delay expressions beyond rise/fall not currently supported. Ignoring.\n");
	}
#line 5213 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 252: /* specify_rise_fall: '(' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ')'  */
#line 1400 "frontends/verilog/verilog_parser.y"
                                                                                                                              {
		(yyval.specify_rise_fall_ptr) = new specify_rise_fall;
		(yyval.specify_rise_fall_ptr)->rise = *(yyvsp[-11].specify_triple_ptr);
		(yyval.specify_rise_fall_ptr)->fall = *(yyvsp[-9].specify_triple_ptr);
		delete (yyvsp[-11].specify_triple_ptr);
		delete (yyvsp[-9].specify_triple_ptr);
		delete (yyvsp[-7].specify_triple_ptr);
		delete (yyvsp[-5].specify_triple_ptr);
		delete (yyvsp[-3].specify_triple_ptr);
		delete (yyvsp[-1].specify_triple_ptr);
		log_file_warning(current_filename, get_line_num(), "Path delay expressions beyond rise/fall not currently supported. Ignoring.\n");
	}
#line 5230 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 253: /* specify_rise_fall: '(' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ',' specify_triple ')'  */
#line 1412 "frontends/verilog/verilog_parser.y"
                                                                                                                                                                                                                                                {
		(yyval.specify_rise_fall_ptr) = new specify_rise_fall;
		(yyval.specify_rise_fall_ptr)->rise = *(yyvsp[-23].specify_triple_ptr);
		(yyval.specify_rise_fall_ptr)->fall = *(yyvsp[-21].specify_triple_ptr);
		delete (yyvsp[-23].specify_triple_ptr);
		delete (yyvsp[-21].specify_triple_ptr);
		delete (yyvsp[-19].specify_triple_ptr);
		delete (yyvsp[-17].specify_triple_ptr);
		delete (yyvsp[-15].specify_triple_ptr);
		delete (yyvsp[-13].specify_triple_ptr);
		delete (yyvsp[-11].specify_triple_ptr);
		delete (yyvsp[-9].specify_triple_ptr);
		delete (yyvsp[-7].specify_triple_ptr);
		delete (yyvsp[-5].specify_triple_ptr);
		delete (yyvsp[-3].specify_triple_ptr);
		delete (yyvsp[-1].specify_triple_ptr);
		log_file_warning(current_filename, get_line_num(), "Path delay expressions beyond rise/fall not currently supported. Ignoring.\n");
	}
#line 5253 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 254: /* specify_triple: expr  */
#line 1432 "frontends/verilog/verilog_parser.y"
             {
		(yyval.specify_triple_ptr) = new specify_triple;
		(yyval.specify_triple_ptr)->t_min = (yyvsp[0].ast);
		(yyval.specify_triple_ptr)->t_avg = (yyvsp[0].ast)->clone();
		(yyval.specify_triple_ptr)->t_max = (yyvsp[0].ast)->clone();
	}
#line 5264 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 255: /* specify_triple: expr ':' expr ':' expr  */
#line 1438 "frontends/verilog/verilog_parser.y"
                               {
		(yyval.specify_triple_ptr) = new specify_triple;
		(yyval.specify_triple_ptr)->t_min = (yyvsp[-4].ast);
		(yyval.specify_triple_ptr)->t_avg = (yyvsp[-2].ast);
		(yyval.specify_triple_ptr)->t_max = (yyvsp[0].ast);
	}
#line 5275 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 305: /* ignspec_constant_expression: expr  */
#line 1559 "frontends/verilog/verilog_parser.y"
             { delete (yyvsp[0].ast); }
#line 5281 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 306: /* ignspec_expr: expr  */
#line 1562 "frontends/verilog/verilog_parser.y"
             { delete (yyvsp[0].ast); }
#line 5287 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 307: /* ignspec_expr: expr ':' expr ':' expr  */
#line 1563 "frontends/verilog/verilog_parser.y"
                               {
		delete (yyvsp[-4].ast);
		delete (yyvsp[-2].ast);
		delete (yyvsp[0].ast);
	}
#line 5297 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 308: /* $@34: %empty  */
#line 1570 "frontends/verilog/verilog_parser.y"
               { delete (yyvsp[0].string); }
#line 5303 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 309: /* ignspec_id: TOK_ID $@34 range_or_multirange  */
#line 1571 "frontends/verilog/verilog_parser.y"
                            { delete (yyvsp[0].ast); }
#line 5309 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 310: /* param_signed: TOK_SIGNED  */
#line 1576 "frontends/verilog/verilog_parser.y"
                   {
		astbuf1->is_signed = true;
	}
#line 5317 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 311: /* param_signed: TOK_UNSIGNED  */
#line 1578 "frontends/verilog/verilog_parser.y"
                         {
		astbuf1->is_signed = false;
	}
#line 5325 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 313: /* param_integer: type_atom  */
#line 1583 "frontends/verilog/verilog_parser.y"
                  {
		astbuf1->is_reg = false;
	}
#line 5333 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 314: /* param_real: TOK_REAL  */
#line 1588 "frontends/verilog/verilog_parser.y"
                 {
		astbuf1->children.push_back(new AstNode(AST_REALVALUE));
	}
#line 5341 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 315: /* param_range: range  */
#line 1593 "frontends/verilog/verilog_parser.y"
              {
		if ((yyvsp[0].ast) != NULL) {
			astbuf1->children.push_back((yyvsp[0].ast));
		}
	}
#line 5351 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 317: /* param_range_type: type_vec param_signed  */
#line 1601 "frontends/verilog/verilog_parser.y"
                              {
		addRange(astbuf1, 0, 0);
	}
#line 5359 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 318: /* param_range_type: type_vec param_signed non_opt_range  */
#line 1604 "frontends/verilog/verilog_parser.y"
                                            {
		astbuf1->children.push_back((yyvsp[0].ast));
	}
#line 5367 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 324: /* param_type: hierarchical_type_id  */
#line 1611 "frontends/verilog/verilog_parser.y"
                             {
		astbuf1->is_custom_type = true;
		astbuf1->children.push_back(new AstNode(AST_WIRETYPE));
		astbuf1->children.back()->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 5378 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 325: /* $@35: %empty  */
#line 1619 "frontends/verilog/verilog_parser.y"
                           {
		astbuf1 = new AstNode(AST_PARAMETER);
		astbuf1->children.push_back(AstNode::mkconst_int(0, true));
		append_attr(astbuf1, (yyvsp[-1].al));
	}
#line 5388 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 326: /* param_decl: attr TOK_PARAMETER $@35 param_type param_decl_list ';'  */
#line 1623 "frontends/verilog/verilog_parser.y"
                                         {
		delete astbuf1;
	}
#line 5396 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 327: /* $@36: %empty  */
#line 1628 "frontends/verilog/verilog_parser.y"
                            {
		astbuf1 = new AstNode(AST_LOCALPARAM);
		astbuf1->children.push_back(AstNode::mkconst_int(0, true));
		append_attr(astbuf1, (yyvsp[-1].al));
	}
#line 5406 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 328: /* localparam_decl: attr TOK_LOCALPARAM $@36 param_type param_decl_list ';'  */
#line 1632 "frontends/verilog/verilog_parser.y"
                                         {
		delete astbuf1;
	}
#line 5414 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 331: /* single_param_decl: single_param_decl_ident '=' expr  */
#line 1640 "frontends/verilog/verilog_parser.y"
                                         {
		AstNode *decl = ast_stack.back()->children.back();
		log_assert(decl->type == AST_PARAMETER || decl->type == AST_LOCALPARAM);
		delete decl->children[0];
		decl->children[0] = (yyvsp[0].ast);
	}
#line 5425 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 332: /* single_param_decl: single_param_decl_ident  */
#line 1646 "frontends/verilog/verilog_parser.y"
                                {
		AstNode *decl = ast_stack.back()->children.back();
		if (decl->type != AST_PARAMETER) {
			log_assert(decl->type == AST_LOCALPARAM);
			frontend_verilog_yyerror("localparam initialization is missing!");
		}
		if (!sv_mode)
			frontend_verilog_yyerror("Parameter defaults can only be omitted in SystemVerilog mode!");
		delete decl->children[0];
		decl->children.erase(decl->children.begin());
	}
#line 5441 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 333: /* single_param_decl_ident: TOK_ID  */
#line 1659 "frontends/verilog/verilog_parser.y"
               {
		AstNode *node;
		if (astbuf1 == nullptr) {
			if (!sv_mode)
				frontend_verilog_yyerror("In pure Verilog (not SystemVerilog), parameter/localparam with an initializer must use the parameter/localparam keyword");
			node = new AstNode(AST_PARAMETER);
			node->children.push_back(AstNode::mkconst_int(0, true));
		} else {
			node = astbuf1->clone();
		}
		node->str = *(yyvsp[0].string);
		ast_stack.back()->children.push_back(node);
		delete (yyvsp[0].string);
		SET_AST_NODE_LOC(node, (yylsp[0]), (yylsp[0]));
	}
#line 5461 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 337: /* single_defparam_decl: range rvalue '=' expr  */
#line 1682 "frontends/verilog/verilog_parser.y"
                              {
		AstNode *node = new AstNode(AST_DEFPARAM);
		node->children.push_back((yyvsp[-2].ast));
		node->children.push_back((yyvsp[0].ast));
		if ((yyvsp[-3].ast) != NULL)
			node->children.push_back((yyvsp[-3].ast));
		ast_stack.back()->children.push_back(node);
	}
#line 5474 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 338: /* $@37: %empty  */
#line 1695 "frontends/verilog/verilog_parser.y"
                    {
		static int enum_count;
		// create parent node for the enum
		astbuf2 = new AstNode(AST_ENUM);
		ast_stack.back()->children.push_back(astbuf2);
		astbuf2->str = std::string("$enum");
		astbuf2->str += std::to_string(enum_count++);
		// create the template for the names
		astbuf1 = new AstNode(AST_ENUM_ITEM);
		astbuf1->children.push_back(AstNode::mkconst_int(0, true));
	}
#line 5490 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 339: /* enum_type: TOK_ENUM $@37 enum_base_type '{' enum_name_list optional_comma '}'  */
#line 1705 "frontends/verilog/verilog_parser.y"
                                                               {
		// create template for the enum vars
		auto tnode = astbuf1->clone();
		delete astbuf1;
		astbuf1 = tnode;
		tnode->type = AST_WIRE;
		tnode->attributes[ID::enum_type] = AstNode::mkconst_str(astbuf2->str);
		// drop constant but keep any range
		delete tnode->children[0];
		tnode->children.erase(tnode->children.begin());
		(yyval.ast) = astbuf1;
	}
#line 5507 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 341: /* enum_base_type: type_vec type_signing range  */
#line 1719 "frontends/verilog/verilog_parser.y"
                                        { if ((yyvsp[0].ast)) astbuf1->children.push_back((yyvsp[0].ast)); }
#line 5513 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 342: /* enum_base_type: %empty  */
#line 1720 "frontends/verilog/verilog_parser.y"
                                        { astbuf1->is_reg = true; addRange(astbuf1); }
#line 5519 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 343: /* type_atom: integer_atom_type  */
#line 1724 "frontends/verilog/verilog_parser.y"
                          {
		astbuf1->is_reg = true;
		astbuf1->is_signed = true;
		addRange(astbuf1, (yyvsp[0].integer) - 1, 0);
	}
#line 5529 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 344: /* type_vec: TOK_REG  */
#line 1730 "frontends/verilog/verilog_parser.y"
                                { astbuf1->is_reg   = true; }
#line 5535 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 345: /* type_vec: TOK_LOGIC  */
#line 1731 "frontends/verilog/verilog_parser.y"
                                { astbuf1->is_logic = true; }
#line 5541 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 346: /* type_signing: TOK_SIGNED  */
#line 1735 "frontends/verilog/verilog_parser.y"
                                { astbuf1->is_signed = true; }
#line 5547 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 347: /* type_signing: TOK_UNSIGNED  */
#line 1736 "frontends/verilog/verilog_parser.y"
                                { astbuf1->is_signed = false; }
#line 5553 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 351: /* enum_name_decl: TOK_ID opt_enum_init  */
#line 1745 "frontends/verilog/verilog_parser.y"
                             {
		// put in fn
		log_assert(astbuf1);
		log_assert(astbuf2);
		auto node = astbuf1->clone();
		node->str = *(yyvsp[-1].string);
		delete (yyvsp[-1].string);
		SET_AST_NODE_LOC(node, (yylsp[-1]), (yylsp[-1]));
		delete node->children[0];
		node->children[0] = (yyvsp[0].ast) ? (yyvsp[0].ast) : new AstNode(AST_NONE);
		astbuf2->children.push_back(node);
	}
#line 5570 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 352: /* opt_enum_init: '=' basic_expr  */
#line 1760 "frontends/verilog/verilog_parser.y"
                                { (yyval.ast) = (yyvsp[0].ast); }
#line 5576 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 353: /* opt_enum_init: %empty  */
#line 1761 "frontends/verilog/verilog_parser.y"
                                { (yyval.ast) = NULL; }
#line 5582 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 356: /* enum_var: TOK_ID  */
#line 1769 "frontends/verilog/verilog_parser.y"
                 {
		log_assert(astbuf1);
		log_assert(astbuf2);
		auto node = astbuf1->clone();
		ast_stack.back()->children.push_back(node);
		node->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		SET_AST_NODE_LOC(node, (yylsp[0]), (yylsp[0]));
		node->is_enum = true;
	}
#line 5597 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 357: /* enum_decl: enum_type enum_var_list ';'  */
#line 1781 "frontends/verilog/verilog_parser.y"
                                                { delete (yyvsp[-2].ast); }
#line 5603 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 358: /* struct_decl: struct_type struct_var_list ';'  */
#line 1788 "frontends/verilog/verilog_parser.y"
                                                { delete astbuf2; }
#line 5609 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 359: /* $@38: %empty  */
#line 1791 "frontends/verilog/verilog_parser.y"
                          { astbuf2 = (yyvsp[0].ast); }
#line 5615 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 360: /* struct_type: struct_union $@38 struct_body  */
#line 1791 "frontends/verilog/verilog_parser.y"
                                                        { (yyval.ast) = astbuf2; }
#line 5621 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 361: /* struct_union: TOK_STRUCT  */
#line 1795 "frontends/verilog/verilog_parser.y"
                                { (yyval.ast) = new AstNode(AST_STRUCT); }
#line 5627 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 362: /* struct_union: TOK_UNION  */
#line 1796 "frontends/verilog/verilog_parser.y"
                                { (yyval.ast) = new AstNode(AST_UNION); }
#line 5633 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 365: /* opt_packed: %empty  */
#line 1804 "frontends/verilog/verilog_parser.y"
               { frontend_verilog_yyerror("Only PACKED supported at this time"); }
#line 5639 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 366: /* opt_signed_struct: TOK_SIGNED  */
#line 1807 "frontends/verilog/verilog_parser.y"
                                { astbuf2->is_signed = true; }
#line 5645 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 367: /* opt_signed_struct: TOK_UNSIGNED  */
#line 1808 "frontends/verilog/verilog_parser.y"
                                { astbuf2->is_signed = false; }
#line 5651 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 371: /* struct_member: struct_member_type member_name_list ';'  */
#line 1816 "frontends/verilog/verilog_parser.y"
                                                                { delete astbuf1; }
#line 5657 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 374: /* $@39: %empty  */
#line 1824 "frontends/verilog/verilog_parser.y"
                    {
			astbuf1->str = (yyvsp[0].string)->substr(1);
			delete (yyvsp[0].string);
			astbuf3 = astbuf1->clone();
			SET_AST_NODE_LOC(astbuf3, (yylsp[0]), (yylsp[0]));
			astbuf2->children.push_back(astbuf3);
		}
#line 5669 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 375: /* member_name: TOK_ID $@39 range  */
#line 1830 "frontends/verilog/verilog_parser.y"
                        { if ((yyvsp[0].ast)) astbuf3->children.push_back((yyvsp[0].ast)); }
#line 5675 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 376: /* $@40: %empty  */
#line 1833 "frontends/verilog/verilog_parser.y"
                    { astbuf1 = new AstNode(AST_STRUCT_ITEM); }
#line 5681 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 379: /* member_type_token: hierarchical_type_id  */
#line 1838 "frontends/verilog/verilog_parser.y"
                               {
			// use a clone of the typedef definition nodes
			auto template_node = copyTypeDefinition(*(yyvsp[0].string));
			delete (yyvsp[0].string);
			switch (template_node->type) {
			case AST_WIRE:
				template_node->type = AST_STRUCT_ITEM;
				break;
			case AST_STRUCT:
			case AST_UNION:
				break;
			default:
				frontend_verilog_yyerror("Invalid type for struct member: %s", type2str(template_node->type).c_str());
			}
			delete astbuf1;
			astbuf1 = template_node;
		}
#line 5703 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 380: /* $@41: %empty  */
#line 1855 "frontends/verilog/verilog_parser.y"
          {
		delete astbuf1;
	}
#line 5711 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 381: /* $@42: %empty  */
#line 1857 "frontends/verilog/verilog_parser.y"
                       {
			// stash state on ast_stack
			ast_stack.push_back(astbuf2);
			astbuf2 = (yyvsp[0].ast);
		}
#line 5721 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 382: /* member_type_token: $@41 struct_union $@42 struct_body  */
#line 1861 "frontends/verilog/verilog_parser.y"
                               {
		        astbuf1 = astbuf2;
			// recover state
			astbuf2 = ast_stack.back();
			ast_stack.pop_back();
		}
#line 5732 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 384: /* member_type: type_vec type_signing range_or_multirange  */
#line 1870 "frontends/verilog/verilog_parser.y"
                                                        { if ((yyvsp[0].ast)) astbuf1->children.push_back((yyvsp[0].ast)); }
#line 5738 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 387: /* struct_var: TOK_ID  */
#line 1877 "frontends/verilog/verilog_parser.y"
                        {	auto *var_node = astbuf2->clone();
				var_node->str = *(yyvsp[0].string);
				delete (yyvsp[0].string);
				SET_AST_NODE_LOC(var_node, (yylsp[0]), (yylsp[0]));
				ast_stack.back()->children.push_back(var_node);
			}
#line 5749 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 388: /* $@43: %empty  */
#line 1890 "frontends/verilog/verilog_parser.y"
                             {
		albuf = (yyvsp[-2].al);
		astbuf1 = (yyvsp[-1].ast);
		astbuf2 = checkRange(astbuf1, (yyvsp[0].ast));
	}
#line 5759 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 389: /* $@44: %empty  */
#line 1894 "frontends/verilog/verilog_parser.y"
                               {
		delete astbuf1;
		if (astbuf2 != NULL)
			delete astbuf2;
		free_attr(albuf);
	}
#line 5770 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 391: /* $@45: %empty  */
#line 1900 "frontends/verilog/verilog_parser.y"
                                {
		ast_stack.back()->children.push_back(new AstNode(AST_WIRE));
		ast_stack.back()->children.back()->str = *(yyvsp[0].string);
		append_attr(ast_stack.back()->children.back(), (yyvsp[-2].al));
		ast_stack.back()->children.push_back(new AstNode(AST_ASSIGN, new AstNode(AST_IDENTIFIER), AstNode::mkconst_int(0, false, 1)));
		ast_stack.back()->children.back()->children[0]->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 5783 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 393: /* $@46: %empty  */
#line 1908 "frontends/verilog/verilog_parser.y"
                                {
		ast_stack.back()->children.push_back(new AstNode(AST_WIRE));
		ast_stack.back()->children.back()->str = *(yyvsp[0].string);
		append_attr(ast_stack.back()->children.back(), (yyvsp[-2].al));
		ast_stack.back()->children.push_back(new AstNode(AST_ASSIGN, new AstNode(AST_IDENTIFIER), AstNode::mkconst_int(1, false, 1)));
		ast_stack.back()->children.back()->children[0]->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 5796 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 396: /* opt_supply_wires: opt_supply_wires ',' TOK_ID  */
#line 1919 "frontends/verilog/verilog_parser.y"
                                    {
		AstNode *wire_node = ast_stack.back()->children.at(GetSize(ast_stack.back()->children)-2)->clone();
		AstNode *assign_node = ast_stack.back()->children.at(GetSize(ast_stack.back()->children)-1)->clone();
		wire_node->str = *(yyvsp[0].string);
		assign_node->children[0]->str = *(yyvsp[0].string);
		ast_stack.back()->children.push_back(wire_node);
		ast_stack.back()->children.push_back(assign_node);
		delete (yyvsp[0].string);
	}
#line 5810 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 399: /* wire_name_and_opt_assign: wire_name  */
#line 1933 "frontends/verilog/verilog_parser.y"
                  {
		bool attr_anyconst = false;
		bool attr_anyseq = false;
		bool attr_allconst = false;
		bool attr_allseq = false;
		if (ast_stack.back()->children.back()->get_bool_attribute(ID::anyconst)) {
			delete ast_stack.back()->children.back()->attributes.at(ID::anyconst);
			ast_stack.back()->children.back()->attributes.erase(ID::anyconst);
			attr_anyconst = true;
		}
		if (ast_stack.back()->children.back()->get_bool_attribute(ID::anyseq)) {
			delete ast_stack.back()->children.back()->attributes.at(ID::anyseq);
			ast_stack.back()->children.back()->attributes.erase(ID::anyseq);
			attr_anyseq = true;
		}
		if (ast_stack.back()->children.back()->get_bool_attribute(ID::allconst)) {
			delete ast_stack.back()->children.back()->attributes.at(ID::allconst);
			ast_stack.back()->children.back()->attributes.erase(ID::allconst);
			attr_allconst = true;
		}
		if (ast_stack.back()->children.back()->get_bool_attribute(ID::allseq)) {
			delete ast_stack.back()->children.back()->attributes.at(ID::allseq);
			ast_stack.back()->children.back()->attributes.erase(ID::allseq);
			attr_allseq = true;
		}
		if (current_wire_rand || attr_anyconst || attr_anyseq || attr_allconst || attr_allseq) {
			AstNode *wire = new AstNode(AST_IDENTIFIER);
			AstNode *fcall = new AstNode(AST_FCALL);
			wire->str = ast_stack.back()->children.back()->str;
			fcall->str = current_wire_const ? "\\$anyconst" : "\\$anyseq";
			if (attr_anyconst)
				fcall->str = "\\$anyconst";
			if (attr_anyseq)
				fcall->str = "\\$anyseq";
			if (attr_allconst)
				fcall->str = "\\$allconst";
			if (attr_allseq)
				fcall->str = "\\$allseq";
			fcall->attributes[ID::reg] = AstNode::mkconst_str(RTLIL::unescape_id(wire->str));
			ast_stack.back()->children.push_back(new AstNode(AST_ASSIGN, wire, fcall));
		}
	}
#line 5857 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 400: /* wire_name_and_opt_assign: wire_name '=' expr  */
#line 1975 "frontends/verilog/verilog_parser.y"
                           {
		AstNode *wire = new AstNode(AST_IDENTIFIER);
		wire->str = ast_stack.back()->children.back()->str;
		if (astbuf1->is_input) {
			if (astbuf1->attributes.count(ID::defaultvalue))
				delete astbuf1->attributes.at(ID::defaultvalue);
			astbuf1->attributes[ID::defaultvalue] = (yyvsp[0].ast);
		}
		else if (astbuf1->is_reg || astbuf1->is_logic){
			AstNode *assign = new AstNode(AST_ASSIGN_LE, wire, (yyvsp[0].ast));
			AstNode *block = new AstNode(AST_BLOCK, assign);
			AstNode *init = new AstNode(AST_INITIAL, block);

			SET_AST_NODE_LOC(assign, (yylsp[-2]), (yylsp[0]));
			SET_AST_NODE_LOC(block, (yylsp[-2]), (yylsp[0]));
			SET_AST_NODE_LOC(init, (yylsp[-2]), (yylsp[0]));

			ast_stack.back()->children.push_back(init);
		}
		else {
			AstNode *assign = new AstNode(AST_ASSIGN, wire, (yyvsp[0].ast));
			SET_AST_NODE_LOC(assign, (yylsp[-2]), (yylsp[0]));
			ast_stack.back()->children.push_back(assign);
		}

	}
#line 5888 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 401: /* wire_name: TOK_ID range_or_multirange  */
#line 2003 "frontends/verilog/verilog_parser.y"
                                   {
		if (astbuf1 == nullptr)
			frontend_verilog_yyerror("Internal error - should not happen - no AST_WIRE node.");
		AstNode *node = astbuf1->clone();
		node->str = *(yyvsp[-1].string);
		append_attr_clone(node, albuf);
		if (astbuf2 != NULL)
			node->children.push_back(astbuf2->clone());
		if ((yyvsp[0].ast) != NULL) {
			if (node->is_input || node->is_output)
				frontend_verilog_yyerror("input/output/inout ports cannot have unpacked dimensions.");
			if (!astbuf2 && !node->is_custom_type) {
				addRange(node, 0, 0, false);
			}
			rewriteAsMemoryNode(node, (yyvsp[0].ast));
		}
		if (current_function_or_task) {
			if (node->is_input || node->is_output)
				node->port_id = current_function_or_task_port_id++;
		} else if (ast_stack.back()->type == AST_GENBLOCK) {
			if (node->is_input || node->is_output)
				frontend_verilog_yyerror("Cannot declare module port `%s' within a generate block.", (yyvsp[-1].string)->c_str());
		} else {
			if (do_not_require_port_stubs && (node->is_input || node->is_output) && port_stubs.count(*(yyvsp[-1].string)) == 0) {
				port_stubs[*(yyvsp[-1].string)] = ++port_counter;
			}
			if (port_stubs.count(*(yyvsp[-1].string)) != 0) {
				if (!node->is_input && !node->is_output)
					frontend_verilog_yyerror("Module port `%s' is neither input nor output.", (yyvsp[-1].string)->c_str());
				if (node->is_reg && node->is_input && !node->is_output && !sv_mode)
					frontend_verilog_yyerror("Input port `%s' is declared as register.", (yyvsp[-1].string)->c_str());
				node->port_id = port_stubs[*(yyvsp[-1].string)];
				port_stubs.erase(*(yyvsp[-1].string));
			} else {
				if (node->is_input || node->is_output)
					frontend_verilog_yyerror("Module port `%s' is not declared in module header.", (yyvsp[-1].string)->c_str());
			}
		}
		//FIXME: for some reason, TOK_ID has a location which always points to one column *after* the real last column...
		SET_AST_NODE_LOC(node, (yylsp[-1]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);

		delete (yyvsp[-1].string);
	}
#line 5937 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 405: /* assign_expr: lvalue '=' expr  */
#line 2055 "frontends/verilog/verilog_parser.y"
                        {
		AstNode *node = new AstNode(AST_ASSIGN, (yyvsp[-2].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC(node, (yyloc), (yyloc));
		ast_stack.back()->children.push_back(node);
	}
#line 5947 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 407: /* type_name: TOK_USER_TYPE  */
#line 2062 "frontends/verilog/verilog_parser.y"
                                { if (isInLocalScope((yyvsp[0].string))) frontend_verilog_yyerror("Duplicate declaration of TYPEDEF '%s'", (yyvsp[0].string)->c_str()+1); }
#line 5953 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 408: /* typedef_decl: TOK_TYPEDEF typedef_base_type range type_name range_or_multirange ';'  */
#line 2066 "frontends/verilog/verilog_parser.y"
                                                                              {
		astbuf1 = (yyvsp[-4].ast);
		astbuf2 = checkRange(astbuf1, (yyvsp[-3].ast));
		if (astbuf2)
			astbuf1->children.push_back(astbuf2);

		if ((yyvsp[-1].ast) != NULL) {
			if (!astbuf2) {
				addRange(astbuf1, 0, 0, false);
			}
			rewriteAsMemoryNode(astbuf1, (yyvsp[-1].ast));
		}
		addTypedefNode((yyvsp[-2].string), astbuf1); }
#line 5971 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 409: /* typedef_decl: TOK_TYPEDEF enum_struct_type type_name ';'  */
#line 2079 "frontends/verilog/verilog_parser.y"
                                                       { addTypedefNode((yyvsp[-1].string), (yyvsp[-2].ast)); }
#line 5977 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 410: /* typedef_base_type: hierarchical_type_id  */
#line 2083 "frontends/verilog/verilog_parser.y"
                             {
		(yyval.ast) = new AstNode(AST_WIRE);
		(yyval.ast)->is_logic = true;
		addWiretypeNode((yyvsp[0].string), (yyval.ast));
	}
#line 5987 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 411: /* typedef_base_type: integer_vector_type opt_signedness_default_unsigned  */
#line 2088 "frontends/verilog/verilog_parser.y"
                                                            {
		(yyval.ast) = new AstNode(AST_WIRE);
		if ((yyvsp[-1].integer) == TOK_REG) {
			(yyval.ast)->is_reg = true;
		} else {
			(yyval.ast)->is_logic = true;
		}
		(yyval.ast)->is_signed = (yyvsp[0].boolean);
	}
#line 6001 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 412: /* typedef_base_type: integer_atom_type opt_signedness_default_signed  */
#line 2097 "frontends/verilog/verilog_parser.y"
                                                        {
		(yyval.ast) = new AstNode(AST_WIRE);
		(yyval.ast)->is_logic = true;
		(yyval.ast)->is_signed = (yyvsp[0].boolean);
		(yyval.ast)->range_left = (yyvsp[-1].integer) - 1;
		(yyval.ast)->range_right = 0;
	}
#line 6013 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 415: /* $@47: %empty  */
#line 2111 "frontends/verilog/verilog_parser.y"
                    {
		astbuf1 = new AstNode(AST_CELL);
		append_attr(astbuf1, (yyvsp[-1].al));
		astbuf1->children.push_back(new AstNode(AST_CELLTYPE));
		astbuf1->children[0]->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 6025 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 416: /* cell_stmt: attr TOK_ID $@47 cell_parameter_list_opt cell_list ';'  */
#line 2117 "frontends/verilog/verilog_parser.y"
                                                {
		delete astbuf1;
	}
#line 6033 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 417: /* $@48: %empty  */
#line 2120 "frontends/verilog/verilog_parser.y"
                                    {
		astbuf1 = new AstNode(AST_PRIMITIVE);
		astbuf1->str = *(yyvsp[-1].string);
		append_attr(astbuf1, (yyvsp[-2].al));
		delete (yyvsp[-1].string);
	}
#line 6044 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 418: /* cell_stmt: attr tok_prim_wrapper delay $@48 prim_list ';'  */
#line 2125 "frontends/verilog/verilog_parser.y"
                        {
		delete astbuf1;
	}
#line 6052 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 419: /* tok_prim_wrapper: TOK_PRIMITIVE  */
#line 2130 "frontends/verilog/verilog_parser.y"
                      {
		(yyval.string) = (yyvsp[0].string);
	}
#line 6060 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 420: /* tok_prim_wrapper: TOK_OR  */
#line 2133 "frontends/verilog/verilog_parser.y"
               {
		(yyval.string) = new std::string("or");
	}
#line 6068 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 425: /* $@49: %empty  */
#line 2145 "frontends/verilog/verilog_parser.y"
               {
		astbuf2 = astbuf1->clone();
		if (astbuf2->type != AST_PRIMITIVE)
			astbuf2->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		ast_stack.back()->children.push_back(astbuf2);
	}
#line 6080 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 426: /* single_cell_no_array: TOK_ID $@49 '(' cell_port_list ')'  */
#line 2151 "frontends/verilog/verilog_parser.y"
                                 {
		SET_AST_NODE_LOC(astbuf2, (yylsp[-4]), (yyloc));
	}
#line 6088 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 427: /* $@50: %empty  */
#line 2156 "frontends/verilog/verilog_parser.y"
                             {
		astbuf2 = astbuf1->clone();
		if (astbuf2->type != AST_PRIMITIVE)
			astbuf2->str = *(yyvsp[-1].string);
		delete (yyvsp[-1].string);
		ast_stack.back()->children.push_back(new AstNode(AST_CELLARRAY, (yyvsp[0].ast), astbuf2));
	}
#line 6100 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 428: /* single_cell_arraylist: TOK_ID non_opt_range $@50 '(' cell_port_list ')'  */
#line 2162 "frontends/verilog/verilog_parser.y"
                                {
		SET_AST_NODE_LOC(astbuf2, (yylsp[-5]), (yyloc));
	}
#line 6108 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 434: /* $@51: %empty  */
#line 2176 "frontends/verilog/verilog_parser.y"
                      {
		astbuf2 = astbuf1->clone();
		ast_stack.back()->children.push_back(astbuf2);
	}
#line 6117 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 435: /* single_prim: $@51 '(' cell_port_list ')'  */
#line 2179 "frontends/verilog/verilog_parser.y"
                                 {
		SET_AST_NODE_LOC(astbuf2, (yylsp[-3]), (yyloc));
	}
#line 6125 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 441: /* cell_parameter: expr  */
#line 2191 "frontends/verilog/verilog_parser.y"
             {
		AstNode *node = new AstNode(AST_PARASET);
		astbuf1->children.push_back(node);
		node->children.push_back((yyvsp[0].ast));
	}
#line 6135 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 442: /* cell_parameter: '.' TOK_ID '(' ')'  */
#line 2196 "frontends/verilog/verilog_parser.y"
                           {
		// just ignore empty parameters
	}
#line 6143 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 443: /* cell_parameter: '.' TOK_ID '(' expr ')'  */
#line 2199 "frontends/verilog/verilog_parser.y"
                                {
		AstNode *node = new AstNode(AST_PARASET);
		node->str = *(yyvsp[-3].string);
		astbuf1->children.push_back(node);
		node->children.push_back((yyvsp[-1].ast));
		delete (yyvsp[-3].string);
	}
#line 6155 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 444: /* cell_port_list: cell_port_list_rules  */
#line 2208 "frontends/verilog/verilog_parser.y"
                             {
		// remove empty args from end of list
		while (!astbuf2->children.empty()) {
			AstNode *node = astbuf2->children.back();
			if (node->type != AST_ARGUMENT) break;
			if (!node->children.empty()) break;
			if (!node->str.empty()) break;
			astbuf2->children.pop_back();
			delete node;
		}

		// check port types
		bool has_positional_args = false;
		bool has_named_args = false;
		for (auto node : astbuf2->children) {
			if (node->type != AST_ARGUMENT) continue;
			if (node->str.empty())
				has_positional_args = true;
			else
				has_named_args = true;
		}

		if (has_positional_args && has_named_args)
			frontend_verilog_yyerror("Mix of positional and named cell ports.");
	}
#line 6185 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 447: /* cell_port: attr  */
#line 2238 "frontends/verilog/verilog_parser.y"
             {
		AstNode *node = new AstNode(AST_ARGUMENT);
		astbuf2->children.push_back(node);
		free_attr((yyvsp[0].al));
	}
#line 6195 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 448: /* cell_port: attr expr  */
#line 2243 "frontends/verilog/verilog_parser.y"
                  {
		AstNode *node = new AstNode(AST_ARGUMENT);
		astbuf2->children.push_back(node);
		node->children.push_back((yyvsp[0].ast));
		free_attr((yyvsp[-1].al));
	}
#line 6206 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 449: /* cell_port: attr '.' TOK_ID '(' expr ')'  */
#line 2249 "frontends/verilog/verilog_parser.y"
                                     {
		AstNode *node = new AstNode(AST_ARGUMENT);
		node->str = *(yyvsp[-3].string);
		astbuf2->children.push_back(node);
		node->children.push_back((yyvsp[-1].ast));
		delete (yyvsp[-3].string);
		free_attr((yyvsp[-5].al));
	}
#line 6219 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 450: /* cell_port: attr '.' TOK_ID '(' ')'  */
#line 2257 "frontends/verilog/verilog_parser.y"
                                {
		AstNode *node = new AstNode(AST_ARGUMENT);
		node->str = *(yyvsp[-2].string);
		astbuf2->children.push_back(node);
		delete (yyvsp[-2].string);
		free_attr((yyvsp[-4].al));
	}
#line 6231 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 451: /* cell_port: attr '.' TOK_ID  */
#line 2264 "frontends/verilog/verilog_parser.y"
                        {
		AstNode *node = new AstNode(AST_ARGUMENT);
		node->str = *(yyvsp[0].string);
		astbuf2->children.push_back(node);
		node->children.push_back(new AstNode(AST_IDENTIFIER));
		node->children.back()->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		free_attr((yyvsp[-2].al));
	}
#line 6245 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 452: /* cell_port: attr TOK_WILDCARD_CONNECT  */
#line 2273 "frontends/verilog/verilog_parser.y"
                                  {
		if (!sv_mode)
			frontend_verilog_yyerror("Wildcard port connections are only supported in SystemVerilog mode.");
		astbuf2->attributes[ID::wildcard_port_conns] = AstNode::mkconst_int(1, false);
		free_attr((yyvsp[-1].al));
	}
#line 6256 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 453: /* always_comb_or_latch: TOK_ALWAYS_COMB  */
#line 2281 "frontends/verilog/verilog_parser.y"
                        {
		(yyval.boolean) = false;
	}
#line 6264 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 454: /* always_comb_or_latch: TOK_ALWAYS_LATCH  */
#line 2284 "frontends/verilog/verilog_parser.y"
                         {
		(yyval.boolean) = true;
	}
#line 6272 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 455: /* always_or_always_ff: TOK_ALWAYS  */
#line 2289 "frontends/verilog/verilog_parser.y"
                   {
		(yyval.boolean) = false;
	}
#line 6280 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 456: /* always_or_always_ff: TOK_ALWAYS_FF  */
#line 2292 "frontends/verilog/verilog_parser.y"
                      {
		(yyval.boolean) = true;
	}
#line 6288 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 457: /* $@52: %empty  */
#line 2297 "frontends/verilog/verilog_parser.y"
                                 {
		AstNode *node = new AstNode(AST_ALWAYS);
		append_attr(node, (yyvsp[-1].al));
		if ((yyvsp[0].boolean))
			node->attributes[ID::always_ff] = AstNode::mkconst_int(1, false);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 6301 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 458: /* $@53: %empty  */
#line 2304 "frontends/verilog/verilog_parser.y"
                      {
		AstNode *block = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
	}
#line 6311 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 459: /* always_stmt: attr always_or_always_ff $@52 always_cond $@53 behavioral_stmt  */
#line 2308 "frontends/verilog/verilog_parser.y"
                          {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
		ast_stack.pop_back();

		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-4]), (yyloc));
		ast_stack.pop_back();

		SET_RULE_LOC((yyloc), (yylsp[-4]), (yyloc));
	}
#line 6325 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 460: /* $@54: %empty  */
#line 2317 "frontends/verilog/verilog_parser.y"
                                  {
		AstNode *node = new AstNode(AST_ALWAYS);
		append_attr(node, (yyvsp[-1].al));
		if ((yyvsp[0].boolean))
			node->attributes[ID::always_latch] = AstNode::mkconst_int(1, false);
		else
			node->attributes[ID::always_comb] = AstNode::mkconst_int(1, false);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		AstNode *block = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
	}
#line 6343 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 461: /* always_stmt: attr always_comb_or_latch $@54 behavioral_stmt  */
#line 2329 "frontends/verilog/verilog_parser.y"
                          {
		ast_stack.pop_back();
		ast_stack.pop_back();
	}
#line 6352 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 462: /* $@55: %empty  */
#line 2333 "frontends/verilog/verilog_parser.y"
                         {
		AstNode *node = new AstNode(AST_INITIAL);
		append_attr(node, (yyvsp[-1].al));
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		AstNode *block = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
	}
#line 6366 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 463: /* always_stmt: attr TOK_INITIAL $@55 behavioral_stmt  */
#line 2341 "frontends/verilog/verilog_parser.y"
                          {
		ast_stack.pop_back();
		ast_stack.pop_back();
	}
#line 6375 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 473: /* always_event: TOK_POSEDGE expr  */
#line 2360 "frontends/verilog/verilog_parser.y"
                         {
		AstNode *node = new AstNode(AST_POSEDGE);
		SET_AST_NODE_LOC(node, (yylsp[-1]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		node->children.push_back((yyvsp[0].ast));
	}
#line 6386 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 474: /* always_event: TOK_NEGEDGE expr  */
#line 2366 "frontends/verilog/verilog_parser.y"
                         {
		AstNode *node = new AstNode(AST_NEGEDGE);
		SET_AST_NODE_LOC(node, (yylsp[-1]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		node->children.push_back((yyvsp[0].ast));
	}
#line 6397 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 475: /* always_event: expr  */
#line 2372 "frontends/verilog/verilog_parser.y"
             {
		AstNode *node = new AstNode(AST_EDGE);
		ast_stack.back()->children.push_back(node);
		node->children.push_back((yyvsp[0].ast));
	}
#line 6407 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 476: /* opt_label: ':' TOK_ID  */
#line 2379 "frontends/verilog/verilog_parser.y"
                   {
		(yyval.string) = (yyvsp[0].string);
	}
#line 6415 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 477: /* opt_label: %empty  */
#line 2382 "frontends/verilog/verilog_parser.y"
               {
		(yyval.string) = NULL;
	}
#line 6423 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 478: /* opt_sva_label: TOK_SVA_LABEL ':'  */
#line 2387 "frontends/verilog/verilog_parser.y"
                          {
		(yyval.string) = (yyvsp[-1].string);
	}
#line 6431 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 479: /* opt_sva_label: %empty  */
#line 2390 "frontends/verilog/verilog_parser.y"
               {
		(yyval.string) = NULL;
	}
#line 6439 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 480: /* opt_property: TOK_PROPERTY  */
#line 2395 "frontends/verilog/verilog_parser.y"
                     {
		(yyval.boolean) = true;
	}
#line 6447 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 481: /* opt_property: TOK_FINAL  */
#line 2398 "frontends/verilog/verilog_parser.y"
                  {
		(yyval.boolean) = false;
	}
#line 6455 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 482: /* opt_property: %empty  */
#line 2401 "frontends/verilog/verilog_parser.y"
               {
		(yyval.boolean) = false;
	}
#line 6463 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 483: /* $@56: %empty  */
#line 2406 "frontends/verilog/verilog_parser.y"
                       {
        AstNode *modport = new AstNode(AST_MODPORT);
        ast_stack.back()->children.push_back(modport);
        ast_stack.push_back(modport);
        modport->str = *(yyvsp[0].string);
        delete (yyvsp[0].string);
    }
#line 6475 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 484: /* $@57: %empty  */
#line 2412 "frontends/verilog/verilog_parser.y"
                        {
        ast_stack.pop_back();
        log_assert(ast_stack.size() == 2);
    }
#line 6484 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 492: /* modport_member: TOK_ID  */
#line 2428 "frontends/verilog/verilog_parser.y"
           {
        AstNode *modport_member = new AstNode(AST_MODPORTMEMBER);
        ast_stack.back()->children.push_back(modport_member);
        modport_member->str = *(yyvsp[0].string);
        modport_member->is_input = current_modport_input;
        modport_member->is_output = current_modport_output;
        delete (yyvsp[0].string);
    }
#line 6497 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 493: /* modport_type_token: TOK_INPUT  */
#line 2438 "frontends/verilog/verilog_parser.y"
              {current_modport_input = 1; current_modport_output = 0;}
#line 6503 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 494: /* modport_type_token: TOK_OUTPUT  */
#line 2438 "frontends/verilog/verilog_parser.y"
                                                                                    {current_modport_input = 0; current_modport_output = 1;}
#line 6509 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 495: /* assert: opt_sva_label TOK_ASSERT opt_property '(' expr ')' ';'  */
#line 2441 "frontends/verilog/verilog_parser.y"
                                                               {
		if (noassert_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(assume_asserts_mode ? AST_ASSUME : AST_ASSERT, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
			if ((yyvsp[-6].string) != nullptr)
				node->str = *(yyvsp[-6].string);
			ast_stack.back()->children.push_back(node);
		}
		if ((yyvsp[-6].string) != nullptr)
			delete (yyvsp[-6].string);
	}
#line 6527 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 496: /* assert: opt_sva_label TOK_ASSUME opt_property '(' expr ')' ';'  */
#line 2454 "frontends/verilog/verilog_parser.y"
                                                               {
		if (noassume_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(assert_assumes_mode ? AST_ASSERT : AST_ASSUME, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
			if ((yyvsp[-6].string) != nullptr)
				node->str = *(yyvsp[-6].string);
			ast_stack.back()->children.push_back(node);
		}
		if ((yyvsp[-6].string) != nullptr)
			delete (yyvsp[-6].string);
	}
#line 6545 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 497: /* assert: opt_sva_label TOK_ASSERT opt_property '(' TOK_EVENTUALLY expr ')' ';'  */
#line 2467 "frontends/verilog/verilog_parser.y"
                                                                              {
		if (noassert_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(assume_asserts_mode ? AST_FAIR : AST_LIVE, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, (yylsp[-7]), (yylsp[-1]));
			if ((yyvsp[-7].string) != nullptr)
				node->str = *(yyvsp[-7].string);
			ast_stack.back()->children.push_back(node);
		}
		if ((yyvsp[-7].string) != nullptr)
			delete (yyvsp[-7].string);
	}
#line 6563 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 498: /* assert: opt_sva_label TOK_ASSUME opt_property '(' TOK_EVENTUALLY expr ')' ';'  */
#line 2480 "frontends/verilog/verilog_parser.y"
                                                                              {
		if (noassume_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(assert_assumes_mode ? AST_LIVE : AST_FAIR, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, (yylsp[-7]), (yylsp[-1]));
			if ((yyvsp[-7].string) != nullptr)
				node->str = *(yyvsp[-7].string);
			ast_stack.back()->children.push_back(node);
		}
		if ((yyvsp[-7].string) != nullptr)
			delete (yyvsp[-7].string);
	}
#line 6581 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 499: /* assert: opt_sva_label TOK_COVER opt_property '(' expr ')' ';'  */
#line 2493 "frontends/verilog/verilog_parser.y"
                                                              {
		AstNode *node = new AstNode(AST_COVER, (yyvsp[-2].ast));
		SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
		if ((yyvsp[-6].string) != nullptr) {
			node->str = *(yyvsp[-6].string);
			delete (yyvsp[-6].string);
		}
		ast_stack.back()->children.push_back(node);
	}
#line 6595 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 500: /* assert: opt_sva_label TOK_COVER opt_property '(' ')' ';'  */
#line 2502 "frontends/verilog/verilog_parser.y"
                                                         {
		AstNode *node = new AstNode(AST_COVER, AstNode::mkconst_int(1, false));
		SET_AST_NODE_LOC(node, (yylsp[-5]), (yylsp[-1]));
		if ((yyvsp[-5].string) != nullptr) {
			node->str = *(yyvsp[-5].string);
			delete (yyvsp[-5].string);
		}
		ast_stack.back()->children.push_back(node);
	}
#line 6609 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 501: /* assert: opt_sva_label TOK_COVER ';'  */
#line 2511 "frontends/verilog/verilog_parser.y"
                                    {
		AstNode *node = new AstNode(AST_COVER, AstNode::mkconst_int(1, false));
		SET_AST_NODE_LOC(node, (yylsp[-2]), (yylsp[-1]));
		if ((yyvsp[-2].string) != nullptr) {
			node->str = *(yyvsp[-2].string);
			delete (yyvsp[-2].string);
		}
		ast_stack.back()->children.push_back(node);
	}
#line 6623 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 502: /* assert: opt_sva_label TOK_RESTRICT opt_property '(' expr ')' ';'  */
#line 2520 "frontends/verilog/verilog_parser.y"
                                                                 {
		if (norestrict_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(AST_ASSUME, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
			if ((yyvsp[-6].string) != nullptr)
				node->str = *(yyvsp[-6].string);
			ast_stack.back()->children.push_back(node);
		}
		if (!(yyvsp[-4].boolean))
			log_file_warning(current_filename, get_line_num(), "SystemVerilog does not allow \"restrict\" without \"property\".\n");
		if ((yyvsp[-6].string) != nullptr)
			delete (yyvsp[-6].string);
	}
#line 6643 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 503: /* assert: opt_sva_label TOK_RESTRICT opt_property '(' TOK_EVENTUALLY expr ')' ';'  */
#line 2535 "frontends/verilog/verilog_parser.y"
                                                                                {
		if (norestrict_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(AST_FAIR, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, (yylsp[-7]), (yylsp[-1]));
			if ((yyvsp[-7].string) != nullptr)
				node->str = *(yyvsp[-7].string);
			ast_stack.back()->children.push_back(node);
		}
		if (!(yyvsp[-5].boolean))
			log_file_warning(current_filename, get_line_num(), "SystemVerilog does not allow \"restrict\" without \"property\".\n");
		if ((yyvsp[-7].string) != nullptr)
			delete (yyvsp[-7].string);
	}
#line 6663 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 504: /* assert_property: opt_sva_label TOK_ASSERT TOK_PROPERTY '(' expr ')' ';'  */
#line 2552 "frontends/verilog/verilog_parser.y"
                                                               {
		AstNode *node = new AstNode(assume_asserts_mode ? AST_ASSUME : AST_ASSERT, (yyvsp[-2].ast));
		SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		if ((yyvsp[-6].string) != nullptr) {
			ast_stack.back()->children.back()->str = *(yyvsp[-6].string);
			delete (yyvsp[-6].string);
		}
	}
#line 6677 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 505: /* assert_property: opt_sva_label TOK_ASSUME TOK_PROPERTY '(' expr ')' ';'  */
#line 2561 "frontends/verilog/verilog_parser.y"
                                                               {
		AstNode *node = new AstNode(AST_ASSUME, (yyvsp[-2].ast));
		SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		if ((yyvsp[-6].string) != nullptr) {
			ast_stack.back()->children.back()->str = *(yyvsp[-6].string);
			delete (yyvsp[-6].string);
		}
	}
#line 6691 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 506: /* assert_property: opt_sva_label TOK_ASSERT TOK_PROPERTY '(' TOK_EVENTUALLY expr ')' ';'  */
#line 2570 "frontends/verilog/verilog_parser.y"
                                                                              {
		AstNode *node = new AstNode(assume_asserts_mode ? AST_FAIR : AST_LIVE, (yyvsp[-2].ast));
		SET_AST_NODE_LOC(node, (yylsp[-7]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		if ((yyvsp[-7].string) != nullptr) {
			ast_stack.back()->children.back()->str = *(yyvsp[-7].string);
			delete (yyvsp[-7].string);
		}
	}
#line 6705 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 507: /* assert_property: opt_sva_label TOK_ASSUME TOK_PROPERTY '(' TOK_EVENTUALLY expr ')' ';'  */
#line 2579 "frontends/verilog/verilog_parser.y"
                                                                              {
		AstNode *node = new AstNode(AST_FAIR, (yyvsp[-2].ast));
		SET_AST_NODE_LOC(node, (yylsp[-7]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		if ((yyvsp[-7].string) != nullptr) {
			ast_stack.back()->children.back()->str = *(yyvsp[-7].string);
			delete (yyvsp[-7].string);
		}
	}
#line 6719 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 508: /* assert_property: opt_sva_label TOK_COVER TOK_PROPERTY '(' expr ')' ';'  */
#line 2588 "frontends/verilog/verilog_parser.y"
                                                              {
		AstNode *node = new AstNode(AST_COVER, (yyvsp[-2].ast));
		SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		if ((yyvsp[-6].string) != nullptr) {
			ast_stack.back()->children.back()->str = *(yyvsp[-6].string);
			delete (yyvsp[-6].string);
		}
	}
#line 6733 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 509: /* assert_property: opt_sva_label TOK_RESTRICT TOK_PROPERTY '(' expr ')' ';'  */
#line 2597 "frontends/verilog/verilog_parser.y"
                                                                 {
		if (norestrict_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(AST_ASSUME, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, (yylsp[-6]), (yylsp[-1]));
			ast_stack.back()->children.push_back(node);
			if ((yyvsp[-6].string) != nullptr) {
				ast_stack.back()->children.back()->str = *(yyvsp[-6].string);
				delete (yyvsp[-6].string);
			}
		}
	}
#line 6751 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 510: /* assert_property: opt_sva_label TOK_RESTRICT TOK_PROPERTY '(' TOK_EVENTUALLY expr ')' ';'  */
#line 2610 "frontends/verilog/verilog_parser.y"
                                                                                {
		if (norestrict_mode) {
			delete (yyvsp[-2].ast);
		} else {
			AstNode *node = new AstNode(AST_FAIR, (yyvsp[-2].ast));
			SET_AST_NODE_LOC(node, (yylsp[-7]), (yylsp[-1]));
			ast_stack.back()->children.push_back(node);
			if ((yyvsp[-7].string) != nullptr) {
				ast_stack.back()->children.back()->str = *(yyvsp[-7].string);
				delete (yyvsp[-7].string);
			}
		}
	}
#line 6769 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 511: /* simple_behavioral_stmt: attr lvalue '=' delay expr  */
#line 2625 "frontends/verilog/verilog_parser.y"
                                   {
		AstNode *node = new AstNode(AST_ASSIGN_EQ, (yyvsp[-3].ast), (yyvsp[0].ast));
		ast_stack.back()->children.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-3]), (yylsp[0]));
		append_attr(node, (yyvsp[-4].al));
	}
#line 6780 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 512: /* simple_behavioral_stmt: attr lvalue TOK_INCREMENT  */
#line 2631 "frontends/verilog/verilog_parser.y"
                                  {
		AstNode *node = new AstNode(AST_ASSIGN_EQ, (yyvsp[-1].ast), new AstNode(AST_ADD, (yyvsp[-1].ast)->clone(), AstNode::mkconst_int(1, true)));
		ast_stack.back()->children.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-1]), (yylsp[0]));
		append_attr(node, (yyvsp[-2].al));
	}
#line 6791 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 513: /* simple_behavioral_stmt: attr lvalue TOK_DECREMENT  */
#line 2637 "frontends/verilog/verilog_parser.y"
                                  {
		AstNode *node = new AstNode(AST_ASSIGN_EQ, (yyvsp[-1].ast), new AstNode(AST_SUB, (yyvsp[-1].ast)->clone(), AstNode::mkconst_int(1, true)));
		ast_stack.back()->children.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-1]), (yylsp[0]));
		append_attr(node, (yyvsp[-2].al));
	}
#line 6802 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 514: /* simple_behavioral_stmt: attr lvalue OP_LE delay expr  */
#line 2643 "frontends/verilog/verilog_parser.y"
                                     {
		AstNode *node = new AstNode(AST_ASSIGN_LE, (yyvsp[-3].ast), (yyvsp[0].ast));
		ast_stack.back()->children.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-3]), (yylsp[0]));
		append_attr(node, (yyvsp[-4].al));
	}
#line 6813 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 515: /* simple_behavioral_stmt: attr lvalue asgn_binop delay expr  */
#line 2649 "frontends/verilog/verilog_parser.y"
                                          {
		AstNode *expr_node = (yyvsp[0].ast);
		if ((yyvsp[-2].ast_node_type) == AST_SHIFT_LEFT || (yyvsp[-2].ast_node_type) == AST_SHIFT_RIGHT ||
			(yyvsp[-2].ast_node_type) == AST_SHIFT_SLEFT || (yyvsp[-2].ast_node_type) == AST_SHIFT_SRIGHT) {
			expr_node = new AstNode(AST_TO_UNSIGNED, expr_node);
			SET_AST_NODE_LOC(expr_node, (yylsp[0]), (yylsp[0]));
		}
		AstNode *op_node = new AstNode((yyvsp[-2].ast_node_type), (yyvsp[-3].ast)->clone(), expr_node);
		AstNode *node = new AstNode(AST_ASSIGN_EQ, (yyvsp[-3].ast), op_node);
		SET_AST_NODE_LOC(op_node, (yylsp[-3]), (yylsp[0]));
		SET_AST_NODE_LOC(node, (yylsp[-3]), (yylsp[0]));
		ast_stack.back()->children.push_back(node);
		append_attr(node, (yyvsp[-4].al));
	}
#line 6832 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 516: /* asgn_binop: TOK_BIT_OR_ASSIGN  */
#line 2665 "frontends/verilog/verilog_parser.y"
                          { (yyval.ast_node_type) = AST_BIT_OR; }
#line 6838 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 517: /* asgn_binop: TOK_BIT_AND_ASSIGN  */
#line 2666 "frontends/verilog/verilog_parser.y"
                           { (yyval.ast_node_type) = AST_BIT_AND; }
#line 6844 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 518: /* asgn_binop: TOK_BIT_XOR_ASSIGN  */
#line 2667 "frontends/verilog/verilog_parser.y"
                           { (yyval.ast_node_type) = AST_BIT_XOR; }
#line 6850 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 519: /* asgn_binop: TOK_ADD_ASSIGN  */
#line 2668 "frontends/verilog/verilog_parser.y"
                       { (yyval.ast_node_type) = AST_ADD; }
#line 6856 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 520: /* asgn_binop: TOK_SUB_ASSIGN  */
#line 2669 "frontends/verilog/verilog_parser.y"
                       { (yyval.ast_node_type) = AST_SUB; }
#line 6862 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 521: /* asgn_binop: TOK_DIV_ASSIGN  */
#line 2670 "frontends/verilog/verilog_parser.y"
                       { (yyval.ast_node_type) = AST_DIV; }
#line 6868 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 522: /* asgn_binop: TOK_MOD_ASSIGN  */
#line 2671 "frontends/verilog/verilog_parser.y"
                       { (yyval.ast_node_type) = AST_MOD; }
#line 6874 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 523: /* asgn_binop: TOK_MUL_ASSIGN  */
#line 2672 "frontends/verilog/verilog_parser.y"
                       { (yyval.ast_node_type) = AST_MUL; }
#line 6880 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 524: /* asgn_binop: TOK_SHL_ASSIGN  */
#line 2673 "frontends/verilog/verilog_parser.y"
                       { (yyval.ast_node_type) = AST_SHIFT_LEFT; }
#line 6886 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 525: /* asgn_binop: TOK_SHR_ASSIGN  */
#line 2674 "frontends/verilog/verilog_parser.y"
                       { (yyval.ast_node_type) = AST_SHIFT_RIGHT; }
#line 6892 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 526: /* asgn_binop: TOK_SSHL_ASSIGN  */
#line 2675 "frontends/verilog/verilog_parser.y"
                        { (yyval.ast_node_type) = AST_SHIFT_SLEFT; }
#line 6898 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 527: /* asgn_binop: TOK_SSHR_ASSIGN  */
#line 2676 "frontends/verilog/verilog_parser.y"
                        { (yyval.ast_node_type) = AST_SHIFT_SRIGHT; }
#line 6904 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 528: /* for_initialization: TOK_ID '=' expr  */
#line 2679 "frontends/verilog/verilog_parser.y"
                        {
		AstNode *ident = new AstNode(AST_IDENTIFIER);
		ident->str = *(yyvsp[-2].string);
		AstNode *node = new AstNode(AST_ASSIGN_EQ, ident, (yyvsp[0].ast));
		ast_stack.back()->children.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-2]), (yylsp[0]));
		delete (yyvsp[-2].string);
	}
#line 6917 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 529: /* for_initialization: non_io_wire_type range TOK_ID  */
#line 2687 "frontends/verilog/verilog_parser.y"
                                      {
		frontend_verilog_yyerror("For loop variable declaration is missing initialization!");
	}
#line 6925 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 530: /* for_initialization: non_io_wire_type range TOK_ID '=' expr  */
#line 2690 "frontends/verilog/verilog_parser.y"
                                               {
		if (!sv_mode)
			frontend_verilog_yyerror("For loop inline variable declaration is only supported in SystemVerilog mode!");

		// loop variable declaration
		AstNode *wire = (yyvsp[-4].ast);
		AstNode *range = checkRange(wire, (yyvsp[-3].ast));
		if (range != nullptr)
			wire->children.push_back(range);
		SET_AST_NODE_LOC(wire, (yylsp[-4]), (yylsp[-2]));
		SET_AST_NODE_LOC(range, (yylsp[-3]), (yylsp[-3]));

		AstNode *ident = new AstNode(AST_IDENTIFIER);
		ident->str = *(yyvsp[-2].string);
		wire->str = *(yyvsp[-2].string);
		delete (yyvsp[-2].string);

		AstNode *loop = ast_stack.back();
		AstNode *parent = ast_stack.at(ast_stack.size() - 2);
		log_assert(parent->children.back() == loop);

		// loop variable initialization
		AstNode *asgn = new AstNode(AST_ASSIGN_EQ, ident, (yyvsp[0].ast));
		loop->children.push_back(asgn);
		SET_AST_NODE_LOC(asgn, (yylsp[-2]), (yylsp[0]));
		SET_AST_NODE_LOC(ident, (yylsp[-2]), (yylsp[-2]));

		// inject a wrapping block to declare the loop variable and
		// contain the current loop
		AstNode *wrapper = new AstNode(AST_BLOCK);
		wrapper->str = "$fordecl_block$" + std::to_string(autoidx++);
		wrapper->children.push_back(wire);
		wrapper->children.push_back(loop);
		parent->children.back() = wrapper; // replaces `loop`
	}
#line 6965 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 539: /* behavioral_stmt: attr ';'  */
#line 2731 "frontends/verilog/verilog_parser.y"
                 {
		free_attr((yyvsp[-1].al));
	}
#line 6973 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 540: /* $@58: %empty  */
#line 2734 "frontends/verilog/verilog_parser.y"
                             {
		AstNode *node = new AstNode(AST_TCALL);
		node->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-1].al));
	}
#line 6986 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 541: /* behavioral_stmt: attr hierarchical_id $@58 opt_arg_list ';'  */
#line 2741 "frontends/verilog/verilog_parser.y"
                          {
		ast_stack.pop_back();
	}
#line 6994 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 542: /* $@59: %empty  */
#line 2744 "frontends/verilog/verilog_parser.y"
                           {
		AstNode *node = new AstNode(AST_TCALL);
		node->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-1].al));
	}
#line 7007 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 543: /* behavioral_stmt: attr TOK_MSG_TASKS $@59 opt_arg_list ';'  */
#line 2751 "frontends/verilog/verilog_parser.y"
                          {
		ast_stack.pop_back();
	}
#line 7015 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 544: /* $@60: %empty  */
#line 2754 "frontends/verilog/verilog_parser.y"
                       {
		enterTypeScope();
	}
#line 7023 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 545: /* $@61: %empty  */
#line 2756 "frontends/verilog/verilog_parser.y"
                    {
		AstNode *node = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-3].al));
		if ((yyvsp[0].string) != NULL)
			node->str = *(yyvsp[0].string);
	}
#line 7036 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 546: /* behavioral_stmt: attr TOK_BEGIN $@60 opt_label $@61 behavioral_stmt_list TOK_END opt_label  */
#line 2763 "frontends/verilog/verilog_parser.y"
                                                 {
		exitTypeScope();
		checkLabelsMatch("Begin label", (yyvsp[-4].string), (yyvsp[0].string));
		AstNode *node = ast_stack.back();
		// In SystemVerilog, unnamed blocks with block item declarations
		// create an implicit hierarchy scope
		if (sv_mode && node->str.empty())
		    for (const AstNode* child : node->children)
			if (child->type == AST_WIRE || child->type == AST_MEMORY || child->type == AST_PARAMETER
				|| child->type == AST_LOCALPARAM || child->type == AST_TYPEDEF) {
			    node->str = "$unnamed_block$" + std::to_string(autoidx++);
			    break;
			}
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-6]), (yylsp[0]));
		delete (yyvsp[-4].string);
		delete (yyvsp[0].string);
		ast_stack.pop_back();
	}
#line 7059 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 547: /* $@62: %empty  */
#line 2781 "frontends/verilog/verilog_parser.y"
                         {
		AstNode *node = new AstNode(AST_FOR);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-2].al));
	}
#line 7070 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 548: /* $@63: %empty  */
#line 2786 "frontends/verilog/verilog_parser.y"
                                      {
		ast_stack.back()->children.push_back((yyvsp[0].ast));
	}
#line 7078 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 549: /* $@64: %empty  */
#line 2788 "frontends/verilog/verilog_parser.y"
                                         {
		AstNode *block = new AstNode(AST_BLOCK);
		block->str = "$for_loop$" + std::to_string(autoidx++);
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
	}
#line 7089 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 550: /* behavioral_stmt: attr TOK_FOR '(' $@62 for_initialization ';' expr $@63 ';' simple_behavioral_stmt ')' $@64 behavioral_stmt  */
#line 2793 "frontends/verilog/verilog_parser.y"
                          {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
		ast_stack.pop_back();
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-11]), (yylsp[0]));
		ast_stack.pop_back();
	}
#line 7100 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 551: /* $@65: %empty  */
#line 2799 "frontends/verilog/verilog_parser.y"
                                    {
		AstNode *node = new AstNode(AST_WHILE);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-4].al));
		AstNode *block = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back((yyvsp[-1].ast));
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
	}
#line 7115 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 552: /* behavioral_stmt: attr TOK_WHILE '(' expr ')' $@65 behavioral_stmt  */
#line 2808 "frontends/verilog/verilog_parser.y"
                          {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
		ast_stack.pop_back();
		ast_stack.pop_back();
	}
#line 7125 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 553: /* $@66: %empty  */
#line 2813 "frontends/verilog/verilog_parser.y"
                                     {
		AstNode *node = new AstNode(AST_REPEAT);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-4].al));
		AstNode *block = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back((yyvsp[-1].ast));
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
	}
#line 7140 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 554: /* behavioral_stmt: attr TOK_REPEAT '(' expr ')' $@66 behavioral_stmt  */
#line 2822 "frontends/verilog/verilog_parser.y"
                          {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
		ast_stack.pop_back();
		ast_stack.pop_back();
	}
#line 7150 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 555: /* $@67: %empty  */
#line 2827 "frontends/verilog/verilog_parser.y"
                                 {
		AstNode *node = new AstNode(AST_CASE);
		AstNode *block = new AstNode(AST_BLOCK);
		AstNode *cond = new AstNode(AST_COND, AstNode::mkconst_int(1, false, 1), block);
		SET_AST_NODE_LOC(cond, (yylsp[-1]), (yylsp[-1]));
		ast_stack.back()->children.push_back(node);
		node->children.push_back(new AstNode(AST_REDUCE_BOOL, (yyvsp[-1].ast)));
		node->children.push_back(cond);
		ast_stack.push_back(node);
		ast_stack.push_back(block);
		append_attr(node, (yyvsp[-4].al));
	}
#line 7167 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 556: /* $@68: %empty  */
#line 2838 "frontends/verilog/verilog_parser.y"
                          {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
	}
#line 7175 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 557: /* behavioral_stmt: attr TOK_IF '(' expr ')' $@67 behavioral_stmt $@68 optional_else  */
#line 2840 "frontends/verilog/verilog_parser.y"
                        {
		ast_stack.pop_back();
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-7]), (yylsp[0]));
		ast_stack.pop_back();
	}
#line 7185 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 558: /* $@69: %empty  */
#line 2845 "frontends/verilog/verilog_parser.y"
                                         {
		AstNode *node = new AstNode(AST_CASE, (yyvsp[-1].ast));
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		append_attr(node, (yyvsp[-4].al));
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-1]), (yylsp[-1]));
	}
#line 7197 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 559: /* behavioral_stmt: case_attr case_type '(' expr ')' $@69 opt_synopsys_attr case_body TOK_ENDCASE  */
#line 2851 "frontends/verilog/verilog_parser.y"
                                                  {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-7]), (yylsp[0]));
		case_type_stack.pop_back();
		ast_stack.pop_back();
	}
#line 7207 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 560: /* case_attr: attr  */
#line 2858 "frontends/verilog/verilog_parser.y"
             {
		(yyval.al) = (yyvsp[0].al);
	}
#line 7215 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 561: /* case_attr: attr TOK_UNIQUE0  */
#line 2861 "frontends/verilog/verilog_parser.y"
                         {
		(*(yyvsp[-1].al))[ID::parallel_case] = AstNode::mkconst_int(1, false);
		(yyval.al) = (yyvsp[-1].al);
	}
#line 7224 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 562: /* case_attr: attr TOK_PRIORITY  */
#line 2865 "frontends/verilog/verilog_parser.y"
                          {
		(*(yyvsp[-1].al))[ID::full_case] = AstNode::mkconst_int(1, false);
		(yyval.al) = (yyvsp[-1].al);
	}
#line 7233 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 563: /* case_attr: attr TOK_UNIQUE  */
#line 2869 "frontends/verilog/verilog_parser.y"
                        {
		(*(yyvsp[-1].al))[ID::full_case] = AstNode::mkconst_int(1, false);
		(*(yyvsp[-1].al))[ID::parallel_case] = AstNode::mkconst_int(1, false);
		(yyval.al) = (yyvsp[-1].al);
	}
#line 7243 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 564: /* case_type: TOK_CASE  */
#line 2876 "frontends/verilog/verilog_parser.y"
                 {
		case_type_stack.push_back(0);
	}
#line 7251 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 565: /* case_type: TOK_CASEX  */
#line 2879 "frontends/verilog/verilog_parser.y"
                  {
		case_type_stack.push_back('x');
	}
#line 7259 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 566: /* case_type: TOK_CASEZ  */
#line 2882 "frontends/verilog/verilog_parser.y"
                  {
		case_type_stack.push_back('z');
	}
#line 7267 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 567: /* opt_synopsys_attr: opt_synopsys_attr TOK_SYNOPSYS_FULL_CASE  */
#line 2887 "frontends/verilog/verilog_parser.y"
                                                 {
		if (ast_stack.back()->attributes.count(ID::full_case) == 0)
			ast_stack.back()->attributes[ID::full_case] = AstNode::mkconst_int(1, false);
	}
#line 7276 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 568: /* opt_synopsys_attr: opt_synopsys_attr TOK_SYNOPSYS_PARALLEL_CASE  */
#line 2891 "frontends/verilog/verilog_parser.y"
                                                     {
		if (ast_stack.back()->attributes.count(ID::parallel_case) == 0)
			ast_stack.back()->attributes[ID::parallel_case] = AstNode::mkconst_int(1, false);
	}
#line 7285 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 572: /* $@70: %empty  */
#line 2902 "frontends/verilog/verilog_parser.y"
                 {
		AstNode *block = new AstNode(AST_BLOCK);
		AstNode *cond = new AstNode(AST_COND, new AstNode(AST_DEFAULT), block);
		SET_AST_NODE_LOC(cond, (yylsp[0]), (yylsp[0]));

		ast_stack.pop_back();
		ast_stack.back()->children.push_back(cond);
		ast_stack.push_back(block);
	}
#line 7299 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 573: /* optional_else: TOK_ELSE $@70 behavioral_stmt  */
#line 2910 "frontends/verilog/verilog_parser.y"
                          {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
	}
#line 7307 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 577: /* $@71: %empty  */
#line 2920 "frontends/verilog/verilog_parser.y"
        {
		AstNode *node = new AstNode(
				case_type_stack.size() && case_type_stack.back() == 'x' ? AST_CONDX :
				case_type_stack.size() && case_type_stack.back() == 'z' ? AST_CONDZ : AST_COND);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 7319 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 578: /* $@72: %empty  */
#line 2926 "frontends/verilog/verilog_parser.y"
                      {
		AstNode *block = new AstNode(AST_BLOCK);
		ast_stack.back()->children.push_back(block);
		ast_stack.push_back(block);
		case_type_stack.push_back(0);
	}
#line 7330 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 579: /* case_item: $@71 case_select $@72 behavioral_stmt  */
#line 2931 "frontends/verilog/verilog_parser.y"
                          {
		case_type_stack.pop_back();
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
		ast_stack.pop_back();
		ast_stack.pop_back();
	}
#line 7341 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 582: /* $@73: %empty  */
#line 2943 "frontends/verilog/verilog_parser.y"
        {
		AstNode *node = new AstNode(
				case_type_stack.size() && case_type_stack.back() == 'x' ? AST_CONDX :
				case_type_stack.size() && case_type_stack.back() == 'z' ? AST_CONDZ : AST_COND);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 7353 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 583: /* $@74: %empty  */
#line 2949 "frontends/verilog/verilog_parser.y"
                      {
		case_type_stack.push_back(0);
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
	}
#line 7362 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 584: /* gen_case_item: $@73 case_select $@74 gen_stmt_block  */
#line 2952 "frontends/verilog/verilog_parser.y"
                         {
		case_type_stack.pop_back();
		ast_stack.pop_back();
	}
#line 7371 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 587: /* case_expr_list: TOK_DEFAULT  */
#line 2962 "frontends/verilog/verilog_parser.y"
                    {
		AstNode *node = new AstNode(AST_DEFAULT);
		SET_AST_NODE_LOC(node, (yylsp[0]), (yylsp[0]));
		ast_stack.back()->children.push_back(node);
	}
#line 7381 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 588: /* case_expr_list: TOK_SVA_LABEL  */
#line 2967 "frontends/verilog/verilog_parser.y"
                      {
		AstNode *node = new AstNode(AST_IDENTIFIER);
		SET_AST_NODE_LOC(node, (yylsp[0]), (yylsp[0]));
		ast_stack.back()->children.push_back(node);
		ast_stack.back()->children.back()->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 7393 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 589: /* case_expr_list: expr  */
#line 2974 "frontends/verilog/verilog_parser.y"
             {
		ast_stack.back()->children.push_back((yyvsp[0].ast));
	}
#line 7401 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 590: /* case_expr_list: case_expr_list ',' expr  */
#line 2977 "frontends/verilog/verilog_parser.y"
                                {
		ast_stack.back()->children.push_back((yyvsp[0].ast));
	}
#line 7409 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 591: /* rvalue: hierarchical_id '[' expr ']' '.' rvalue  */
#line 2982 "frontends/verilog/verilog_parser.y"
                                                {
		(yyval.ast) = new AstNode(AST_PREFIX, (yyvsp[-3].ast), (yyvsp[0].ast));
		(yyval.ast)->str = *(yyvsp[-5].string);
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-5]), (yylsp[0]));
		delete (yyvsp[-5].string);
	}
#line 7420 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 592: /* rvalue: hierarchical_id range  */
#line 2988 "frontends/verilog/verilog_parser.y"
                              {
		(yyval.ast) = new AstNode(AST_IDENTIFIER, (yyvsp[0].ast));
		(yyval.ast)->str = *(yyvsp[-1].string);
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-1]), (yylsp[-1]));
		delete (yyvsp[-1].string);
		if ((yyvsp[0].ast) == nullptr && ((yyval.ast)->str == "\\$initstate" ||
				(yyval.ast)->str == "\\$anyconst" || (yyval.ast)->str == "\\$anyseq" ||
				(yyval.ast)->str == "\\$allconst" || (yyval.ast)->str == "\\$allseq"))
			(yyval.ast)->type = AST_FCALL;
	}
#line 7435 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 593: /* rvalue: hierarchical_id non_opt_multirange  */
#line 2998 "frontends/verilog/verilog_parser.y"
                                           {
		(yyval.ast) = new AstNode(AST_IDENTIFIER, (yyvsp[0].ast));
		(yyval.ast)->str = *(yyvsp[-1].string);
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-1]), (yylsp[-1]));
		delete (yyvsp[-1].string);
	}
#line 7446 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 594: /* lvalue: rvalue  */
#line 3006 "frontends/verilog/verilog_parser.y"
               {
		(yyval.ast) = (yyvsp[0].ast);
	}
#line 7454 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 595: /* lvalue: '{' lvalue_concat_list '}'  */
#line 3009 "frontends/verilog/verilog_parser.y"
                                   {
		(yyval.ast) = (yyvsp[-1].ast);
	}
#line 7462 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 596: /* lvalue_concat_list: expr  */
#line 3014 "frontends/verilog/verilog_parser.y"
             {
		(yyval.ast) = new AstNode(AST_CONCAT);
		(yyval.ast)->children.push_back((yyvsp[0].ast));
	}
#line 7471 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 597: /* lvalue_concat_list: expr ',' lvalue_concat_list  */
#line 3018 "frontends/verilog/verilog_parser.y"
                                    {
		(yyval.ast) = (yyvsp[0].ast);
		(yyval.ast)->children.push_back((yyvsp[-2].ast));
	}
#line 7480 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 604: /* single_arg: expr  */
#line 3036 "frontends/verilog/verilog_parser.y"
             {
		ast_stack.back()->children.push_back((yyvsp[0].ast));
	}
#line 7488 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 610: /* gen_stmt_or_module_body_stmt: attr ';'  */
#line 3047 "frontends/verilog/verilog_parser.y"
                 {
		free_attr((yyvsp[-1].al));
	}
#line 7496 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 611: /* genvar_identifier: TOK_ID  */
#line 3052 "frontends/verilog/verilog_parser.y"
               {
		(yyval.ast) = new AstNode(AST_IDENTIFIER);
		(yyval.ast)->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
	}
#line 7506 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 612: /* genvar_initialization: TOK_GENVAR genvar_identifier  */
#line 3059 "frontends/verilog/verilog_parser.y"
                                     {
		frontend_verilog_yyerror("Generate for loop variable declaration is missing initialization!");
	}
#line 7514 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 613: /* genvar_initialization: TOK_GENVAR genvar_identifier '=' expr  */
#line 3062 "frontends/verilog/verilog_parser.y"
                                              {
		if (!sv_mode)
			frontend_verilog_yyerror("Generate for loop inline variable declaration is only supported in SystemVerilog mode!");
		AstNode *node = new AstNode(AST_GENVAR);
		node->is_reg = true;
		node->is_signed = true;
		node->range_left = 31;
		node->range_right = 0;
		node->str = (yyvsp[-2].ast)->str;
		node->children.push_back(checkRange(node, nullptr));
		ast_stack.back()->children.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-3]), (yylsp[0]));
		node = new AstNode(AST_ASSIGN_EQ, (yyvsp[-2].ast), (yyvsp[0].ast));
		ast_stack.back()->children.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-3]), (yylsp[0]));
	}
#line 7535 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 614: /* genvar_initialization: genvar_identifier '=' expr  */
#line 3078 "frontends/verilog/verilog_parser.y"
                                   {
		AstNode *node = new AstNode(AST_ASSIGN_EQ, (yyvsp[-2].ast), (yyvsp[0].ast));
		ast_stack.back()->children.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-2]), (yylsp[0]));
	}
#line 7545 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 615: /* $@75: %empty  */
#line 3086 "frontends/verilog/verilog_parser.y"
                    {
		AstNode *node = new AstNode(AST_GENFOR);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 7555 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 616: /* $@76: %empty  */
#line 3090 "frontends/verilog/verilog_parser.y"
                                         {
		ast_stack.back()->children.push_back((yyvsp[0].ast));
	}
#line 7563 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 617: /* gen_stmt: TOK_FOR '(' $@75 genvar_initialization ';' expr $@76 ';' simple_behavioral_stmt ')' gen_stmt_block  */
#line 3092 "frontends/verilog/verilog_parser.y"
                                                        {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-10]), (yylsp[0]));
		rewriteGenForDeclInit(ast_stack.back());
		ast_stack.pop_back();
	}
#line 7573 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 618: /* $@77: %empty  */
#line 3097 "frontends/verilog/verilog_parser.y"
                            {
		AstNode *node = new AstNode(AST_GENIF);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
		ast_stack.back()->children.push_back((yyvsp[-1].ast));
	}
#line 7584 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 619: /* gen_stmt: TOK_IF '(' expr ')' $@77 gen_stmt_block opt_gen_else  */
#line 3102 "frontends/verilog/verilog_parser.y"
                                      {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-6]), (yylsp[0]));
		ast_stack.pop_back();
	}
#line 7593 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 620: /* $@78: %empty  */
#line 3106 "frontends/verilog/verilog_parser.y"
                               {
		AstNode *node = new AstNode(AST_GENCASE, (yyvsp[-1].ast));
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 7603 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 621: /* gen_stmt: case_type '(' expr ')' $@78 gen_case_body TOK_ENDCASE  */
#line 3110 "frontends/verilog/verilog_parser.y"
                                    {
		case_type_stack.pop_back();
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-6]), (yylsp[0]));
		ast_stack.pop_back();
	}
#line 7613 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 622: /* $@79: %empty  */
#line 3115 "frontends/verilog/verilog_parser.y"
                      {
		AstNode *node = new AstNode(AST_TECALL);
		node->str = *(yyvsp[0].string);
		delete (yyvsp[0].string);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 7625 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 623: /* gen_stmt: TOK_MSG_TASKS $@79 opt_arg_list ';'  */
#line 3121 "frontends/verilog/verilog_parser.y"
                          {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-3]), (yylsp[-1]));
		ast_stack.pop_back();
	}
#line 7634 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 624: /* $@80: %empty  */
#line 3127 "frontends/verilog/verilog_parser.y"
                  {
		enterTypeScope();
	}
#line 7642 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 625: /* $@81: %empty  */
#line 3129 "frontends/verilog/verilog_parser.y"
                    {
		AstNode *node = new AstNode(AST_GENBLOCK);
		node->str = (yyvsp[0].string) ? *(yyvsp[0].string) : std::string();
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 7653 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 626: /* gen_block: TOK_BEGIN $@80 opt_label $@81 module_gen_body TOK_END opt_label  */
#line 3134 "frontends/verilog/verilog_parser.y"
                                            {
		exitTypeScope();
		checkLabelsMatch("Begin label", (yyvsp[-4].string), (yyvsp[0].string));
		delete (yyvsp[-4].string);
		delete (yyvsp[0].string);
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[-6]), (yylsp[0]));
		ast_stack.pop_back();
	}
#line 7666 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 627: /* $@82: %empty  */
#line 3145 "frontends/verilog/verilog_parser.y"
        {
		AstNode *node = new AstNode(AST_GENBLOCK);
		ast_stack.back()->children.push_back(node);
		ast_stack.push_back(node);
	}
#line 7676 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 628: /* gen_stmt_block: $@82 gen_stmt_or_module_body_stmt  */
#line 3149 "frontends/verilog/verilog_parser.y"
                                       {
		SET_AST_NODE_LOC(ast_stack.back(), (yylsp[0]), (yylsp[0]));
		ast_stack.pop_back();
	}
#line 7685 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 632: /* expr: basic_expr  */
#line 3158 "frontends/verilog/verilog_parser.y"
                   {
		(yyval.ast) = (yyvsp[0].ast);
	}
#line 7693 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 633: /* expr: basic_expr '?' attr expr ':' expr  */
#line 3161 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_TERNARY);
		(yyval.ast)->children.push_back((yyvsp[-5].ast));
		(yyval.ast)->children.push_back((yyvsp[-2].ast));
		(yyval.ast)->children.push_back((yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-5]), (yyloc));
		append_attr((yyval.ast), (yyvsp[-3].al));
	}
#line 7706 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 634: /* basic_expr: rvalue  */
#line 3171 "frontends/verilog/verilog_parser.y"
               {
		(yyval.ast) = (yyvsp[0].ast);
	}
#line 7714 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 635: /* basic_expr: '(' expr ')' integral_number  */
#line 3174 "frontends/verilog/verilog_parser.y"
                                     {
		if ((yyvsp[0].string)->compare(0, 1, "'") != 0)
			frontend_verilog_yyerror("Cast operation must be applied on sized constants e.g. (<expr>)<constval> , while %s is not a sized constant.", (yyvsp[0].string)->c_str());
		AstNode *bits = (yyvsp[-2].ast);
		AstNode *val = const2ast(*(yyvsp[0].string), case_type_stack.size() == 0 ? 0 : case_type_stack.back(), !lib_mode);
		if (val == NULL)
			log_error("Value conversion failed: `%s'\n", (yyvsp[0].string)->c_str());
		(yyval.ast) = new AstNode(AST_TO_BITS, bits, val);
		delete (yyvsp[0].string);
	}
#line 7729 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 636: /* basic_expr: hierarchical_id integral_number  */
#line 3184 "frontends/verilog/verilog_parser.y"
                                        {
		if ((yyvsp[0].string)->compare(0, 1, "'") != 0)
			frontend_verilog_yyerror("Cast operation must be applied on sized constants, e.g. <ID>\'d0, while %s is not a sized constant.", (yyvsp[0].string)->c_str());
		AstNode *bits = new AstNode(AST_IDENTIFIER);
		bits->str = *(yyvsp[-1].string);
		SET_AST_NODE_LOC(bits, (yylsp[-1]), (yylsp[-1]));
		AstNode *val = const2ast(*(yyvsp[0].string), case_type_stack.size() == 0 ? 0 : case_type_stack.back(), !lib_mode);
		SET_AST_NODE_LOC(val, (yylsp[0]), (yylsp[0]));
		if (val == NULL)
			log_error("Value conversion failed: `%s'\n", (yyvsp[0].string)->c_str());
		(yyval.ast) = new AstNode(AST_TO_BITS, bits, val);
		delete (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 7748 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 637: /* basic_expr: integral_number  */
#line 3198 "frontends/verilog/verilog_parser.y"
                        {
		(yyval.ast) = const2ast(*(yyvsp[0].string), case_type_stack.size() == 0 ? 0 : case_type_stack.back(), !lib_mode);
		SET_AST_NODE_LOC((yyval.ast), (yylsp[0]), (yylsp[0]));
		if ((yyval.ast) == NULL)
			log_error("Value conversion failed: `%s'\n", (yyvsp[0].string)->c_str());
		delete (yyvsp[0].string);
	}
#line 7760 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 638: /* basic_expr: TOK_REALVAL  */
#line 3205 "frontends/verilog/verilog_parser.y"
                    {
		(yyval.ast) = new AstNode(AST_REALVALUE);
		char *p = (char*)malloc(GetSize(*(yyvsp[0].string)) + 1), *q;
		for (int i = 0, j = 0; j < GetSize(*(yyvsp[0].string)); j++)
			if ((*(yyvsp[0].string))[j] != '_')
				p[i++] = (*(yyvsp[0].string))[j], p[i] = 0;
		(yyval.ast)->realvalue = strtod(p, &q);
		SET_AST_NODE_LOC((yyval.ast), (yylsp[0]), (yylsp[0]));
		log_assert(*q == 0);
		delete (yyvsp[0].string);
		free(p);
	}
#line 7777 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 639: /* basic_expr: TOK_STRING  */
#line 3217 "frontends/verilog/verilog_parser.y"
                   {
		(yyval.ast) = AstNode::mkconst_str(*(yyvsp[0].string));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[0]), (yylsp[0]));
		delete (yyvsp[0].string);
	}
#line 7787 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 640: /* $@83: %empty  */
#line 3222 "frontends/verilog/verilog_parser.y"
                             {
		AstNode *node = new AstNode(AST_FCALL);
		node->str = *(yyvsp[-1].string);
		delete (yyvsp[-1].string);
		ast_stack.push_back(node);
		SET_AST_NODE_LOC(node, (yylsp[-1]), (yylsp[-1]));
		append_attr(node, (yyvsp[0].al));
	}
#line 7800 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 641: /* basic_expr: hierarchical_id attr $@83 '(' arg_list optional_comma ')'  */
#line 3229 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = ast_stack.back();
		ast_stack.pop_back();
	}
#line 7809 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 642: /* basic_expr: TOK_TO_SIGNED attr '(' expr ')'  */
#line 3233 "frontends/verilog/verilog_parser.y"
                                        {
		(yyval.ast) = new AstNode(AST_TO_SIGNED, (yyvsp[-1].ast));
		append_attr((yyval.ast), (yyvsp[-3].al));
	}
#line 7818 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 643: /* basic_expr: TOK_TO_UNSIGNED attr '(' expr ')'  */
#line 3237 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_TO_UNSIGNED, (yyvsp[-1].ast));
		append_attr((yyval.ast), (yyvsp[-3].al));
	}
#line 7827 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 644: /* basic_expr: '(' expr ')'  */
#line 3241 "frontends/verilog/verilog_parser.y"
                     {
		(yyval.ast) = (yyvsp[-1].ast);
	}
#line 7835 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 645: /* basic_expr: '(' expr ':' expr ':' expr ')'  */
#line 3244 "frontends/verilog/verilog_parser.y"
                                       {
		delete (yyvsp[-5].ast);
		(yyval.ast) = (yyvsp[-3].ast);
		delete (yyvsp[-1].ast);
	}
#line 7845 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 646: /* basic_expr: '{' concat_list '}'  */
#line 3249 "frontends/verilog/verilog_parser.y"
                            {
		(yyval.ast) = (yyvsp[-1].ast);
	}
#line 7853 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 647: /* basic_expr: '{' expr '{' concat_list '}' '}'  */
#line 3252 "frontends/verilog/verilog_parser.y"
                                         {
		(yyval.ast) = new AstNode(AST_REPLICATE, (yyvsp[-4].ast), (yyvsp[-2].ast));
	}
#line 7861 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 648: /* basic_expr: '~' attr basic_expr  */
#line 3255 "frontends/verilog/verilog_parser.y"
                                            {
		(yyval.ast) = new AstNode(AST_BIT_NOT, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7871 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 649: /* basic_expr: basic_expr '&' attr basic_expr  */
#line 3260 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_BIT_AND, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7881 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 650: /* basic_expr: basic_expr OP_NAND attr basic_expr  */
#line 3265 "frontends/verilog/verilog_parser.y"
                                           {
		(yyval.ast) = new AstNode(AST_BIT_NOT, new AstNode(AST_BIT_AND, (yyvsp[-3].ast), (yyvsp[0].ast)));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7891 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 651: /* basic_expr: basic_expr '|' attr basic_expr  */
#line 3270 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_BIT_OR, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7901 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 652: /* basic_expr: basic_expr OP_NOR attr basic_expr  */
#line 3275 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_BIT_NOT, new AstNode(AST_BIT_OR, (yyvsp[-3].ast), (yyvsp[0].ast)));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7911 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 653: /* basic_expr: basic_expr '^' attr basic_expr  */
#line 3280 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_BIT_XOR, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7921 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 654: /* basic_expr: basic_expr OP_XNOR attr basic_expr  */
#line 3285 "frontends/verilog/verilog_parser.y"
                                           {
		(yyval.ast) = new AstNode(AST_BIT_XNOR, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7931 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 655: /* basic_expr: '&' attr basic_expr  */
#line 3290 "frontends/verilog/verilog_parser.y"
                                            {
		(yyval.ast) = new AstNode(AST_REDUCE_AND, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7941 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 656: /* basic_expr: OP_NAND attr basic_expr  */
#line 3295 "frontends/verilog/verilog_parser.y"
                                                {
		(yyval.ast) = new AstNode(AST_REDUCE_AND, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
		(yyval.ast) = new AstNode(AST_LOGIC_NOT, (yyval.ast));
	}
#line 7952 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 657: /* basic_expr: '|' attr basic_expr  */
#line 3301 "frontends/verilog/verilog_parser.y"
                                            {
		(yyval.ast) = new AstNode(AST_REDUCE_OR, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7962 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 658: /* basic_expr: OP_NOR attr basic_expr  */
#line 3306 "frontends/verilog/verilog_parser.y"
                                               {
		(yyval.ast) = new AstNode(AST_REDUCE_OR, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
		(yyval.ast) = new AstNode(AST_LOGIC_NOT, (yyval.ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
	}
#line 7974 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 659: /* basic_expr: '^' attr basic_expr  */
#line 3313 "frontends/verilog/verilog_parser.y"
                                            {
		(yyval.ast) = new AstNode(AST_REDUCE_XOR, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7984 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 660: /* basic_expr: OP_XNOR attr basic_expr  */
#line 3318 "frontends/verilog/verilog_parser.y"
                                                {
		(yyval.ast) = new AstNode(AST_REDUCE_XNOR, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 7994 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 661: /* basic_expr: basic_expr OP_SHL attr basic_expr  */
#line 3323 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_SHIFT_LEFT, (yyvsp[-3].ast), new AstNode(AST_TO_UNSIGNED, (yyvsp[0].ast)));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8004 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 662: /* basic_expr: basic_expr OP_SHR attr basic_expr  */
#line 3328 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_SHIFT_RIGHT, (yyvsp[-3].ast), new AstNode(AST_TO_UNSIGNED, (yyvsp[0].ast)));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8014 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 663: /* basic_expr: basic_expr OP_SSHL attr basic_expr  */
#line 3333 "frontends/verilog/verilog_parser.y"
                                           {
		(yyval.ast) = new AstNode(AST_SHIFT_SLEFT, (yyvsp[-3].ast), new AstNode(AST_TO_UNSIGNED, (yyvsp[0].ast)));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8024 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 664: /* basic_expr: basic_expr OP_SSHR attr basic_expr  */
#line 3338 "frontends/verilog/verilog_parser.y"
                                           {
		(yyval.ast) = new AstNode(AST_SHIFT_SRIGHT, (yyvsp[-3].ast), new AstNode(AST_TO_UNSIGNED, (yyvsp[0].ast)));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8034 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 665: /* basic_expr: basic_expr '<' attr basic_expr  */
#line 3343 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_LT, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8044 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 666: /* basic_expr: basic_expr OP_LE attr basic_expr  */
#line 3348 "frontends/verilog/verilog_parser.y"
                                         {
		(yyval.ast) = new AstNode(AST_LE, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8054 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 667: /* basic_expr: basic_expr OP_EQ attr basic_expr  */
#line 3353 "frontends/verilog/verilog_parser.y"
                                         {
		(yyval.ast) = new AstNode(AST_EQ, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8064 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 668: /* basic_expr: basic_expr OP_NE attr basic_expr  */
#line 3358 "frontends/verilog/verilog_parser.y"
                                         {
		(yyval.ast) = new AstNode(AST_NE, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8074 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 669: /* basic_expr: basic_expr OP_EQX attr basic_expr  */
#line 3363 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_EQX, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8084 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 670: /* basic_expr: basic_expr OP_NEX attr basic_expr  */
#line 3368 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_NEX, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8094 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 671: /* basic_expr: basic_expr OP_GE attr basic_expr  */
#line 3373 "frontends/verilog/verilog_parser.y"
                                         {
		(yyval.ast) = new AstNode(AST_GE, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8104 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 672: /* basic_expr: basic_expr '>' attr basic_expr  */
#line 3378 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_GT, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8114 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 673: /* basic_expr: basic_expr '+' attr basic_expr  */
#line 3383 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_ADD, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8124 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 674: /* basic_expr: basic_expr '-' attr basic_expr  */
#line 3388 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_SUB, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8134 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 675: /* basic_expr: basic_expr '*' attr basic_expr  */
#line 3393 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_MUL, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8144 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 676: /* basic_expr: basic_expr '/' attr basic_expr  */
#line 3398 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_DIV, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8154 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 677: /* basic_expr: basic_expr '%' attr basic_expr  */
#line 3403 "frontends/verilog/verilog_parser.y"
                                       {
		(yyval.ast) = new AstNode(AST_MOD, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8164 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 678: /* basic_expr: basic_expr OP_POW attr basic_expr  */
#line 3408 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_POW, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8174 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 679: /* basic_expr: '+' attr basic_expr  */
#line 3413 "frontends/verilog/verilog_parser.y"
                                            {
		(yyval.ast) = new AstNode(AST_POS, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8184 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 680: /* basic_expr: '-' attr basic_expr  */
#line 3418 "frontends/verilog/verilog_parser.y"
                                            {
		(yyval.ast) = new AstNode(AST_NEG, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8194 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 681: /* basic_expr: basic_expr OP_LAND attr basic_expr  */
#line 3423 "frontends/verilog/verilog_parser.y"
                                           {
		(yyval.ast) = new AstNode(AST_LOGIC_AND, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8204 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 682: /* basic_expr: basic_expr OP_LOR attr basic_expr  */
#line 3428 "frontends/verilog/verilog_parser.y"
                                          {
		(yyval.ast) = new AstNode(AST_LOGIC_OR, (yyvsp[-3].ast), (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-3]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8214 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 683: /* basic_expr: '!' attr basic_expr  */
#line 3433 "frontends/verilog/verilog_parser.y"
                                            {
		(yyval.ast) = new AstNode(AST_LOGIC_NOT, (yyvsp[0].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-2]), (yylsp[0]));
		append_attr((yyval.ast), (yyvsp[-1].al));
	}
#line 8224 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 684: /* basic_expr: TOK_SIGNED OP_CAST '(' expr ')'  */
#line 3438 "frontends/verilog/verilog_parser.y"
                                        {
		if (!sv_mode)
			frontend_verilog_yyerror("Static cast is only supported in SystemVerilog mode.");
		(yyval.ast) = new AstNode(AST_TO_SIGNED, (yyvsp[-1].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-4]), (yylsp[-1]));
	}
#line 8235 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 685: /* basic_expr: TOK_UNSIGNED OP_CAST '(' expr ')'  */
#line 3444 "frontends/verilog/verilog_parser.y"
                                          {
		if (!sv_mode)
			frontend_verilog_yyerror("Static cast is only supported in SystemVerilog mode.");
		(yyval.ast) = new AstNode(AST_TO_UNSIGNED, (yyvsp[-1].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-4]), (yylsp[-1]));
	}
#line 8246 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 686: /* basic_expr: basic_expr OP_CAST '(' expr ')'  */
#line 3450 "frontends/verilog/verilog_parser.y"
                                        {
		if (!sv_mode)
			frontend_verilog_yyerror("Static cast is only supported in SystemVerilog mode.");
		(yyval.ast) = new AstNode(AST_CAST_SIZE, (yyvsp[-4].ast), (yyvsp[-1].ast));
		SET_AST_NODE_LOC((yyval.ast), (yylsp[-4]), (yylsp[-1]));
	}
#line 8257 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 687: /* concat_list: expr  */
#line 3458 "frontends/verilog/verilog_parser.y"
             {
		(yyval.ast) = new AstNode(AST_CONCAT, (yyvsp[0].ast));
	}
#line 8265 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 688: /* concat_list: expr ',' concat_list  */
#line 3461 "frontends/verilog/verilog_parser.y"
                             {
		(yyval.ast) = (yyvsp[0].ast);
		(yyval.ast)->children.push_back((yyvsp[-2].ast));
	}
#line 8274 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 689: /* integral_number: TOK_CONSTVAL  */
#line 3467 "frontends/verilog/verilog_parser.y"
                     { (yyval.string) = (yyvsp[0].string); }
#line 8280 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 690: /* integral_number: TOK_UNBASED_UNSIZED_CONSTVAL  */
#line 3468 "frontends/verilog/verilog_parser.y"
                                     { (yyval.string) = (yyvsp[0].string); }
#line 8286 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 691: /* integral_number: TOK_BASE TOK_BASED_CONSTVAL  */
#line 3469 "frontends/verilog/verilog_parser.y"
                                    {
		(yyvsp[-1].string)->append(*(yyvsp[0].string));
		(yyval.string) = (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 8296 "frontends/verilog/verilog_parser.tab.cc"
    break;

  case 692: /* integral_number: TOK_CONSTVAL TOK_BASE TOK_BASED_CONSTVAL  */
#line 3474 "frontends/verilog/verilog_parser.y"
                                                 {
		(yyvsp[-2].string)->append(*(yyvsp[-1].string)).append(*(yyvsp[0].string));
		(yyval.string) = (yyvsp[-2].string);
		delete (yyvsp[-1].string);
		delete (yyvsp[0].string);
	}
#line 8307 "frontends/verilog/verilog_parser.tab.cc"
    break;


#line 8311 "frontends/verilog/verilog_parser.tab.cc"

        default: break;
      }
    if (yychar_backup != yychar)
      YY_LAC_DISCARD ("yychar change");
  }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == FRONTEND_VERILOG_YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yyesa, &yyes, &yyes_capacity, yytoken, &yylloc};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        if (yychar != FRONTEND_VERILOG_YYEMPTY)
          YY_LAC_ESTABLISH;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= FRONTEND_VERILOG_YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == FRONTEND_VERILOG_YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = FRONTEND_VERILOG_YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  /* If the stack popping above didn't lose the initial context for the
     current lookahead token, the shift below will for sure.  */
  YY_LAC_DISCARD ("error recovery");

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != FRONTEND_VERILOG_YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yyes != yyesa)
    YYSTACK_FREE (yyes);
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

